/*
 Navicat Premium Data Transfer

 Source Server         : test
 Source Server Type    : MySQL
 Source Server Version : 50731
 Source Host           : localhost:3306
 Source Schema         : reagent_managment

 Target Server Type    : MySQL
 Target Server Version : 50731
 File Encoding         : 65001

 Date: 25/04/2023 14:59:59
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for acceptance_record_form
-- ----------------------------
DROP TABLE IF EXISTS `acceptance_record_form`;
CREATE TABLE `acceptance_record_form`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `acceptance_conclusion` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(验收结论)',
  `audit_time_of_three_level` datetime(6) NULL DEFAULT NULL COMMENT '三级审核人审核时间',
  `date_of_acceptance` datetime(6) NULL DEFAULT NULL COMMENT '(验收日期)',
  `audit_opinion_of_three_level` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级审核人审核意见',
  `three_level_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级审核人ID',
  `follow_up_treatment` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(后续处理情况)',
  `nonconforming_item` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(不合格项目)',
  `audit_opinion_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核人审核意见',
  `primary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核人ID',
  `audit_time_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核人审核时间',
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `audit_opinion_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核人审核意见',
  `audit_time_of_secondary` datetime(6) NULL DEFAULT NULL COMMENT '(二级审核人审核日期)',
  `secondary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(二级审核人ID)',
  `audit_result_of_secondary` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '试剂耗材管理员审核结果',
  `audit_result_of_three_level` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级审核审核结果',
  `audit_result_of_primary` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(一级审核结果)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `the_same_brand_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `bam_remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `consistent_quantity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `cq_remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `packing_in_good_condition` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pgc_remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `validity_period` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `vp_remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `delivery_cycle` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `dc_remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` int(6) NULL DEFAULT NULL,
  `warehousing_content_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'user_name',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(验收记录表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of acceptance_record_form
-- ----------------------------
INSERT INTO `acceptance_record_form` VALUES ('13FCE22407CCC586F6EF1E5111D83B2C', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '0', '0', '0', '2023-04-18 15:19:44.977000', '2023-04-23 17:32:25.922000', '1', '1', '合格', '', '合格', '', '合格', NULL, '合格', '', '合格', '', '1', 1, NULL, '管理员');
INSERT INTO `acceptance_record_form` VALUES ('3CA16BCA35AAFA3799A82425A66B3F7B', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, NULL, '0', '0', '0', '2023-04-21 15:10:58.746000', '2023-04-21 15:10:58.746000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '0', NULL, '0', NULL, '0', NULL, '0', NULL, '0', NULL, '2DA79E5EA9BD6AC13D6BED4258B976EA', 0, NULL, NULL);
INSERT INTO `acceptance_record_form` VALUES ('90A7E86DE961D322D620DD0096E37461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '56BC02CC3C58F537A8289D142297A381', NULL, NULL, NULL, '0', '0', '0', '2023-04-21 17:17:23.971000', '2023-04-21 17:17:23.971000', '1', '1', '0', NULL, '0', NULL, '0', NULL, '0', NULL, '0', NULL, '80FA0C44E3A2846331CAD918A2D90F2D', 0, NULL, NULL);
INSERT INTO `acceptance_record_form` VALUES ('936070F7CD0CAAA7001D7470292D94B4', '验收合格', NULL, NULL, NULL, NULL, '无后续', '无不合格项目', '审核通过', '1', '2023-04-06 15:10:21.402', '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '0', '0', '1', '2023-04-06 14:46:15.808000', '2023-04-06 15:10:21.422000', '1', '1', '1', NULL, '1', NULL, '1', NULL, '1', NULL, '1', NULL, '1', 0, NULL, NULL);
INSERT INTO `acceptance_record_form` VALUES ('C4911EF36B4E37D79D83FFEE84951246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '0', '0', '0', '2023-04-18 15:19:44.974000', '2023-04-18 15:19:44.974000', '1', '1', '0', NULL, '0', NULL, '0', NULL, '0', NULL, '0', NULL, '1', 0, NULL, NULL);
INSERT INTO `acceptance_record_form` VALUES ('DE561C05F700ED925CE320ABFA03E5F2', '验收合格', NULL, NULL, NULL, NULL, '无后续', '无不合格项目', NULL, NULL, NULL, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '0', '0', '0', '2023-04-06 14:46:15.813000', '2023-04-06 14:56:15.285000', '1', '1', '1', '无', '1', '无', '1', NULL, '1', '无', '1', '无', '1', 0, NULL, NULL);
INSERT INTO `acceptance_record_form` VALUES ('E1081B769B37A22B9EF17854042F62C5', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, NULL, '0', '0', '0', '2023-04-21 17:36:20.022000', '2023-04-21 17:36:20.022000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '0', NULL, '0', NULL, '0', NULL, '0', NULL, '0', NULL, '80FA0C44E3A2846331CAD918A2D90F2D', 0, NULL, NULL);

-- ----------------------------
-- Table structure for application_for_use
-- ----------------------------
DROP TABLE IF EXISTS `application_for_use`;
CREATE TABLE `application_for_use`  (
  `date_of_collection` datetime(6) NULL DEFAULT NULL COMMENT '(领取日期)',
  `recipient_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(领用人ID)',
  `status` int(11) NULL DEFAULT NULL COMMENT '(状态)',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `delivery_registration_form_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `requisition_record_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `claim_code` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `IXFK_application_for_use_requisition_record`(`requisition_record_id`) USING BTREE,
  CONSTRAINT `FK_application_for_use_requisition_record` FOREIGN KEY (`requisition_record_id`) REFERENCES `requisition_record` (`requisition_record_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材领用申请表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of application_for_use
-- ----------------------------
INSERT INTO `application_for_use` VALUES ('2023-04-25 10:45:20.134000', 'C27B8F582693B93596C21C1586A0845A', 1, '0B48D3210DBDAF8FF53EF6C6D008EF00', NULL, NULL, '0185', '2023-04-25 10:45:20.123000', '2023-04-25 10:45:20.135000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A');
INSERT INTO `application_for_use` VALUES ('2023-04-25 11:50:16.133000', 'BC1A096180973C5EA652C9787F5A155A', 1, '132E48107248D2F52AA9BA626821B64D', '669E8592742B2F3940AAF63D5ECD3A46', NULL, '0281', '2023-04-25 11:50:15.464000', '2023-04-25 11:50:16.147000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A');
INSERT INTO `application_for_use` VALUES ('2023-04-25 10:45:15.964000', 'C27B8F582693B93596C21C1586A0845A', 1, '7A2F7ADBCB14B2D8AB3F5CD3D2CA87C1', NULL, NULL, '8538', '2023-04-25 10:45:15.942000', '2023-04-25 10:45:15.966000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A');
INSERT INTO `application_for_use` VALUES ('2023-04-25 10:46:17.299000', 'C27B8F582693B93596C21C1586A0845A', 1, 'A2098A185E57905E2A428FDC9BA13904', '3ECED6B92E56DE93B7983BAD76267226', NULL, '3359', '2023-04-25 10:46:17.289000', '2023-04-25 10:46:17.317000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A');
INSERT INTO `application_for_use` VALUES ('2023-04-25 11:48:33.792000', 'BC1A096180973C5EA652C9787F5A155A', 1, 'BA532FB9709EC95F179FCC1C1F6BF67F', '9D81188486079A4401A40B5056469DD5', NULL, '5161', '2023-04-25 11:48:33.783000', '2023-04-25 11:48:33.799000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A');
INSERT INTO `application_for_use` VALUES (NULL, 'BC1A096180973C5EA652C9787F5A155A', 0, 'C366668EE5E76C3AAD5C43DC399A7A32', NULL, NULL, NULL, '2023-04-25 11:50:26.900000', '2023-04-25 11:50:26.900000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A');

-- ----------------------------
-- Table structure for batch_details
-- ----------------------------
DROP TABLE IF EXISTS `batch_details`;
CREATE TABLE `batch_details`  (
  `batch` int(6) NULL DEFAULT NULL COMMENT '(批次)',
  `batch_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(批号)',
  `compliance_test_situation` tinyint(5) NULL DEFAULT NULL COMMENT '(符合性检验情况)',
  `date_of_last_check` datetime(6) NULL DEFAULT NULL COMMENT '(上次期间核查日期)',
  `date_of_production` datetime(0) NULL DEFAULT NULL COMMENT '(生产日期)',
  `deviation_or_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(偏差/不确定度)',
  `expiration_date` datetime(6) NULL DEFAULT NULL COMMENT '(有效日期)',
  `fixed_result` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(定值结果)',
  `purchase_time` datetime(6) NULL DEFAULT NULL COMMENT '(购置时间)',
  `quantity` int(11) NULL DEFAULT NULL COMMENT '(数量)',
  `reagent_consumable_inventory_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材库存ID)',
  `service_status` int(11) NULL DEFAULT NULL COMMENT '(使用状态)',
  `supplier_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商ID)',
  `warning_value` int(11) NULL DEFAULT NULL COMMENT '(预警值)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `batch_details_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `number` varchar(11) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warning_information` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`batch_details_id`) USING BTREE,
  INDEX `IXFK_batch_details_reagent_consumable_inventory`(`reagent_consumable_inventory_id`) USING BTREE,
  CONSTRAINT `FK_batch_details_reagent_consumable_inventory` FOREIGN KEY (`reagent_consumable_inventory_id`) REFERENCES `reagent_consumable_inventory` (`reagent_consumable_inventory_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '批次明细' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of batch_details
-- ----------------------------
INSERT INTO `batch_details` VALUES (2, '0002', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 14:43:42.201000', 10, 'D115879CEE645E5FF1522B473CCDBAC8', 1, '1', 3, '2023-04-06 14:43:42.176000', '2023-04-06 14:43:42.176000', '1', '1', '009BF6D5226B4C67CAEFFAAADA635BAF', NULL, NULL);
INSERT INTO `batch_details` VALUES (4, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 09:57:37.726000', 10, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-06 09:57:37.714000', '2023-04-06 09:57:37.714000', '1', '1', '0327F27E0974803039C0DA83FCB0F1D9', NULL, NULL);
INSERT INTO `batch_details` VALUES (6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:19.948000', 4, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 4, '2023-04-21 17:36:19.944000', '2023-04-21 17:36:19.944000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '044BC72726B54F6E515C5913462DDB12', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:03:02.271000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:03:02.257000', '2023-04-20 17:03:02.257000', '1', '1', '05984785FCBC31702F92593A61DAB8A2', NULL, NULL);
INSERT INTO `batch_details` VALUES (9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:19.979000', 23, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 3, '2023-04-21 17:36:19.976000', '2023-04-21 17:36:19.976000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '0971E6D9EB6293BF547B2E1D4BA026F7', NULL, NULL);
INSERT INTO `batch_details` VALUES (13, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.463000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.461000', '2023-04-21 09:15:03.461000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '0CFA605839BBABA919EC456F9B84089F', NULL, NULL);
INSERT INTO `batch_details` VALUES (7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:19.956000', 6, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 23, '2023-04-21 17:36:19.953000', '2023-04-21 17:36:19.953000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '12D8E3DC7C79CE5A4308FF9E69548CDC', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 10:14:32.145000', 3, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 65, '2023-04-21 10:14:32.135000', '2023-04-21 10:14:32.135000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '17C258BFB79DDCED5A2F950BADA7004A', NULL, NULL);
INSERT INTO `batch_details` VALUES (2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:18:37.419000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:18:37.398000', '2023-04-20 17:18:37.398000', '1', '1', '1DF17EC4DAB8E0645AC05B62885A6BD9', NULL, NULL);
INSERT INTO `batch_details` VALUES (5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:19.933000', 3, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 8, '2023-04-21 17:36:19.917000', '2023-04-21 17:36:19.917000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '237FE38E3ACD6003CC33FC69D743A0A6', NULL, NULL);
INSERT INTO `batch_details` VALUES (10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:19.988000', 4, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 34, '2023-04-21 17:36:19.984000', '2023-04-21 17:36:19.984000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '2E9DB04A6ACB0218681565C129476AC7', NULL, NULL);
INSERT INTO `batch_details` VALUES (6, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 09:59:58.113000', 5, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-06 09:59:58.108000', '2023-04-06 09:59:58.108000', '1', '1', '2FDCE43E87FF0B6EF61FEE9B897172C4', NULL, NULL);
INSERT INTO `batch_details` VALUES (2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 10:14:32.189000', 320, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 323, '2023-04-21 10:14:32.186000', '2023-04-21 10:14:32.186000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '35A44617B1CFB5722450DED4AE207056', NULL, NULL);
INSERT INTO `batch_details` VALUES (3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:18:37.479000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:18:37.475000', '2023-04-20 17:18:37.475000', '1', '1', '3DE55260E463EA774AA878B513D6715A', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, '0003', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-18 15:19:44.847000', 40, '972B49CE93F21DB67AB34ABE42F4BEDB', 1, '1', 3, '2023-04-18 15:19:44.842000', '2023-04-18 15:19:44.842000', '1', '1', '40A3E7A2D5945357ECA99B0BD283E16B', NULL, NULL);
INSERT INTO `batch_details` VALUES (8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:19.970000', 10, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 23, '2023-04-21 17:36:19.967000', '2023-04-21 17:36:19.967000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '473E71976CEE91D3A27EAD551A0778E1', NULL, NULL);
INSERT INTO `batch_details` VALUES (12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.427000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.425000', '2023-04-21 09:15:03.425000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '49887E55D8F3900CAF8A68817AC9B451', NULL, NULL);
INSERT INTO `batch_details` VALUES (3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 15:22:15.637000', 10, '8FA36752B25A66E2E934A3446CEC2039', 1, '1', 1, '2023-04-21 15:22:15.610000', '2023-04-21 15:22:15.610000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '49C526856D05C84B97715628A37F2431', NULL, NULL);
INSERT INTO `batch_details` VALUES (11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:20.000000', 5, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 54, '2023-04-21 17:36:19.997000', '2023-04-21 17:36:19.997000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '4B774EA7A478438AEBD8DA91EC2F2B41', NULL, NULL);
INSERT INTO `batch_details` VALUES (20, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.585000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.583000', '2023-04-21 09:42:34.583000', '1', '1', '57AC6E45617700170BA6AD71B11455BD', NULL, NULL);
INSERT INTO `batch_details` VALUES (3, '0002', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 14:45:40.356000', 10, 'D115879CEE645E5FF1522B473CCDBAC8', 1, '1', 3, '2023-04-06 14:45:40.352000', '2023-04-06 14:45:40.352000', '1', '1', '586A6FA3983E1E6E6ACFBD2F0007FF93', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 15:12:16.287000', 45, '88FF175C8ACCF8B710C000C386765866', 1, '1', 45, '2023-04-21 15:12:16.284000', '2023-04-21 15:12:16.284000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '5B307CF2ED7EB5620C04C224CBAE2F9B', NULL, NULL);
INSERT INTO `batch_details` VALUES (5, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 09:58:15.733000', 10, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-06 09:58:15.711000', '2023-04-06 09:58:15.711000', '1', '1', '60B967C0FC46C0A87939D3ABC0081BDC', NULL, NULL);
INSERT INTO `batch_details` VALUES (8, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.246000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.235000', '2023-04-21 09:15:03.235000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '6B59AE5F3A8E4AA0740C7A5E121E0016', NULL, NULL);
INSERT INTO `batch_details` VALUES (6, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:26:52.085000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:26:52.083000', '2023-04-20 17:26:52.083000', '1', '1', '77FE3ACBE4EFA25D08FFBC1A9CF6EABC', NULL, NULL);
INSERT INTO `batch_details` VALUES (9, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.314000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.311000', '2023-04-21 09:15:03.311000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '79DC80B12B85DE2EA18C704E421A0338', NULL, NULL);
INSERT INTO `batch_details` VALUES (28, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.826000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.824000', '2023-04-21 09:42:34.824000', '1', '1', '7BF8D95BDB55FC286F1F587F23C8D902', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-18 15:19:44.620000', 10, 'D115879CEE645E5FF1522B473CCDBAC8', 1, '1', 3, '2023-04-18 15:19:44.612000', '2023-04-18 15:19:44.612000', '1', '1', '89F2C2E220ADD12FD669670B738421A1', NULL, NULL);
INSERT INTO `batch_details` VALUES (4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 16:15:35.073000', 10, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 1, '2023-04-21 16:15:35.065000', '2023-04-21 16:15:35.065000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '8A687EF711C3101A0242633EA521E093', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 09:47:34.142000', 5, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-06 09:47:34.124000', '2023-04-06 09:47:34.124000', '1', '1', '96A6656686A216B359B8CB5D9583D7FF', NULL, NULL);
INSERT INTO `batch_details` VALUES (21, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.614000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.611000', '2023-04-21 09:42:34.611000', '1', '1', '971661BF6A8881AEA456C535B9EFEA97', NULL, NULL);
INSERT INTO `batch_details` VALUES (3, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 09:56:59.430000', 10, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-06 09:56:59.425000', '2023-04-06 09:56:59.425000', '1', '1', '9E911E8369580395CF7D1E5DE0FF8C65', NULL, NULL);
INSERT INTO `batch_details` VALUES (2, '0001', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 09:54:48.863000', 10, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-06 09:54:48.845000', '2023-04-06 09:54:48.845000', '1', '1', 'A382E16A1B91A9E374B3A447C1D1C4A5', NULL, NULL);
INSERT INTO `batch_details` VALUES (2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:17:23.756000', 55, '88FF175C8ACCF8B710C000C386765866', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 1, '2023-04-21 17:17:23.745000', '2023-04-21 17:17:23.745000', '1', '1', 'A44E2FED4822B19246C3A1A94B65DE88', NULL, NULL);
INSERT INTO `batch_details` VALUES (18, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.531000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.528000', '2023-04-21 09:42:34.528000', '1', '1', 'A4B42C4F9F22BF701AB4EF144056FB3F', NULL, NULL);
INSERT INTO `batch_details` VALUES (19, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.559000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.556000', '2023-04-21 09:42:34.556000', '1', '1', 'A78318D94F82D28F1E55A52AC0AD87AD', NULL, NULL);
INSERT INTO `batch_details` VALUES (17, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.501000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.498000', '2023-04-21 09:42:34.498000', '1', '1', 'A80DB572319EEF64EAF25D9D81D6773A', NULL, NULL);
INSERT INTO `batch_details` VALUES (23, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.670000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.667000', '2023-04-21 09:42:34.667000', '1', '1', 'A99FE2D800C14CBD644503EB9EC2FD6E', NULL, NULL);
INSERT INTO `batch_details` VALUES (22, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.640000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.638000', '2023-04-21 09:42:34.638000', '1', '1', 'B904FAD316B328C7044E74CD907613DF', NULL, NULL);
INSERT INTO `batch_details` VALUES (10, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.353000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.350000', '2023-04-21 09:15:03.350000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'B96D6EC4C9CC82FDAB8EA785B2340A06', NULL, NULL);
INSERT INTO `batch_details` VALUES (26, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.760000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.759000', '2023-04-21 09:42:34.759000', '1', '1', 'BB7587865584CC7140890D67A58AF849', NULL, NULL);
INSERT INTO `batch_details` VALUES (25, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.727000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.725000', '2023-04-21 09:42:34.725000', '1', '1', 'BF3D4AC18D760BE28CD315540FCAA7DB', NULL, NULL);
INSERT INTO `batch_details` VALUES (16, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.469000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.466000', '2023-04-21 09:42:34.466000', '1', '1', 'C02A334BC00312A92BDBE4C82C4E0515', NULL, NULL);
INSERT INTO `batch_details` VALUES (4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:26:52.035000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:26:52.020000', '2023-04-20 17:26:52.020000', '1', '1', 'C4E14875B97F95D7CB099A28AB64FCD5', NULL, NULL);
INSERT INTO `batch_details` VALUES (4, '0002', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-06 14:46:15.575000', 10, 'D115879CEE645E5FF1522B473CCDBAC8', 1, '1', 3, '2023-04-06 14:46:15.556000', '2023-04-06 14:46:15.556000', '1', '1', 'C75D289FAC0617D0A67A1993BB5D80B1', NULL, NULL);
INSERT INTO `batch_details` VALUES (24, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.698000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.696000', '2023-04-21 09:42:34.696000', '1', '1', 'C847CFFD30236390A4EE6143A06D71E2', NULL, NULL);
INSERT INTO `batch_details` VALUES (15, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.420000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.412000', '2023-04-21 09:42:34.412000', '1', '1', 'CA53A2F4FE5853D39CBFA193A131A498', NULL, NULL);
INSERT INTO `batch_details` VALUES (1, '0002', NULL, NULL, '2023-03-14 22:01:01', NULL, '2023-03-14 22:01:01.000000', NULL, '2023-04-18 15:19:44.674000', 50, 'E26E35A8363EA106453A87AF223A211B', 1, '1', 3, '2023-04-18 15:19:44.672000', '2023-04-18 15:19:44.672000', '1', '1', 'E03A32C0068F35672F5A46FB257DB786', NULL, NULL);
INSERT INTO `batch_details` VALUES (11, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.392000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.390000', '2023-04-21 09:15:03.390000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'E081C7D911A2240B7F466FDD8FA3CDD8', NULL, NULL);
INSERT INTO `batch_details` VALUES (12, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 17:36:20.008000', 5, '8FA36752B25A66E2E934A3446CEC2039', 1, '80FA0C44E3A2846331CAD918A2D90F2D', 55, '2023-04-21 17:36:20.005000', '2023-04-21 17:36:20.005000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'E182D8DFDAF5A86278C1BAA1630A7A39', NULL, NULL);
INSERT INTO `batch_details` VALUES (14, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:15:03.498000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:15:03.496000', '2023-04-21 09:15:03.496000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'E20CE9447C6344E7AB22CE9EB836B13A', NULL, NULL);
INSERT INTO `batch_details` VALUES (27, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-21 09:42:34.795000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-21 09:42:34.792000', '2023-04-21 09:42:34.792000', '1', '1', 'E77C68A13D7170A7BA768361C5922A1A', NULL, NULL);
INSERT INTO `batch_details` VALUES (5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:26:52.063000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:26:52.061000', '2023-04-20 17:26:52.061000', '1', '1', 'F2C4B6B7360497FD588601FBD0A91A82', NULL, NULL);
INSERT INTO `batch_details` VALUES (7, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-20 17:26:52.113000', 10, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC', 1, '1', 10, '2023-04-20 17:26:52.110000', '2023-04-20 17:26:52.110000', '1', '1', 'FE0C05B843B5C17F4A484CF3B92236FC', NULL, NULL);

-- ----------------------------
-- Table structure for blacklist
-- ----------------------------
DROP TABLE IF EXISTS `blacklist`;
CREATE TABLE `blacklist`  (
  `reagent_consumable_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `results_of_compliance_check` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(符合性检查结果)',
  `supplier_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商ID)',
  `blacklist_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `compliance_check_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  PRIMARY KEY (`blacklist_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材黑名单)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of blacklist
-- ----------------------------
INSERT INTO `blacklist` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '0', '1', '202304211820025421649357316736077825', NULL, '2023-04-21 18:20:02.543000', '2023-04-21 18:20:02.543000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A');
INSERT INTO `blacklist` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '0', '1', '202304231010128261649958823063900161', NULL, '2023-04-23 10:10:12.838000', '2023-04-23 10:10:12.838000', '1', '1');

-- ----------------------------
-- Table structure for cabinet_form
-- ----------------------------
DROP TABLE IF EXISTS `cabinet_form`;
CREATE TABLE `cabinet_form`  (
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `storage_room_form_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `specification` int(255) NULL DEFAULT NULL,
  `status` int(6) NULL DEFAULT NULL,
  `picture` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of cabinet_form
-- ----------------------------
INSERT INTO `cabinet_form` VALUES ('1', '1', '测试柜', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for catalogue_details
-- ----------------------------
DROP TABLE IF EXISTS `catalogue_details`;
CREATE TABLE `catalogue_details`  (
  `brand` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(品牌)',
  `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(类别)',
  `deviation_or_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '偏差/不确定度',
  `packaged_copies` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '包装份数',
  `purchase_catalogue_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '采购目录ID',
  `purchase_catalogue_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(采购目录编号)',
  `reagent_consumable_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '试剂耗材名称',
  `species` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(种类)',
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(规格型号)',
  `standard_value_or_purity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准值/纯度)',
  `unit_price` double(10, 2) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '单价',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `catalogue_details_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `english_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '别名',
  `storage_condition` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '存储条件',
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注\r\n',
  `minimum_unit` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`catalogue_details_id`) USING BTREE,
  INDEX `IXFK_catalogue_details_purchase_catalogue`(`purchase_catalogue_id`) USING BTREE,
  CONSTRAINT `FK_catalogue_details_purchase_catalogue` FOREIGN KEY (`purchase_catalogue_id`) REFERENCES `purchase_catalogue` (`purchase_catalogue_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(采购目录明细)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of catalogue_details
-- ----------------------------
INSERT INTO `catalogue_details` VALUES ('bd', '标准物质', NULL, '434', '59B41C115F9906393320FE4D5760053A', NULL, '冰毒2', '一般标准物质', 'bd', '65%', 0000434.00, '2023-04-18 10:42:48.578000', '2023-04-18 10:42:48.578000', '1', '1', '008412a04bcc21b9d66d19563eccbacd', 'db', NULL, 'bd', '冷藏贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('yyy', '标准物质', NULL, '45', '564E236AFA6BA1EF7E9C28F927BFB13D', NULL, '摇头丸4', '一般标准物质', 'yyy', '67%', 0000545.00, '2023-04-18 10:22:55.589000', '2023-04-18 10:22:55.589000', '1', '1', '01193a55aafa6c75519460937a92cfff', 'yyy', NULL, 'yyy', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('22', '试剂', NULL, '22', '59B41C115F9906393320FE4D5760053A', '1', '222', '酒精', '22', '22', 0000022.00, '2023-04-18 09:49:33.037000', '2023-04-18 09:49:33.037000', '1', '1', '08C43B71952B63AB20EC2B47CE2F66F1', '22', NULL, '22', '常规贮存', '222', '盒');
INSERT INTO `catalogue_details` VALUES ('dama', '标准物质', NULL, '564', '769B6D8D7A54F4595A06745F25706169', NULL, '大麻2', '一般标准物质', 'dada', '56%', 0000045.00, '2023-04-18 10:26:32.422000', '2023-04-18 11:30:05.609000', '1', '1', '4736fb527e00c14d903c7ce2b1b41a06', 'dama', 'E394DF6CB798A925D4C79F51544E1A73', 'dama', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('22', '试剂', NULL, '22', '769B6D8D7A54F4595A06745F25706169', '1', '222', '酒精', '22', '22', 0000022.00, '2023-04-18 09:54:38.616000', '2023-04-18 11:30:05.617000', '1', '1', '6741963791AFDF6B5957C1B6D87DCA31', '22', '4DC0DFAD80856851F5484282EAFC54ED', '22', '常规贮存', '222', '盒');
INSERT INTO `catalogue_details` VALUES ('yyy', '标准物质', NULL, '24', '564E236AFA6BA1EF7E9C28F927BFB13D', NULL, '摇头丸5', '一般标准物质', 'hhh', '56%', 0000043.00, '2023-04-18 10:23:53.750000', '2023-04-18 10:24:03.137000', '1', '1', '78e506fbf00d377ab16f75b5b46df5e9', 'yh', NULL, 'yy', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('bd', '标准物质', NULL, '232', '59B41C115F9906393320FE4D5760053A', NULL, '冰毒', '一般标准物质', 'bd', 'bd', 0000323.00, '2023-04-18 10:43:38.367000', '2023-04-18 10:43:38.367000', '1', '1', '87a706660db3f55c9961ce540da3685a', 'bd', NULL, 'bd', '冷藏贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('da', '标准物质', NULL, '54', '769B6D8D7A54F4595A06745F25706169', NULL, '大麻3', '一般标准物质', 'ma', '76%', 0000045.00, '2023-04-18 10:27:24.101000', '2023-04-18 11:30:05.619000', '1', '1', '8f9af522b4bb8a2400a1ef99a27053e6', 'ma', '68D2DBC2AF35C0CEB4E67B6B2977AD61', 'ma', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('222', '耗材', NULL, '34', '564E236AFA6BA1EF7E9C28F927BFB13D', NULL, '摇头丸', '木材', '22', '22%', 0000043.00, '2023-04-18 10:21:19.649000', '2023-04-18 10:21:19.649000', '1', '1', '90f51fa2e5af76c1c56a8b73569d5568', 'fdf', NULL, '222', '常规贮存', NULL, '箱');
INSERT INTO `catalogue_details` VALUES ('da', '标准物质', NULL, '2343', '769B6D8D7A54F4595A06745F25706169', NULL, '大麻', '一般标准物质', 'da', '56%', 0003443.00, '2023-04-18 10:40:34.056000', '2023-04-18 11:30:05.621000', '1', '1', 'a0f3bcc38bf2681e830d9bea6a23c2b6', 'da', 'A3D7E4D4A19169E664FFF0698A4CF8AD', 'da', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('hhh', '标准物质', NULL, '323', '564E236AFA6BA1EF7E9C28F927BFB13D', NULL, '摇头丸2', '一般标准物质', 'hhh', '33%', 0000023.00, '2023-04-18 10:22:12.022000', '2023-04-18 10:22:12.022000', '1', '1', 'a536b921bc685e8817e9e7d72087c82c', 'hhh', NULL, 'hhh', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('22', '试剂', NULL, '22', 'F897538730C1722798970643884807FF', '1', '222', '酒精', '22', '22', 0000022.00, '2023-04-18 09:54:23.428000', '2023-04-18 09:54:23.428000', '1', '1', 'BBCE1B03079334B70D91082D417E01F1', '22', NULL, '22', '常规贮存', '222', '盒');
INSERT INTO `catalogue_details` VALUES ('bd', '标准物质', NULL, '23', '59B41C115F9906393320FE4D5760053A', NULL, '冰毒4', '一般标准物质', 'bd', '100%', 0000323.00, '2023-04-18 10:44:32.304000', '2023-04-18 10:44:32.304000', '1', '1', 'bc23e6294d2f5313f04f822b8e3cb3d6', 'bd', NULL, 'bd', '冷藏贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('dada', '标准物质', NULL, '23', '769B6D8D7A54F4595A06745F25706169', NULL, '大麻1', '一般标准物质', 'dada', '67%', 0000032.00, '2023-04-18 10:25:36.994000', '2023-04-18 11:30:05.623000', '1', '1', 'c8bdf45a90db09bae72693d76008994f', 'dada', '56BC02CC3C58F537A8289D142297A381', 'dada', '常规贮存', NULL, '盒');
INSERT INTO `catalogue_details` VALUES ('34', '耗材', '34%', '34', '564E236AFA6BA1EF7E9C28F927BFB13D', NULL, '耗材222', '钢材', '34', '34%', 0000023.00, '2023-04-18 10:01:40.520000', '2023-04-18 10:01:40.520000', '1', '1', 'E6354BA84571CC34A22DB72BCBF2BF18', '4', NULL, '34', '常规贮存', '23', '盒');

-- ----------------------------
-- Table structure for category_table
-- ----------------------------
DROP TABLE IF EXISTS `category_table`;
CREATE TABLE `category_table`  (
  `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `species` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of category_table
-- ----------------------------
INSERT INTO `category_table` VALUES ('耗材', '1', '木材', NULL, NULL, NULL, NULL);
INSERT INTO `category_table` VALUES ('试剂', '2', '酒精', NULL, NULL, NULL, NULL);
INSERT INTO `category_table` VALUES ('标准物质', '3', '海洛因', NULL, NULL, NULL, NULL);
INSERT INTO `category_table` VALUES ('标准储备溶液', '4', 'k粉', NULL, NULL, NULL, NULL);
INSERT INTO `category_table` VALUES ('耗材', '5', '钢材', NULL, NULL, NULL, NULL);
INSERT INTO `category_table` VALUES ('耗材', 'C2D52AFE372558AD363E6664999CDF6F', '碳钢', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-12 11:21:16.379000', '2023-04-12 11:21:16.379000');
INSERT INTO `category_table` VALUES ('标准物质', 'DA63F4F987495FED969E23F72AB83AE0', '一般标准物质', '1', '1', '2023-04-13 14:52:00.796000', '2023-04-13 14:52:00.796000');

-- ----------------------------
-- Table structure for centralized_request
-- ----------------------------
DROP TABLE IF EXISTS `centralized_request`;
CREATE TABLE `centralized_request`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `applicant_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(申请人ID)',
  `date_of_application` datetime(6) NULL DEFAULT NULL COMMENT '(申请日期)',
  `purchasing_plan_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '采购计划ID',
  `status` int(11) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '(状态)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `applicant_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `department` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(集中采购申请)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of centralized_request
-- ----------------------------
INSERT INTO `centralized_request` VALUES ('094BAE1CC0E7463F2FDE120CA4778F96', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 14:55:35.340000', NULL, 00000000002, '2023-04-19 14:55:35.340000', '2023-04-19 14:55:41.641000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, '员工审核员1', NULL);
INSERT INTO `centralized_request` VALUES ('0CC7699DDD34112A95E610A10389C369', '1', '2023-04-20 10:01:28.181000', NULL, 00000000000, '2023-04-20 10:01:28.184000', '2023-04-20 10:01:28.184000', '1', '1', NULL, '管理员', NULL);
INSERT INTO `centralized_request` VALUES ('1AFD4AE1546D2802CF3168F16A333AC6', 'C27B8F582693B93596C21C1586A0845A', '2023-04-19 16:20:55.713000', NULL, 00000000002, '2023-04-19 16:20:55.720000', '2023-04-19 16:21:35.101000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, '审核员2', NULL);
INSERT INTO `centralized_request` VALUES ('28EB341C0E02F66F6A8F79298A3EC0F3', '1', '2023-04-21 14:57:36.964000', NULL, 00000000002, '2023-04-21 14:57:36.968000', '2023-04-21 14:57:47.807000', '1', '1', NULL, '管理员', NULL);
INSERT INTO `centralized_request` VALUES ('333DE0540D7E21A0E411685017A914CA', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 17:42:50.979000', NULL, 00000000001, '2023-04-19 17:42:50.982000', '2023-04-19 17:42:50.993000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, '员工审核员1', NULL);
INSERT INTO `centralized_request` VALUES ('3A19590D8F6CC22E70DD32CECA767E12', '1', '2023-04-19 12:00:38.712000', NULL, 00000000002, '2023-04-19 12:00:38.718000', '2023-04-19 12:00:58.737000', '1', '1', NULL, '管理员', NULL);
INSERT INTO `centralized_request` VALUES ('410DC1267176F7489FD91D98095C2F3D', '1', '2023-04-19 16:44:49.679000', NULL, 00000000000, '2023-04-19 16:44:49.680000', '2023-04-19 16:44:49.680000', '1', '1', NULL, '管理员', NULL);
INSERT INTO `centralized_request` VALUES ('6DC74FA4AF6CE1DB595D348E6932C3C2', 'C27B8F582693B93596C21C1586A0845A', '2023-04-19 16:21:13.395000', NULL, 00000000002, '2023-04-19 16:21:13.395000', '2023-04-19 16:21:35.109000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, '审核员2', NULL);
INSERT INTO `centralized_request` VALUES ('BE16796A40D2EB93F0F9C644698D3DFA', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 14:47:30.098000', NULL, 00000000002, '2023-04-19 14:47:30.099000', '2023-04-19 14:50:30.443000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, '员工审核员1', NULL);
INSERT INTO `centralized_request` VALUES ('D3B01D55369179CF684E94DAA8D76CC5', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 15:00:05.665000', NULL, 00000000002, '2023-04-19 15:00:05.665000', '2023-04-19 15:00:27.534000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, '员工审核员1', NULL);
INSERT INTO `centralized_request` VALUES ('D85DEB32F1D0BA4C6E7957EDBFA12427', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 14:52:36.300000', NULL, 00000000002, '2023-04-19 14:52:36.300000', '2023-04-19 14:52:56.773000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, '员工审核员1', NULL);
INSERT INTO `centralized_request` VALUES ('E496D316D0E70B08C4D5AE64B3A9248F', '1', '2023-04-19 12:00:45.761000', NULL, 00000000002, '2023-04-19 12:00:45.762000', '2023-04-19 12:00:58.745000', '1', '1', NULL, '管理员', NULL);
INSERT INTO `centralized_request` VALUES ('F19E3CEFA6698E0FBB8059EDAB27FA1A', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 15:04:36.119000', NULL, 00000000002, '2023-04-19 15:04:36.119000', '2023-04-19 15:05:10.632000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, '员工审核员1', NULL);
INSERT INTO `centralized_request` VALUES ('FB9AA2FCF3F2EA24B04F68DDF16C5D4F', 'BC1A096180973C5EA652C9787F5A155A', '2023-04-19 15:32:33.700000', NULL, 00000000002, '2023-04-19 15:32:33.701000', '2023-04-19 16:21:35.113000', 'BC1A096180973C5EA652C9787F5A155A', 'C27B8F582693B93596C21C1586A0845A', NULL, '员工审核员1', NULL);

-- ----------------------------
-- Table structure for check_schedule
-- ----------------------------
DROP TABLE IF EXISTS `check_schedule`;
CREATE TABLE `check_schedule`  (
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `manager_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `audit_time_of_technical` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `audit_result_of_technical` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `audit_opinion_of_technical` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `technical_director_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of check_schedule
-- ----------------------------
INSERT INTO `check_schedule` VALUES (NULL, '1', NULL, '0', NULL, '52F2BA565CEF882A8EE03C9127E19BD7', '2023-04-24 16:56:10.675000', '2023-04-24 16:56:10.675000', '1', '1', NULL, '0');
INSERT INTO `check_schedule` VALUES (NULL, '1', '2023-04-10 14:54:41.848', '1', '审核通过', 'B8BE49FB3D4ABCBB459EFD4FC5B154B0', '2023-04-10 14:52:26.161000', '2023-04-10 14:54:41.848000', '1', '1', '1', '2');

-- ----------------------------
-- Table structure for compliance_check
-- ----------------------------
DROP TABLE IF EXISTS `compliance_check`;
CREATE TABLE `compliance_check`  (
  `batch_details_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `audit_opinion_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核意见',
  `audit_opinion_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核意见',
  `audit_result_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核结果',
  `audit_result_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核结果',
  `audit_time_of_primary` datetime(6) NULL DEFAULT NULL COMMENT '一级审核时间',
  `audit_time_of_secondary` datetime(6) NULL DEFAULT NULL COMMENT '二级审核时间',
  `date_of_inspection` datetime(6) NULL DEFAULT NULL COMMENT '(检查日期)',
  `examination_conclusion` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(检查结论)',
  `primary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核人ID',
  `inspection_scheme` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(检查方案)',
  `status` int(11) NULL DEFAULT NULL COMMENT '(状态)',
  `secondary_auditor_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核人ID',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reagent_consumable_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `nonconforming_item` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `brand` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `executor_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(符合性检查记录表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of compliance_check
-- ----------------------------
INSERT INTO `compliance_check` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '043409DEF8FA00D50D0E02318807FE31', '2023-04-25 10:30:36.696000', '2023-04-25 10:30:36.696000', '1', '1', NULL, 'dama-2023-1-100', 'dada', NULL, 'dama', 'E394DF6CB798A925D4C79F51544E1A73', NULL);
INSERT INTO `compliance_check` VALUES ('5B307CF2ED7EB5620C04C224CBAE2F9B', NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-23 09:56:11.019000', '测试结论', NULL, '测试', 2, NULL, '627F735D0D17E3324D73891DB8BC0BA0', '2023-04-23 09:55:33.194000', '2023-04-23 10:10:29.774000', '1', 'BC1A096180973C5EA652C9787F5A155A', NULL, 'dada-2023-1-038', 'dada', NULL, 'dada', '56BC02CC3C58F537A8289D142297A381', '1');
INSERT INTO `compliance_check` VALUES ('35A44617B1CFB5722450DED4AE207056', NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-23 09:57:23.523000', '23123', NULL, '123123', 2, NULL, '6F05A00D81AFA9731A48A567A33A0575', '2023-04-23 09:55:33.189000', '2023-04-23 10:10:12.855000', '1', '1', NULL, 'dama-2023-1-100', 'dada', '123123', 'dama', 'E394DF6CB798A925D4C79F51544E1A73', 'BC1A096180973C5EA652C9787F5A155A');
INSERT INTO `compliance_check` VALUES ('044BC72726B54F6E515C5913462DDB12', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '9E91EAA6262DA1A4971D29475D1778AA', '2023-04-23 09:55:33.185000', '2023-04-23 09:55:33.185000', '1', '1', NULL, NULL, '22', NULL, '22', '4DC0DFAD80856851F5484282EAFC54ED', NULL);

-- ----------------------------
-- Table structure for deactivation_application
-- ----------------------------
DROP TABLE IF EXISTS `deactivation_application`;
CREATE TABLE `deactivation_application`  (
  `applicant_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(申请人ID)',
  `application_time` datetime(0) NULL DEFAULT NULL COMMENT '(申请时间)',
  `reference_material_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质ID)',
  `reference_material_number` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质编号)',
  `deactivation_application_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  PRIMARY KEY (`deactivation_application_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准物质到期停用申请表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of deactivation_application
-- ----------------------------

-- ----------------------------
-- Table structure for decentralize_details
-- ----------------------------
DROP TABLE IF EXISTS `decentralize_details`;
CREATE TABLE `decentralize_details`  (
  `brand` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(品牌)',
  `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(类别)',
  `decentralized_request_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(分散采购申请ID)',
  `deviation_or_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '偏差/不确定度',
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `packaged_copies` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '包装份数',
  `quantity` int(10) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '(数量)',
  `reagent_consumable_Id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `species` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(种类)',
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(规格型号)',
  `standard_value_or_purity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准值/纯度)',
  `technical_parameter` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术参数)',
  `unit_price` double(10, 2) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '单价',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `purpose` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(用途)',
  `english_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `storage_condition` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `minimum_unit` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reagent_consumable_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '分散采购申请明细' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of decentralize_details
-- ----------------------------
INSERT INTO `decentralize_details` VALUES ('22', '试剂', '2D8945BBE5FD9518D312C30436A5B396', NULL, '329949ffefb5e6abfe5f365a566a938c', '22', 0000002343, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 14:21:11.988000', '2023-04-18 14:21:11.988000', '1', '1', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('da', '标准物质', '8B10B242E667D55264246D7607C8C81E', NULL, '4D5171A4A31432844D44C8D5F7FA2617', '2343', 0000000323, 'A3D7E4D4A19169E664FFF0698A4CF8AD', '一般标准物质', 'da', '56%', NULL, 0003443.00, '2023-04-18 15:46:25.411000', '2023-04-18 15:46:25.411000', '1', '1', NULL, 'da', 'da', '常规贮存', NULL, '盒', '大麻');
INSERT INTO `decentralize_details` VALUES ('22', '试剂', 'DD86CB5FAB1D5B04383D9F2BE1C71EF4', NULL, '5357EF8A171AACC6A92EDF20750E9367', '22', NULL, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 15:58:58.826000', '2023-04-18 15:58:58.826000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('22', '试剂', '6B991C99FF977F40863803EC967E5033', NULL, '539CF7C2EBA2E8EC4C5B2F0E752DFFBD', '22', 0000000023, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 14:18:09.391000', '2023-04-18 14:18:09.391000', '1', '1', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('22', '试剂', '063783222E28EC15CCE0D9E2D663151E', NULL, '5564613F12BB70E23BB89945CD5991C3', '22', 0000002343, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 14:21:33.652000', '2023-04-18 14:21:33.652000', '1', '1', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('22', '试剂', 'B010F399D64BA7B13843CD294D93FAEC', NULL, '5DFB4760CC8582FDC18CAD7C8C349D20', '22', 0000000023, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 14:17:36.492000', '2023-04-18 14:17:36.492000', '1', '1', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('da', '标准物质', 'B010F399D64BA7B13843CD294D93FAEC', NULL, '7A9C5689E3214762ED25040A31606EE9', '54', 0000000434, '68D2DBC2AF35C0CEB4E67B6B2977AD61', '一般标准物质', 'ma', '76%', NULL, 0000045.00, '2023-04-18 14:17:36.490000', '2023-04-18 14:17:36.490000', '1', '1', NULL, 'ma', 'ma', '常规贮存', NULL, '盒', '大麻3');
INSERT INTO `decentralize_details` VALUES ('dama', '标准物质', 'DD86CB5FAB1D5B04383D9F2BE1C71EF4', NULL, '8296F43030D1CB0F254DDB7567589DAB', '564', NULL, 'E394DF6CB798A925D4C79F51544E1A73', '一般标准物质', 'dada', '56%', NULL, 0000045.00, '2023-04-18 15:58:58.825000', '2023-04-18 15:58:58.825000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, 'dama', 'dama', '常规贮存', NULL, '盒', '大麻2');
INSERT INTO `decentralize_details` VALUES ('da', '标准物质', '6B3E5F185DDED532CE04378A1F5C539C', NULL, '8986BAA7B1F17314E57108FE96909EA7', '54', 0000000434, '68D2DBC2AF35C0CEB4E67B6B2977AD61', '一般标准物质', 'ma', '76%', NULL, 0000045.00, '2023-04-18 14:18:26.554000', '2023-04-18 14:18:26.554000', '1', '1', NULL, 'ma', 'ma', '常规贮存', NULL, '盒', '大麻3');
INSERT INTO `decentralize_details` VALUES ('22', '试剂', '7E63C540FDDE7D5F647B77DA13BBD0BC', NULL, 'BC03AF3BB7D5894AB912E1EB94D6C649', '22', 0000000023, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 14:18:53.394000', '2023-04-18 14:18:53.394000', '1', '1', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('da', '标准物质', '6B991C99FF977F40863803EC967E5033', NULL, 'BE573F8DDA59164CBB4BEE7256208D2F', '54', 0000000434, '68D2DBC2AF35C0CEB4E67B6B2977AD61', '一般标准物质', 'ma', '76%', NULL, 0000045.00, '2023-04-18 14:18:09.390000', '2023-04-18 14:18:09.390000', '1', '1', NULL, 'ma', 'ma', '常规贮存', NULL, '盒', '大麻3');
INSERT INTO `decentralize_details` VALUES ('22', '试剂', '6B3E5F185DDED532CE04378A1F5C539C', NULL, 'DFF140EC8FF5AE5EAE085F19E82D5C21', '22', 0000000023, '4DC0DFAD80856851F5484282EAFC54ED', '酒精', '22', '22', NULL, 0000022.00, '2023-04-18 14:18:26.555000', '2023-04-18 14:18:26.555000', '1', '1', NULL, '22', '22', '常规贮存', NULL, '盒', '222');
INSERT INTO `decentralize_details` VALUES ('da', '标准物质', '7E63C540FDDE7D5F647B77DA13BBD0BC', NULL, 'E1BE439C91E330183B4F62598AA2A2B0', '54', 0000000434, '68D2DBC2AF35C0CEB4E67B6B2977AD61', '一般标准物质', 'ma', '76%', NULL, 0000045.00, '2023-04-18 14:18:53.394000', '2023-04-18 14:18:53.394000', '1', '1', NULL, 'ma', 'ma', '常规贮存', NULL, '盒', '大麻3');
INSERT INTO `decentralize_details` VALUES ('dama', '标准物质', '8AD10FDECD3D3C38C0CE94B9C33C3D3D', NULL, 'EBDFA9CD26B5F77AEC6416FC5F04E83B', '564', 0000000023, 'E394DF6CB798A925D4C79F51544E1A73', '一般标准物质', 'dada', '56%', NULL, 0000045.00, '2023-04-18 14:16:26.003000', '2023-04-18 14:16:26.003000', '1', '1', NULL, 'dama', 'dama', '常规贮存', NULL, '盒', '大麻2');
INSERT INTO `decentralize_details` VALUES ('dama', '标准物质', 'A46078C6764E28B0310C2270C3AA5427', NULL, 'F444AAEAB8C4DE38D9A7DEECD53243B1', '564', 0000000232, 'E394DF6CB798A925D4C79F51544E1A73', '一般标准物质', 'dada', '56%', NULL, 0000045.00, '2023-04-18 15:02:47.116000', '2023-04-18 15:02:47.116000', '1', '1', NULL, 'dama', 'dama', '常规贮存', NULL, '盒', '大麻2');

-- ----------------------------
-- Table structure for decentralized_request
-- ----------------------------
DROP TABLE IF EXISTS `decentralized_request`;
CREATE TABLE `decentralized_request`  (
  `applicant_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(申请人id)',
  `opinion_of_approval` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '审批意见',
  `result_of_approval` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '审批结果\r\n',
  `approval_of_time` datetime(6) NULL DEFAULT NULL COMMENT '审批时间',
  `audit_opinion_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核意见',
  `audit_opinion_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核意见',
  `audit_opinion_of_three_level` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级审核意见',
  `audit_result_of_primary` tinyint(3) NULL DEFAULT NULL COMMENT '一级审核结果',
  `audit_result_of_secondary` tinyint(3) NULL DEFAULT NULL COMMENT '二级审核结果',
  `audit_result_of_three_level` tinyint(3) NULL DEFAULT NULL COMMENT '三级审核结果',
  `audit_time_of_primary` datetime(6) NULL DEFAULT NULL COMMENT '一级审核时间',
  `audit_time_of_secondary` datetime(6) NULL DEFAULT NULL COMMENT '二级审核时间',
  `audit_time_of_three_level` datetime(6) NULL DEFAULT NULL COMMENT '三级审核时间',
  `compliance_testing` tinyint(6) NULL DEFAULT NULL COMMENT '(需要符合性检验)',
  `date_of_application` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(申请日期)',
  `approver_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '审批人ID',
  `primary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核人ID\r\n',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `purchase_list_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(采购清单ID)',
  `secondary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核人ID',
  `status` int(8) NULL DEFAULT NULL COMMENT '(提交状态)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `three_level_audit_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级审核人ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(分散采购申请)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of decentralized_request
-- ----------------------------
INSERT INTO `decentralized_request` VALUES ('1', '审批通过', '1', '2023-04-18 16:52:14.681000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-18 15:46:25.398', '1', NULL, '8B10B242E667D55264246D7607C8C81E', NULL, NULL, 5, '2023-04-18 15:46:25.401000', '2023-04-18 16:52:14.899000', '1', '1', NULL);
INSERT INTO `decentralized_request` VALUES ('C27B8F582693B93596C21C1586A0845A', '审批通过', '1', '2023-04-18 16:53:08.498000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-18 15:58:58.805', '1', NULL, 'DD86CB5FAB1D5B04383D9F2BE1C71EF4', NULL, NULL, 5, '2023-04-18 15:58:58.810000', '2023-04-18 16:53:08.510000', 'C27B8F582693B93596C21C1586A0845A', '1', NULL);

-- ----------------------------
-- Table structure for delivery_registration_form
-- ----------------------------
DROP TABLE IF EXISTS `delivery_registration_form`;
CREATE TABLE `delivery_registration_form`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `date_of_delivery` datetime(6) NULL DEFAULT NULL COMMENT '(出库日期)',
  `depositor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(出库人)',
  `outgoing_applicant_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(出库申请人)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `status` int(5) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材出库登记表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of delivery_registration_form
-- ----------------------------
INSERT INTO `delivery_registration_form` VALUES ('3ECED6B92E56DE93B7983BAD76267226', NULL, NULL, 'C27B8F582693B93596C21C1586A0845A', '2023-04-25 10:46:17.311000', '2023-04-25 10:46:17.311000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 0);
INSERT INTO `delivery_registration_form` VALUES ('669E8592742B2F3940AAF63D5ECD3A46', NULL, NULL, 'BC1A096180973C5EA652C9787F5A155A', '2023-04-25 11:50:16.145000', '2023-04-25 11:50:16.145000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 0);
INSERT INTO `delivery_registration_form` VALUES ('9D81188486079A4401A40B5056469DD5', NULL, NULL, 'BC1A096180973C5EA652C9787F5A155A', '2023-04-25 11:48:33.798000', '2023-04-25 11:48:33.798000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 0);
INSERT INTO `delivery_registration_form` VALUES ('B794452B051ACF591C51854A898780D7', NULL, NULL, 'BC1A096180973C5EA652C9787F5A155A', '2023-04-25 11:48:15.774000', '2023-04-25 11:48:15.774000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 0);

-- ----------------------------
-- Table structure for details_of_centralized
-- ----------------------------
DROP TABLE IF EXISTS `details_of_centralized`;
CREATE TABLE `details_of_centralized`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `centralized_request_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(集中采购申请ID)',
  `purchase_catalogue_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(采购目录编号)',
  `quantity_purchased` int(255) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '(采购数量)',
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `procurement_content_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `replacement_quantity` int(255) UNSIGNED ZEROFILL NULL DEFAULT NULL,
  `replacement_reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `number_of_applications` int(11) UNSIGNED ZEROFILL NULL DEFAULT NULL,
  `details_remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(集中采购申请明细)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of details_of_centralized
-- ----------------------------
INSERT INTO `details_of_centralized` VALUES ('0A86BF0AD775A4AA94271AF9CFA59770', 'BE16796A40D2EB93F0F9C644698D3DFA', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000001111, 'E394DF6CB798A925D4C79F51544E1A73', '1111', '2023-04-19 14:47:30.101000', '2023-04-19 14:50:30.440000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'B3BAFFD846DBDAFCAF257A895509FBB2', NULL, NULL, 00000001111, NULL);
INSERT INTO `details_of_centralized` VALUES ('1A7F4227DCAA43107E22D6BFF7AF24D5', '6DC74FA4AF6CE1DB595D348E6932C3C2', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000100, '56BC02CC3C58F537A8289D142297A381', NULL, '2023-04-19 16:21:13.398000', '2023-04-19 16:21:35.107000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '2F7952C476BA3A2AD6C88A0DD8032152', NULL, NULL, 00000000100, NULL);
INSERT INTO `details_of_centralized` VALUES ('1EB02A169B2F846553B5B44007F96722', 'FB9AA2FCF3F2EA24B04F68DDF16C5D4F', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000010, 'E394DF6CB798A925D4C79F51544E1A73', '123', '2023-04-19 15:32:33.701000', '2023-04-20 09:21:36.515000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '248A03561549B02151383F2557704984', NULL, NULL, 00000000123, NULL);
INSERT INTO `details_of_centralized` VALUES ('2E008759E2144755065CC2FE002391EE', '1AFD4AE1546D2802CF3168F16A333AC6', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000300, 'E394DF6CB798A925D4C79F51544E1A73', NULL, '2023-04-19 16:20:55.730000', '2023-04-20 09:22:13.597000', 'C27B8F582693B93596C21C1586A0845A', 'BC1A096180973C5EA652C9787F5A155A', '248A03561549B02151383F2557704984', NULL, NULL, 00000000100, NULL);
INSERT INTO `details_of_centralized` VALUES ('2E131A0BE99535CE532926ED68086EB5', '3A19590D8F6CC22E70DD32CECA767E12', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000, '4DC0DFAD80856851F5484282EAFC54ED', NULL, '2023-04-19 12:00:38.727000', '2023-04-19 14:44:22.040000', '1', '1', 'BE98E13132B0437EE86CBE05EEEBB8DA', NULL, NULL, 00000000020, NULL);
INSERT INTO `details_of_centralized` VALUES ('34555A1D2027B8AFFFB59747812B306B', 'E496D316D0E70B08C4D5AE64B3A9248F', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000, '4DC0DFAD80856851F5484282EAFC54ED', NULL, '2023-04-19 12:00:45.764000', '2023-04-19 14:44:22.043000', '1', '1', 'BE98E13132B0437EE86CBE05EEEBB8DA', NULL, NULL, 00000000010, NULL);
INSERT INTO `details_of_centralized` VALUES ('3B63038AADA44C1455FF85EC89A57188', '28EB341C0E02F66F6A8F79298A3EC0F3', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000100, '4DC0DFAD80856851F5484282EAFC54ED', NULL, '2023-04-21 14:57:36.977000', '2023-04-21 14:57:47.812000', '1', '1', '850839C6AA50E4A7F73FE1E707F3045D', NULL, NULL, 00000000100, NULL);
INSERT INTO `details_of_centralized` VALUES ('48A5E3CFF39F716D64B0E01681D94060', '3A19590D8F6CC22E70DD32CECA767E12', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000, 'E394DF6CB798A925D4C79F51544E1A73', NULL, '2023-04-19 12:00:38.726000', '2023-04-19 14:17:36.523000', '1', 'BC1A096180973C5EA652C9787F5A155A', '4A11137EAF6D8C7B0FE5ADB285A78E83', NULL, NULL, 00000000020, NULL);
INSERT INTO `details_of_centralized` VALUES ('52B2F96D7A31CDFAF9FB0C71F440BC7B', 'D85DEB32F1D0BA4C6E7957EDBFA12427', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000011, '4DC0DFAD80856851F5484282EAFC54ED', '111', '2023-04-19 14:52:36.302000', '2023-04-19 14:52:56.772000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '79BAB76751122A45781404A3591CB148', NULL, NULL, 00000000011, NULL);
INSERT INTO `details_of_centralized` VALUES ('607A61B3159C385DB60855619C201E84', '6DC74FA4AF6CE1DB595D348E6932C3C2', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000100, 'E394DF6CB798A925D4C79F51544E1A73', NULL, '2023-04-19 16:21:13.397000', '2023-04-19 16:21:35.111000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '248A03561549B02151383F2557704984', NULL, NULL, 00000000100, NULL);
INSERT INTO `details_of_centralized` VALUES ('60A7CEE7B336D282F8D499C7B4F001CB', 'BE16796A40D2EB93F0F9C644698D3DFA', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000011, '68D2DBC2AF35C0CEB4E67B6B2977AD61', '111', '2023-04-19 14:47:30.102000', '2023-04-19 14:50:30.442000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '1B162B0EE45FC57A5D848652E384FED8', NULL, NULL, 00000000011, NULL);
INSERT INTO `details_of_centralized` VALUES ('77F194F09975FDBB6BC3C201B26FF2BD', '1AFD4AE1546D2802CF3168F16A333AC6', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000100, '4DC0DFAD80856851F5484282EAFC54ED', NULL, '2023-04-19 16:20:55.731000', '2023-04-19 16:21:35.103000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'FE59861437EA5CBFE0ACC05FED43D8B7', NULL, NULL, 00000000100, NULL);
INSERT INTO `details_of_centralized` VALUES ('7FE6CA8D86A88824ECF0216A94B8CEC9', 'BE16796A40D2EB93F0F9C644698D3DFA', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000111, '4DC0DFAD80856851F5484282EAFC54ED', '111', '2023-04-19 14:47:30.102000', '2023-04-19 14:50:30.444000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '07862889BCA52459BAE146F2C0E274B9', NULL, NULL, 00000000111, NULL);
INSERT INTO `details_of_centralized` VALUES ('9A4A217ED729EB087EC85B4DA49409A2', 'F19E3CEFA6698E0FBB8059EDAB27FA1A', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000100, 'E394DF6CB798A925D4C79F51544E1A73', '11', '2023-04-19 15:04:36.120000', '2023-04-20 09:06:57.400000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'FA075D1F9BC55465F3402D40E2134E4B', NULL, NULL, 00000000001, NULL);
INSERT INTO `details_of_centralized` VALUES ('A6243ABF15D3E8B3FA809CF415675832', 'D3B01D55369179CF684E94DAA8D76CC5', '1', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000112677, '4DC0DFAD80856851F5484282EAFC54ED', '11', '2023-04-19 15:00:05.667000', '2023-04-19 16:16:37.778000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'EC5CB50678E2E9AEED28C33E0C38F0C6', NULL, NULL, 00000000011, NULL);
INSERT INTO `details_of_centralized` VALUES ('C691D7F8516E73146A55CA5655694ED9', '333DE0540D7E21A0E411685017A914CA', NULL, NULL, 'E394DF6CB798A925D4C79F51544E1A73', '111', '2023-04-19 17:42:50.987000', '2023-04-19 17:42:50.987000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 00000000001, NULL);
INSERT INTO `details_of_centralized` VALUES ('C9C68A5F15E18C82763E25336D42D3A5', 'E496D316D0E70B08C4D5AE64B3A9248F', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000003, 'E394DF6CB798A925D4C79F51544E1A73', NULL, '2023-04-19 12:00:45.763000', '2023-04-19 14:17:23.902000', '1', 'BC1A096180973C5EA652C9787F5A155A', '4A11137EAF6D8C7B0FE5ADB285A78E83', NULL, NULL, 00000000010, NULL);
INSERT INTO `details_of_centralized` VALUES ('D35353809210A3770700FEC2D3FC8173', 'D85DEB32F1D0BA4C6E7957EDBFA12427', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000001, 'E394DF6CB798A925D4C79F51544E1A73', '111', '2023-04-19 14:52:36.301000', '2023-04-19 14:52:56.774000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'C89219AB87295BC0DEE928D3D70D8305', NULL, NULL, 00000000001, NULL);
INSERT INTO `details_of_centralized` VALUES ('DC9B4461603449B1C9FF632B4982C881', '094BAE1CC0E7463F2FDE120CA4778F96', NULL, 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000022, 'E394DF6CB798A925D4C79F51544E1A73', '1111', '2023-04-19 14:55:35.341000', '2023-04-19 14:57:10.368000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '8BF3F8493B42D1E060175251026EC4C0', NULL, NULL, 00000000011, NULL);

-- ----------------------------
-- Table structure for disqualification_form
-- ----------------------------
DROP TABLE IF EXISTS `disqualification_form`;
CREATE TABLE `disqualification_form`  (
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `compliance_check_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `disqualification_form_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`disqualification_form_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of disqualification_form
-- ----------------------------

-- ----------------------------
-- Table structure for evaluation_form
-- ----------------------------
DROP TABLE IF EXISTS `evaluation_form`;
CREATE TABLE `evaluation_form`  (
  `comments_from_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级评价意见',
  `comments_from_three_level` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级评价意见',
  `contact_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(联系电话)',
  `contact_person` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(联系人)',
  `primary_user_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级评价人ID',
  `comments_from_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级评价意见',
  `secondary_user_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级评价人ID',
  `service_provider_and_supplier_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(服务商/供应商ID)',
  `three_level_user_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级评价人ID',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `supplier_information_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '供应商/服务商信息表ID',
  `supplier_business_license` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商营业执照)',
  `supplier_passes_quality_assurance_system` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商通过质量保证体系)',
  `supplier_product_certification` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商产品认证)',
  `check_and_calibrate_efficiency_of_supplies` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(对供应品检验校准效率)',
  `overall_supplier_service_satisfaction` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(对供应商总体服务是否满意)',
  `supplier_attitude` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商态度)',
  `supplier_equipment_and_facilities` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商设备与设施)',
  `supplier_technology_and_management_capability` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商技术与管理能力)',
  `whether_the_supplier_delivers_on_time` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商交货是否及时)',
  `comments_result_from_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级评价结果',
  `comments_date_from_primary` datetime(6) NULL DEFAULT NULL COMMENT '一级评价时间',
  `comments_result_from_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级评价结果',
  `comments_date_from_secondary` datetime(6) NULL DEFAULT NULL COMMENT '二级评价时间',
  `comments_result_from_three_level` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '三级评价结果',
  `comments_date_from_three_level` datetime(6) NULL DEFAULT NULL COMMENT '三级评价时间',
  `status` int(2) NULL DEFAULT NULL COMMENT '状态\r\n',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(服务商/供应商评价表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of evaluation_form
-- ----------------------------
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 14:54:38.379000', '2023-04-17 14:54:38.379000', '1', '1', '149D1F2E5E22C239106B1BFDBC09AFA4', '12F7D1F5F83481503F5EAC204BFE9FB7', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 15:26:24.439000', '2023-04-17 15:26:24.439000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '17FE537A3E06324B6FF8EE64099FEAF1', '80FA0C44E3A2846331CAD918A2D90F2D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 14:45:07.171000', '2023-04-17 14:45:07.171000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '233765804C45235945A988186A837434', 'B4232934D504286DBD4A55E747C624CA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 14:21:31.334000', '2023-04-17 14:21:31.334000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '5076682D86295D822C06A55B7746406F', 'EA088AA61983C2C8C60954D2D8E4B153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 14:09:39.446000', '2023-04-17 14:09:39.446000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '64A418BB016F96AA4A5B289656690859', '2DA79E5EA9BD6AC13D6BED4258B976EA', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 16:44:38.859000', '2023-04-17 16:44:38.859000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '9B75CA6F4494766C28671068DA0EC14A', '4DE1482F1E1C25E76EEAA306E3161C9D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `evaluation_form` VALUES ('合格', NULL, '15533331111', '关于', '1', NULL, NULL, NULL, NULL, '2023-03-21 10:26:55.452000', '2023-03-21 10:28:29.370000', '1', '1', 'BF25138DF5339B72ECC9772B59C959EB', '1', '有', '有', '有', '满意', '满意', '满意', '满意', '满意', '满意', NULL, '2023-03-21 00:00:00.000000', NULL, NULL, NULL, NULL, 1, NULL);
INSERT INTO `evaluation_form` VALUES (NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-17 14:04:56.966000', '2023-04-17 14:04:56.966000', '1', '1', 'D417F5D7D6E2E156495E85F0826F6BE8', '92E358EC60031EF81C131A93355592E1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for expiration_reminder
-- ----------------------------
DROP TABLE IF EXISTS `expiration_reminder`;
CREATE TABLE `expiration_reminder`  (
  `expiration_date` datetime(0) NULL DEFAULT NULL COMMENT '(试剂耗材有效期/保质期)',
  `expiration_message` datetime(0) NOT NULL COMMENT '(试剂耗材到期提醒信息)',
  `reagent_consumable_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `reagent_consumable_number` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材编号)',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `expiration_reminder_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`expiration_reminder_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材到期提醒)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of expiration_reminder
-- ----------------------------

-- ----------------------------
-- Table structure for fixed_value_report
-- ----------------------------
DROP TABLE IF EXISTS `fixed_value_report`;
CREATE TABLE `fixed_value_report`  (
  `fixed_value_report` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(定值报告URL)',
  `reference_substance_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '标准物质ID',
  `fixed_value_report_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `fixed_result` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '定值结果',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  PRIMARY KEY (`fixed_value_report_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(定值报告)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of fixed_value_report
-- ----------------------------

-- ----------------------------
-- Table structure for instruction_book
-- ----------------------------
DROP TABLE IF EXISTS `instruction_book`;
CREATE TABLE `instruction_book`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `audit_opinion_of_technical` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '技术负责人审核意见',
  `audit_result_of_technical` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '技术负责人审核结果',
  `audit_time_of_technical` datetime(0) NULL DEFAULT NULL COMMENT '技术负责人审核时间',
  `commit_status` int(11) NULL DEFAULT NULL COMMENT '(提交状态)',
  `instruction_book` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(指导书)',
  `maker_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(制定人)',
  `reference_material_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质id)',
  `set_time` datetime(0) NULL DEFAULT NULL COMMENT '(制定时间)',
  `technical_director_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '技术负责人ID',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准物质期间核查指导书)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of instruction_book
-- ----------------------------

-- ----------------------------
-- Table structure for lattice_form
-- ----------------------------
DROP TABLE IF EXISTS `lattice_form`;
CREATE TABLE `lattice_form`  (
  `update_by` varbinary(255) NULL DEFAULT NULL,
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` int(255) NULL DEFAULT NULL,
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `cabinet_form_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `picture` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of lattice_form
-- ----------------------------
INSERT INTO `lattice_form` VALUES (NULL, NULL, 0, '1', '1', NULL, NULL, NULL, NULL);
INSERT INTO `lattice_form` VALUES (NULL, NULL, 0, '2', '1', NULL, NULL, NULL, NULL);
INSERT INTO `lattice_form` VALUES (NULL, NULL, 0, '3', '1', NULL, NULL, NULL, NULL);
INSERT INTO `lattice_form` VALUES (NULL, NULL, 0, '4', '1', NULL, NULL, NULL, NULL);
INSERT INTO `lattice_form` VALUES (NULL, NULL, 0, '5', '1', NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for location_information
-- ----------------------------
DROP TABLE IF EXISTS `location_information`;
CREATE TABLE `location_information`  (
  `cabinet_number` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(柜子编号)',
  `cabinet_type` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(柜子类型)',
  `lattice_number` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(格子编号)',
  `storage_registration_form_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材入库登记表ID)',
  `storage_room_number` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(存储室号)',
  `storage_room_type` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(存储室类型)',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `location_information_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`location_information_id`) USING BTREE,
  INDEX `IXFK_location_information_storage_registration_form`(`storage_registration_form_id`) USING BTREE,
  CONSTRAINT `FK_location_information_storage_registration_form` FOREIGN KEY (`storage_registration_form_id`) REFERENCES `storage_registration_form` (`storage_registration_form_id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(位置信息)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of location_information
-- ----------------------------

-- ----------------------------
-- Table structure for outgoing_contents
-- ----------------------------
DROP TABLE IF EXISTS `outgoing_contents`;
CREATE TABLE `outgoing_contents`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `delivery_registration_form_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材出库登记表ID)',
  `outbound_use` int(3) NULL DEFAULT NULL COMMENT '(出库用途)',
  `quantity` int(11) NULL DEFAULT NULL COMMENT '(数量)',
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `reagent_consumable_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材类型)',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `return_or_not` tinyint(3) NULL DEFAULT NULL,
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reference_material_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(出库内容)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of outgoing_contents
-- ----------------------------
INSERT INTO `outgoing_contents` VALUES ('12431BBAA8BA92FA3DCDD8A575FD7AA6', '669E8592742B2F3940AAF63D5ECD3A46', 0, 10, '4DC0DFAD80856851F5484282EAFC54ED', '试剂', '1231', '2023-04-25 11:50:16.146000', '2023-04-25 11:50:16.146000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 0, NULL, NULL);
INSERT INTO `outgoing_contents` VALUES ('1F96F15425615EF58C8CD582594B1031', '9D81188486079A4401A40B5056469DD5', 0, 10, '4DC0DFAD80856851F5484282EAFC54ED', '试剂', '12313', '2023-04-25 11:48:33.798000', '2023-04-25 11:48:33.798000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 0, NULL, NULL);
INSERT INTO `outgoing_contents` VALUES ('416FF4EBD1F56ECA782C62701089C5BA', 'B794452B051ACF591C51854A898780D7', 0, 10, '4DC0DFAD80856851F5484282EAFC54ED', '试剂', '1233123', '2023-04-25 11:48:15.775000', '2023-04-25 11:48:15.775000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 0, NULL, NULL);
INSERT INTO `outgoing_contents` VALUES ('9D45791357522BBD10F52AB0D2B11289', '3ECED6B92E56DE93B7983BAD76267226', 0, 1, '4DC0DFAD80856851F5484282EAFC54ED', '试剂', '1', '2023-04-25 10:46:17.315000', '2023-04-25 10:46:17.315000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 0, NULL, NULL);
INSERT INTO `outgoing_contents` VALUES ('D66D1C4118F9EA46860E83542A872791', '3ECED6B92E56DE93B7983BAD76267226', 0, 1, '56BC02CC3C58F537A8289D142297A381', '标准物质', '1', '2023-04-25 10:46:17.314000', '2023-04-25 10:46:17.314000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 1, 'dada-2023-1-038', '007C4F9D413B84F5FED6B536D453E92D');

-- ----------------------------
-- Table structure for period_verification_implementation
-- ----------------------------
DROP TABLE IF EXISTS `period_verification_implementation`;
CREATE TABLE `period_verification_implementation`  (
  `audit_opinion_of_technical` varchar(6) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术负责人审核意见)',
  `audit_result_of_technical` tinyint(36) NULL DEFAULT NULL COMMENT '(技术负责人审核结果)',
  `audit_time_of_technical` datetime(6) NULL DEFAULT NULL COMMENT '(技术负责人审核时间)',
  `cause_of_dissatisfaction` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(不满足应用要求原因分析)',
  `checking_time` datetime(6) NULL DEFAULT NULL COMMENT '(核查时间)',
  `commit_status` int(11) NULL DEFAULT NULL COMMENT '(提交状态)',
  `deviation_and_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(偏差/不确定度)',
  `implementation_and_results` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(核查实施情况及结果)',
  `inspector_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(核查人员ID)',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(编号)',
  `opinion_of_inspector` tinyint(3) NULL DEFAULT NULL COMMENT '(核查人员意见)',
  `reference_material_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质ID)',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `standard_value_and_purity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准值/纯度)',
  `technical_director_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术负责人ID)',
  `verification_method` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(核查方法)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `period_verification_implementation_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `period_verification_plan_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reference_material_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`period_verification_implementation_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准物质期间核查实施情况及结果记录表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of period_verification_implementation
-- ----------------------------

-- ----------------------------
-- Table structure for period_verification_plan
-- ----------------------------
DROP TABLE IF EXISTS `period_verification_plan`;
CREATE TABLE `period_verification_plan`  (
  `date_of_next_check` datetime(6) NULL DEFAULT NULL COMMENT '(下次核查日期)',
  `deviation_and_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(偏差/不确定度)',
  `inspector_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(核查人ID)',
  `instruction_book_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(指导书ID)',
  `planned_verification_cycle` int(5) NULL DEFAULT NULL COMMENT '(计划核查周期)',
  `reference_material_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质ID)',
  `scheduled_verification_date` datetime(6) NULL DEFAULT NULL COMMENT '(计划核查日期)',
  `standard_value_and_purity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准值/纯度)',
  `verification_basis` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(核查依据)',
  `implementation_date` datetime(6) NULL DEFAULT NULL COMMENT '(核查实施日期)',
  `verification_result` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(核查结果)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `check_schedule_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准物质期间核查计划和确认表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of period_verification_plan
-- ----------------------------
INSERT INTO `period_verification_plan` VALUES (NULL, '1.1', '1', NULL, 2, '942B1DF7A794395171D3175270A46464', '2023-03-14 00:00:00.000000', '70%', '核查手册', NULL, NULL, '2023-04-24 16:56:10.685000', '2023-04-24 16:56:10.685000', '1', '1', '2e5b7149bf7136812b13d3a79e02e4b9', '52F2BA565CEF882A8EE03C9127E19BD7', 'HW-2023-1-06');
INSERT INTO `period_verification_plan` VALUES (NULL, '1.1', '1', NULL, 1, '942B1DF7A794395171D3175270A46464', '2023-03-14 00:00:00.000000', '70%', '核查手册', NULL, NULL, '2023-04-24 16:56:10.684000', '2023-04-24 16:56:10.684000', '1', '1', 'b20580fd3c06c735067ed7015489502d', '52F2BA565CEF882A8EE03C9127E19BD7', 'HW-2023-1-09');

-- ----------------------------
-- Table structure for procurement_content
-- ----------------------------
DROP TABLE IF EXISTS `procurement_content`;
CREATE TABLE `procurement_content`  (
  `purchasing_plan_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(采购计划id)',
  `quantity_purchased` int(8) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '(数量)',
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `subtotal` double(255, 0) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '(小计)',
  `unit_price` double(10, 2) UNSIGNED ZEROFILL NULL DEFAULT NULL COMMENT '(单价)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `procurement_content_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `replacement_quantity` int(255) UNSIGNED ZEROFILL NULL DEFAULT NULL,
  `replacement_reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `replacement_price` double(10, 2) UNSIGNED ZEROFILL NULL DEFAULT NULL,
  `details_of_centralized_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `number_of_applications` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `plan_remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`procurement_content_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(采购内容)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of procurement_content
-- ----------------------------
INSERT INTO `procurement_content` VALUES ('0AECCBC02F3F82CFE55AD4B48CAEE360', 00000111, '4DC0DFAD80856851F5484282EAFC54ED', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000002442, 0000022.00, '2023-04-19 14:50:30.448000', '2023-04-19 14:50:30.448000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '07862889BCA52459BAE146F2C0E274B9', NULL, NULL, NULL, '7FE6CA8D86A88824ECF0216A94B8CEC9', '111', NULL);
INSERT INTO `procurement_content` VALUES ('0AECCBC02F3F82CFE55AD4B48CAEE360', 00000011, '68D2DBC2AF35C0CEB4E67B6B2977AD61', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000495, 0000045.00, '2023-04-19 14:50:30.448000', '2023-04-19 14:50:30.448000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '1B162B0EE45FC57A5D848652E384FED8', NULL, NULL, NULL, '60A7CEE7B336D282F8D499C7B4F001CB', '11', NULL);
INSERT INTO `procurement_content` VALUES ('4F17D6750FF0634FF94BF5EF0657D6E9', 00000300, 'E394DF6CB798A925D4C79F51544E1A73', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000013500, 0000045.00, '2023-04-19 16:21:35.120000', '2023-04-20 09:22:13.596000', 'C27B8F582693B93596C21C1586A0845A', 'BC1A096180973C5EA652C9787F5A155A', '248A03561549B02151383F2557704984', NULL, NULL, NULL, '2E008759E2144755065CC2FE002391EE', '100', '111');
INSERT INTO `procurement_content` VALUES ('4F17D6750FF0634FF94BF5EF0657D6E9', 00000100, '56BC02CC3C58F537A8289D142297A381', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000003200, 0000032.00, '2023-04-19 16:21:35.121000', '2023-04-19 16:21:35.121000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '2F7952C476BA3A2AD6C88A0DD8032152', NULL, NULL, NULL, '1A7F4227DCAA43107E22D6BFF7AF24D5', '100', NULL);
INSERT INTO `procurement_content` VALUES ('F410105BFF8AA409C55BA1C044AF4B55', 00000003, 'E394DF6CB798A925D4C79F51544E1A73', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000135, 0000045.00, '2023-04-19 12:00:58.752000', '2023-04-19 14:17:36.517000', '1', 'BC1A096180973C5EA652C9787F5A155A', '4A11137EAF6D8C7B0FE5ADB285A78E83', NULL, NULL, NULL, '48A5E3CFF39F716D64B0E01681D94060', '20', NULL);
INSERT INTO `procurement_content` VALUES ('35D158B64D5ABF6F9FA575D4C2D77470', 00000011, '4DC0DFAD80856851F5484282EAFC54ED', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000242, 0000022.00, '2023-04-19 14:52:56.775000', '2023-04-19 14:52:56.775000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '79BAB76751122A45781404A3591CB148', NULL, NULL, NULL, '52B2F96D7A31CDFAF9FB0C71F440BC7B', '11', NULL);
INSERT INTO `procurement_content` VALUES ('28627D87056C83BD15149BBACB90C681', 00000100, '4DC0DFAD80856851F5484282EAFC54ED', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000002200, 0000022.00, '2023-04-21 14:57:47.821000', '2023-04-21 14:57:47.821000', '1', '1', '850839C6AA50E4A7F73FE1E707F3045D', NULL, NULL, NULL, '3B63038AADA44C1455FF85EC89A57188', '100', NULL);
INSERT INTO `procurement_content` VALUES ('480F36553844D439121E525105139A05', 00000022, 'E394DF6CB798A925D4C79F51544E1A73', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000990, 0000045.00, '2023-04-19 14:55:41.647000', '2023-04-19 14:57:10.363000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '8BF3F8493B42D1E060175251026EC4C0', NULL, NULL, NULL, 'DC9B4461603449B1C9FF632B4982C881', '11', NULL);
INSERT INTO `procurement_content` VALUES ('0AECCBC02F3F82CFE55AD4B48CAEE360', 00001111, 'E394DF6CB798A925D4C79F51544E1A73', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000049995, 0000045.00, '2023-04-19 14:50:30.447000', '2023-04-19 14:50:30.447000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'B3BAFFD846DBDAFCAF257A895509FBB2', NULL, NULL, NULL, '0A86BF0AD775A4AA94271AF9CFA59770', '1111', NULL);
INSERT INTO `procurement_content` VALUES ('35D158B64D5ABF6F9FA575D4C2D77470', 00000001, 'E394DF6CB798A925D4C79F51544E1A73', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000045, 0000045.00, '2023-04-19 14:52:56.775000', '2023-04-19 14:52:56.775000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'C89219AB87295BC0DEE928D3D70D8305', NULL, NULL, NULL, 'D35353809210A3770700FEC2D3FC8173', '1', NULL);
INSERT INTO `procurement_content` VALUES ('50B75CB38D67E9F3D4A9D87725909A82', 00112677, '4DC0DFAD80856851F5484282EAFC54ED', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000002478894, 0000022.00, '2023-04-19 15:00:27.536000', '2023-04-19 16:16:37.772000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'EC5CB50678E2E9AEED28C33E0C38F0C6', NULL, NULL, NULL, 'A6243ABF15D3E8B3FA809CF415675832', '11', NULL);
INSERT INTO `procurement_content` VALUES ('C9C97577F0ED0297D0B59D3C44ADDF22', 00000100, 'E394DF6CB798A925D4C79F51544E1A73', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000004500, 0000045.00, '2023-04-19 15:05:10.635000', '2023-04-20 09:06:57.399000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', 'FA075D1F9BC55465F3402D40E2134E4B', NULL, NULL, NULL, '9A4A217ED729EB087EC85B4DA49409A2', '1', '备注1');
INSERT INTO `procurement_content` VALUES ('4F17D6750FF0634FF94BF5EF0657D6E9', 00000100, '4DC0DFAD80856851F5484282EAFC54ED', 000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000002200, 0000022.00, '2023-04-19 16:21:35.121000', '2023-04-19 16:21:35.121000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'FE59861437EA5CBFE0ACC05FED43D8B7', NULL, NULL, NULL, '77F194F09975FDBB6BC3C201B26FF2BD', '100', NULL);

-- ----------------------------
-- Table structure for provide_services_or_supplies
-- ----------------------------
DROP TABLE IF EXISTS `provide_services_or_supplies`;
CREATE TABLE `provide_services_or_supplies`  (
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `evaluation_form_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(服务商/供应商评价表ID)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '提供服务或供应品' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of provide_services_or_supplies
-- ----------------------------
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.983000', '2023-04-21 17:36:19.983000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '07D90BA08C80F993DD26EB4CF3E0C28A');
INSERT INTO `provide_services_or_supplies` VALUES ('1', 'BF25138DF5339B72ECC9772B59C959EB', '2023-03-21 10:28:29.376000', '2023-03-21 10:28:29.376000', '1', '1', '097EFD7664C55233EFDD644694F18149');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.792000', '2023-04-21 09:42:34.792000', '1', '1', '0F96C7939663106C7AA6B393AF46E425');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.527000', '2023-04-21 09:42:34.527000', '1', '1', '14EE7C581650D8C408877D5F7E6844EE');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.996000', '2023-04-21 17:36:19.996000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '18F3465AD6881AF078ACC93208318020');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.497000', '2023-04-21 09:42:34.497000', '1', '1', '1DE57B082AA76664D801A1BBAE96C271');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:18:37.390000', '2023-04-20 17:18:37.390000', '1', '1', '2BB50FCC317495AE3D8B9AF1B2CC59E8');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 15:13:24.020000', '2023-04-21 15:13:24.020000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '359BD2857879C47A7D8A33948729409B');
INSERT INTO `provide_services_or_supplies` VALUES ('942B1DF7A794395171D3175270A46464', 'BF25138DF5339B72ECC9772B59C959EB', '2023-04-18 15:19:44.671000', '2023-04-18 15:19:44.671000', '1', '1', '35EB4699470009DE2F2F29CCD5DF86BF');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 10:14:32.128000', '2023-04-21 10:14:32.128000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '3C3120B8A27A665EE6CE4F20706EE179');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.610000', '2023-04-21 09:42:34.610000', '1', '1', '47A010B2340767CC6FD311B35986667B');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.582000', '2023-04-21 09:42:34.582000', '1', '1', '47F5237AA1F1B13305420795034241E5');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.975000', '2023-04-21 17:36:19.975000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '4B64F3BEB4DA2060B474FB53BFC8A95E');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.424000', '2023-04-21 09:15:03.424000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '4C8572ACF495488FAC2BA278C1A803CE');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '64A418BB016F96AA4A5B289656690859', '2023-04-21 15:10:58.736000', '2023-04-21 15:10:58.736000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '537C802B8963AC072B575E586B373556');
INSERT INTO `provide_services_or_supplies` VALUES ('233ace392b1a111a5a4b91191cb24811', 'BF25138DF5339B72ECC9772B59C959EB', '2023-04-18 15:19:44.842000', '2023-04-18 15:19:44.842000', '1', '1', '53B7B0F5B7A555C7143097003B9145E2');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.758000', '2023-04-21 09:42:34.758000', '1', '1', '54840E0533324F9A186F3D9A44444B47');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.389000', '2023-04-21 09:15:03.389000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '5660359EB14D20B3530EB8695A4D1435');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.309000', '2023-04-21 09:15:03.309000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '5791B1FA805CF773BECC7617AADDE4B2');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.349000', '2023-04-21 09:15:03.349000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '62AC614D84AEEE5F9008BA3D142A3C35');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.637000', '2023-04-21 09:42:34.637000', '1', '1', '6C046A58CD1FDBE62046C169487C8EA5');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.405000', '2023-04-21 09:42:34.405000', '1', '1', '6C50C5DDC403106504D45A498CA32266');
INSERT INTO `provide_services_or_supplies` VALUES ('1', 'BF25138DF5339B72ECC9772B59C959EB', '2023-03-21 10:28:29.377000', '2023-03-21 10:28:29.377000', '1', '1', '6CFF40B81E8E2CCC1D8620602360B505');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:26:52.060000', '2023-04-20 17:26:52.060000', '1', '1', '6F9A4B1CB46D786AF61B3CE669BEBFB2');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.465000', '2023-04-21 09:42:34.465000', '1', '1', '816C769DCA9DE685144E94E0D678DF4C');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.912000', '2023-04-21 17:36:19.912000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '8736A4F86679048EE95556E5BD4CF207');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.724000', '2023-04-21 09:42:34.724000', '1', '1', '8E1F7D2DFFC7DA0198CC814CA0AA75D6');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.952000', '2023-04-21 17:36:19.952000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '9052F08C3710727D5D03B507491E2BFE');
INSERT INTO `provide_services_or_supplies` VALUES ('56BC02CC3C58F537A8289D142297A381', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 15:12:16.283000', '2023-04-21 15:12:16.283000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '9394BB21D0A46AA4A4493ACCD65A38F5');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 15:20:30.056000', '2023-04-21 15:20:30.056000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '9530543954943C39CB26B80EE067087C');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.696000', '2023-04-21 09:42:34.696000', '1', '1', '955A3160AFBDB7DCA77D6AB7F3DFB633');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 10:14:32.184000', '2023-04-21 10:14:32.184000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', '985E0B40CB427A2C16BA1198AC3DB04E');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:18:37.474000', '2023-04-20 17:18:37.474000', '1', '1', '9A06CFEA8B84FF22FD96ECD2959CA4FE');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.823000', '2023-04-21 09:42:34.823000', '1', '1', 'AEFCA308648DD4F4F4672AEBCAF86408');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:26:52.018000', '2023-04-20 17:26:52.018000', '1', '1', 'B200D375587AF256E3FE0914EE12247E');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.495000', '2023-04-21 09:15:03.495000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'B6551B1860058491D24B8299E05D5EBA');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 16:15:35.058000', '2023-04-21 16:15:35.058000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'B83B44D980460A1D44A5862EF09F4657');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.555000', '2023-04-21 09:42:34.555000', '1', '1', 'BDE188DA41D5A78775B4A9B066309D88');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '64A418BB016F96AA4A5B289656690859', '2023-04-21 14:59:56.864000', '2023-04-21 14:59:56.864000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'BE78851A162D104479A18FC2FD32461A');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:42:34.667000', '2023-04-21 09:42:34.667000', '1', '1', 'C03E19AAF163863C789C802AB9629B1A');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.943000', '2023-04-21 17:36:19.943000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'CAE1AE40AC48C95A77C311511880A5A7');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:03:02.255000', '2023-04-20 17:03:02.255000', '1', '1', 'CB421DD934E6373765DA690DBDFF780C');
INSERT INTO `provide_services_or_supplies` VALUES ('EC9357ED2463BB14C6EFE231436C218D', 'BF25138DF5339B72ECC9772B59C959EB', '2023-04-18 15:19:44.609000', '2023-04-18 15:19:44.609000', '1', '1', 'CB5ABEC7F0CD408866FB8411362A651A');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:26:52.082000', '2023-04-20 17:26:52.082000', '1', '1', 'CD6C20108428797C82B08E517A87B277');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 15:22:15.603000', '2023-04-21 15:22:15.603000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'CD7D4D58A224A90073D2AFCE5FEF0A91');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:19.966000', '2023-04-21 17:36:19.966000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'D2132260D0351BD73ACD70153576FB5F');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.460000', '2023-04-21 09:15:03.460000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'D9DDDB36ED33B63560BFA8DAEB5FB7CC');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-20 17:26:52.109000', '2023-04-20 17:26:52.109000', '1', '1', 'DF1F853F589BA4339572E39C640A90CE');
INSERT INTO `provide_services_or_supplies` VALUES ('2', 'BF25138DF5339B72ECC9772B59C959EB', '2023-03-21 10:28:29.377000', '2023-03-21 10:28:29.377000', '1', '1', 'EBF5A395A95E6E8782E2D1A8F3CBF9A9');
INSERT INTO `provide_services_or_supplies` VALUES ('56BC02CC3C58F537A8289D142297A381', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:17:23.741000', '2023-04-21 17:17:23.741000', '1', '1', 'ECE89AC94E69EDD8B22137B2578C46E0');
INSERT INTO `provide_services_or_supplies` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '9B75CA6F4494766C28671068DA0EC14A', '2023-04-21 09:15:03.227000', '2023-04-21 09:15:03.227000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'FA3F1A3245F4CE511A62CB12E4A01C0C');
INSERT INTO `provide_services_or_supplies` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '17FE537A3E06324B6FF8EE64099FEAF1', '2023-04-21 17:36:20.004000', '2023-04-21 17:36:20.004000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'FB721FC8287FBCED09703C7D6C6DDAC2');

-- ----------------------------
-- Table structure for purchase_catalogue
-- ----------------------------
DROP TABLE IF EXISTS `purchase_catalogue`;
CREATE TABLE `purchase_catalogue`  (
  `purchase_catalogue_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `audit_opinion_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核意见\r\n',
  `audit_opinion_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核意见',
  `audit_result_of_primary` tinyint(255) NULL DEFAULT NULL COMMENT '一级审核结果',
  `audit_result_of_secondary` tinyint(255) NULL DEFAULT NULL COMMENT '二级审核结果',
  `audit_time_of_primary` datetime(6) NULL DEFAULT NULL COMMENT '一级审核时间',
  `audit_time_of_secondary` datetime(6) NULL DEFAULT NULL COMMENT '二级审核时间',
  `primary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核人',
  `release_date` datetime(6) NULL DEFAULT NULL COMMENT '发布日期',
  `status` int(255) NULL DEFAULT NULL COMMENT '(状态)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `secondary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级审核人ID',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`purchase_catalogue_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(采购目录)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of purchase_catalogue
-- ----------------------------
INSERT INTO `purchase_catalogue` VALUES ('0ADA4915B884EC2AA1A4B213CF791556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, '2023-04-19 16:45:21.266000', '2023-04-19 16:45:21.266000', '1', '1', NULL, NULL);
INSERT INTO `purchase_catalogue` VALUES ('564E236AFA6BA1EF7E9C28F927BFB13D', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, '2023-04-18 10:01:40.512000', '2023-04-18 10:01:40.512000', '1', '1', NULL, NULL);
INSERT INTO `purchase_catalogue` VALUES ('59B41C115F9906393320FE4D5760053A', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, '2023-04-18 09:49:33.036000', '2023-04-18 09:49:33.036000', '1', '1', NULL, NULL);
INSERT INTO `purchase_catalogue` VALUES ('769B6D8D7A54F4595A06745F25706169', NULL, '审核通过', NULL, 1, NULL, '2023-04-18 11:30:05.605000', NULL, NULL, 4, '2023-04-18 09:54:38.615000', '2023-04-18 11:30:05.625000', '1', '1', '1', NULL);
INSERT INTO `purchase_catalogue` VALUES ('F897538730C1722798970643884807FF', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, '2023-04-18 09:54:23.427000', '2023-04-18 09:58:25.937000', '1', '1', NULL, NULL);

-- ----------------------------
-- Table structure for purchase_list
-- ----------------------------
DROP TABLE IF EXISTS `purchase_list`;
CREATE TABLE `purchase_list`  (
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '清单名称',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` int(9) NULL DEFAULT NULL,
  `type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(采购清单)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of purchase_list
-- ----------------------------
INSERT INTO `purchase_list` VALUES ('2023-03-20采购清单', '2023-03-20 11:06:29.489000', '2023-03-20 11:06:29.489000', '1', '1', '28B56107FC4D5BBCC8B485A728216DBB', NULL, NULL, NULL);
INSERT INTO `purchase_list` VALUES ('2023-03-22采购清单', '2023-03-22 09:57:59.087000', '2023-03-22 09:57:59.087000', '1', '1', '2AF4FD700A7534084C32975668EEF924', NULL, NULL, NULL);
INSERT INTO `purchase_list` VALUES ('2023-04-19 16:31:36采购清单', '2023-04-19 16:31:36.646000', '2023-04-19 16:31:36.646000', '1', '1', '3FE2F364DC3E0BD7F57A0891C9AB902A', NULL, 0, '采购计划');
INSERT INTO `purchase_list` VALUES ('2023-04-04采购清单', '2023-04-04 16:34:32.781000', '2023-04-04 16:34:32.781000', '1', '1', '6137CEA303DD6CEA255D7438E12FC600', NULL, NULL, NULL);
INSERT INTO `purchase_list` VALUES ('2023-04-19 16:35:58采购清单', '2023-04-19 16:35:58.068000', '2023-04-19 16:36:41.585000', '1', '1', '66724A3976617987C9B78167EABBC515', NULL, 1, '采购计划');
INSERT INTO `purchase_list` VALUES ('2023-04-18 16:52:14采购清单', '2023-04-18 16:52:14.875000', '2023-04-18 16:52:14.875000', '1', '1', '896690B4AD7855353D203DB8A623EC90', NULL, 0, '分散采购申请');
INSERT INTO `purchase_list` VALUES ('2023-04-18采购清单', '2023-04-18 09:40:50.582000', '2023-04-18 09:40:50.582000', '1', '1', 'A49FE2CEB92C461A39D8AF73206660D6', NULL, NULL, NULL);
INSERT INTO `purchase_list` VALUES ('2023-04-21 14:59:23采购清单', '2023-04-21 14:59:23.499000', '2023-04-21 15:00:05.642000', '1', '1', 'BAEC3FB4FA2294BF4C4BFD1A8DCCE01A', NULL, 1, '采购计划');
INSERT INTO `purchase_list` VALUES ('2023-04-18 16:53:08采购清单', '2023-04-18 16:53:08.500000', '2023-04-19 11:27:26.127000', '1', '6c847974320c7cb184228d53eea19114', 'BBBD74C0E875793D8CF40CF081113C7E', NULL, 1, '分散采购申请');
INSERT INTO `purchase_list` VALUES ('2023-04-19 16:26:49采购清单', '2023-04-19 16:26:49.289000', '2023-04-19 16:26:49.289000', '1', '1', 'FAF395F1281FC6AB2E5BCAC80CF6FDCD', NULL, 0, '采购计划');

-- ----------------------------
-- Table structure for purchase_list_details
-- ----------------------------
DROP TABLE IF EXISTS `purchase_list_details`;
CREATE TABLE `purchase_list_details`  (
  `purchase_list_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(采购清单ID)·',
  `purchase_quantity` int(11) NULL DEFAULT NULL COMMENT '(采购量)',
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `supplier_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商ID)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(采购清单明细)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of purchase_list_details
-- ----------------------------
INSERT INTO `purchase_list_details` VALUES ('28B56107FC4D5BBCC8B485A728216DBB', 99, '1', '1', '2023-03-20 11:06:29.523000', '2023-03-20 11:06:29.523000', '1', '1', '00F1C706F8B1AF46DBF33C51236A79A6');
INSERT INTO `purchase_list_details` VALUES ('28B56107FC4D5BBCC8B485A728216DBB', 99, '2', '1', '2023-03-20 11:06:29.522000', '2023-03-20 11:06:29.522000', '1', '1', '100D5C9358B57F9F9921123E10F95867');
INSERT INTO `purchase_list_details` VALUES ('BBBD74C0E875793D8CF40CF081113C7E', NULL, '4DC0DFAD80856851F5484282EAFC54ED', '4DE1482F1E1C25E76EEAA306E3161C9D', '2023-04-18 16:53:08.504000', '2023-04-19 10:48:19.001000', '1', '6c847974320c7cb184228d53eea19114', '1176CB3D209E30D02DD96C4D7685E363');
INSERT INTO `purchase_list_details` VALUES ('A49FE2CEB92C461A39D8AF73206660D6', 50, '233ace392b1a111a5a4b91191cb24811', '1', '2023-04-18 09:40:50.592000', '2023-04-18 09:40:50.592000', '1', '1', '2BEAA37A92A4A95F66E227DB6EA1E78E');
INSERT INTO `purchase_list_details` VALUES ('6137CEA303DD6CEA255D7438E12FC600', 50, '942B1DF7A794395171D3175270A46464', '72E82118AA58CFE3EB4D400C253F512E', '2023-04-04 16:34:32.791000', '2023-04-04 16:34:32.791000', '1', '1', '305140CA8CA1986BFDC854FEA1C6F4C4');
INSERT INTO `purchase_list_details` VALUES ('896690B4AD7855353D203DB8A623EC90', 323, 'A3D7E4D4A19169E664FFF0698A4CF8AD', NULL, '2023-04-18 16:52:14.890000', '2023-04-18 16:52:14.890000', '1', '1', '391067AAD16EF9B217FFB75A4CE1CBDB');
INSERT INTO `purchase_list_details` VALUES ('BAEC3FB4FA2294BF4C4BFD1A8DCCE01A', 100, '4DC0DFAD80856851F5484282EAFC54ED', '80FA0C44E3A2846331CAD918A2D90F2D', '2023-04-21 14:59:23.508000', '2023-04-21 15:00:04.546000', '1', '1', '3C2A1AE403CBB4655CA7A4D74FA71A05');
INSERT INTO `purchase_list_details` VALUES ('66724A3976617987C9B78167EABBC515', 323, 'E394DF6CB798A925D4C79F51544E1A73', '4DE1482F1E1C25E76EEAA306E3161C9D', '2023-04-19 16:35:58.079000', '2023-04-19 16:36:34.941000', '1', '1', '3D39A52419C9EC1F42BC1C4B91095B26');
INSERT INTO `purchase_list_details` VALUES ('2AF4FD700A7534084C32975668EEF924', 10, '1', '1', '2023-03-22 09:57:59.097000', '2023-03-22 09:57:59.097000', '1', '1', '4AA790C8EE4AE9B31BD08CF1250663E7');
INSERT INTO `purchase_list_details` VALUES ('66724A3976617987C9B78167EABBC515', 100, '56BC02CC3C58F537A8289D142297A381', '80FA0C44E3A2846331CAD918A2D90F2D', '2023-04-19 16:35:58.085000', '2023-04-19 16:36:37.848000', '1', '1', '67DDE2DBA0394174391892E3713F542E');
INSERT INTO `purchase_list_details` VALUES ('A49FE2CEB92C461A39D8AF73206660D6', 10, 'EC9357ED2463BB14C6EFE231436C218D', '1', '2023-04-18 09:40:50.591000', '2023-04-18 09:40:50.591000', '1', '1', '686A6695EFDB33B52373B172B354FBF7');
INSERT INTO `purchase_list_details` VALUES ('66724A3976617987C9B78167EABBC515', 100, '4DC0DFAD80856851F5484282EAFC54ED', '2DA79E5EA9BD6AC13D6BED4258B976EA', '2023-04-19 16:35:58.095000', '2023-04-19 16:36:40.493000', '1', '1', '71BA91D94FBDFFD0A43D72782085E90F');
INSERT INTO `purchase_list_details` VALUES ('28B56107FC4D5BBCC8B485A728216DBB', 99, '1', '1', '2023-03-20 11:06:29.521000', '2023-03-20 11:06:29.521000', '1', '1', '81E6950F875078CBF6AFCB76F99DF55D');
INSERT INTO `purchase_list_details` VALUES ('BBBD74C0E875793D8CF40CF081113C7E', NULL, 'E394DF6CB798A925D4C79F51544E1A73', '80FA0C44E3A2846331CAD918A2D90F2D', '2023-04-18 16:53:08.506000', '2023-04-19 11:21:42.545000', '1', '6c847974320c7cb184228d53eea19114', '8BB038016182E1A76AE4B90A7791BD9A');
INSERT INTO `purchase_list_details` VALUES ('A49FE2CEB92C461A39D8AF73206660D6', 50, '942B1DF7A794395171D3175270A46464', '72E82118AA58CFE3EB4D400C253F512E', '2023-04-18 09:40:50.590000', '2023-04-18 09:40:50.590000', '1', '1', 'A88DC502491C808852E9CF2172C146E8');
INSERT INTO `purchase_list_details` VALUES ('2AF4FD700A7534084C32975668EEF924', 30, '2', '1', '2023-03-22 09:57:59.099000', '2023-03-22 09:57:59.099000', '1', '1', 'CC571698845DAFDBB9E8607D8A1D116D');
INSERT INTO `purchase_list_details` VALUES ('6137CEA303DD6CEA255D7438E12FC600', 10, 'EC9357ED2463BB14C6EFE231436C218D', '1', '2023-04-04 16:34:32.793000', '2023-04-04 16:34:32.793000', '1', '1', 'D44B3A88EC7D4E2D8CAA7DF777BA90EE');
INSERT INTO `purchase_list_details` VALUES ('2AF4FD700A7534084C32975668EEF924', 20, '1', '1', '2023-03-22 09:57:59.098000', '2023-03-22 09:57:59.098000', '1', '1', 'D76761B4CF062509DAF2B46EA44BB4E7');
INSERT INTO `purchase_list_details` VALUES ('BBBD74C0E875793D8CF40CF081113C7E', NULL, '4DC0DFAD80856851F5484282EAFC54ED', '80FA0C44E3A2846331CAD918A2D90F2D', '2023-04-19 10:30:29.309000', '2023-04-19 11:21:51.853000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 'D847135EA551FB9D2E2A10327442B5E8');

-- ----------------------------
-- Table structure for purchasing_plan
-- ----------------------------
DROP TABLE IF EXISTS `purchasing_plan`;
CREATE TABLE `purchasing_plan`  (
  `appropriation_budget` double(255, 0) NULL DEFAULT NULL COMMENT '(经费预算)',
  `approval_opinion` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '审批意见',
  `approval_result` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '审批结果',
  `approval_time` datetime(6) NULL DEFAULT NULL COMMENT '审批时间',
  `audit_opinion_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核意见',
  `audit_result_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核结果',
  `audit_time_of_primary` datetime(6) NULL DEFAULT NULL COMMENT '一级审核时间',
  `approver_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '审批人ID',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `purchase_list_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(采购清单ID)',
  `primary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级审核人ID',
  `release_date` datetime(6) NULL DEFAULT NULL COMMENT '发布日期',
  `status` int(11) NULL DEFAULT NULL COMMENT '(状态)',
  `purchasing_plan_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '制定人\r\n',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `department` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`purchasing_plan_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(采购计划)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of purchasing_plan
-- ----------------------------
INSERT INTO `purchasing_plan` VALUES (52932, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-19 14:50:30.446000', '2023-04-19 14:50:30.446000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 0, '0AECCBC02F3F82CFE55AD4B48CAEE360', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, '员工审核员1');
INSERT INTO `purchasing_plan` VALUES (2200, '审批通过', '1', '2023-04-21 14:59:23.492000', NULL, NULL, NULL, '1', '2023-04-21 14:57:47.814000', '2023-04-21 14:59:23.514000', '1', '1', NULL, NULL, NULL, 3, '28627D87056C83BD15149BBACB90C681', '1', NULL, NULL, '管理员');
INSERT INTO `purchasing_plan` VALUES (287, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-19 14:52:56.774000', '2023-04-19 14:52:56.774000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 0, '35D158B64D5ABF6F9FA575D4C2D77470', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, '员工审核员1');
INSERT INTO `purchasing_plan` VALUES (990, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-19 14:55:41.646000', '2023-04-19 14:57:10.374000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 0, '480F36553844D439121E525105139A05', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, '员工审核员1');
INSERT INTO `purchasing_plan` VALUES (18900, '审批通过', '1', '2023-04-19 16:35:58.018000', NULL, NULL, NULL, '1', '2023-04-19 16:21:35.117000', '2023-04-20 09:22:13.599000', 'C27B8F582693B93596C21C1586A0845A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 3, '4F17D6750FF0634FF94BF5EF0657D6E9', 'C27B8F582693B93596C21C1586A0845A', NULL, NULL, '审核员2');
INSERT INTO `purchasing_plan` VALUES (2478894, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-19 15:00:27.536000', '2023-04-19 16:16:37.785000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 0, '50B75CB38D67E9F3D4A9D87725909A82', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, '员工审核员1');
INSERT INTO `purchasing_plan` VALUES (4500, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-19 15:05:10.634000', '2023-04-20 09:06:57.403000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, NULL, 1, 'C9C97577F0ED0297D0B59D3C44ADDF22', 'BC1A096180973C5EA652C9787F5A155A', NULL, NULL, '员工审核员1');
INSERT INTO `purchasing_plan` VALUES (135, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '2023-04-19 12:00:58.748000', '2023-04-19 14:44:22.051000', '1', '1', NULL, NULL, NULL, 0, 'F410105BFF8AA409C55BA1C044AF4B55', '1', NULL, NULL, '管理员');

-- ----------------------------
-- Table structure for reagent_consumable_inventory
-- ----------------------------
DROP TABLE IF EXISTS `reagent_consumable_inventory`;
CREATE TABLE `reagent_consumable_inventory`  (
  `reagent_consumable_inventory_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '试剂耗材id',
  `reagent_consumable_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `brand` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(品牌)',
  `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(类别)',
  `deviation_or_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '偏差/不确定度',
  `instruction_book_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(指导书ID)',
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(规格型号)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `standard_value_or_purity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准值/纯度)',
  `technical_parameter` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术参数)',
  `total_quantity` int(55) NOT NULL COMMENT '(总数量)',
  `species` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '种类\r\n',
  `packaged_copies` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lattice_Id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `configuration_concentration` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `storage_condition` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `minimum_unit` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `english_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `unit_price` decimal(10, 2) NULL DEFAULT NULL,
  `storage_life` datetime(6) NULL DEFAULT NULL,
  `status` int(255) NULL DEFAULT NULL,
  PRIMARY KEY (`reagent_consumable_inventory_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '试剂耗材库存' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of reagent_consumable_inventory
-- ----------------------------
INSERT INTO `reagent_consumable_inventory` VALUES ('88FF175C8ACCF8B710C000C386765866', '56BC02CC3C58F537A8289D142297A381', '大麻1', 'dada', '标准物质', NULL, NULL, 'dada', '2023-04-18 10:25:36.994000', '2023-04-21 17:17:23.958000', '1', '1', '67%', NULL, 145, '一般标准物质', '23', NULL, NULL, 'dada', '常规贮存', NULL, '盒', 'dada', 32.00, NULL, NULL);
INSERT INTO `reagent_consumable_inventory` VALUES ('8FA36752B25A66E2E934A3446CEC2039', '4DC0DFAD80856851F5484282EAFC54ED', '222', '22', '试剂', NULL, NULL, '22', '2023-04-18 09:54:38.616000', '2023-04-21 17:36:20.008000', '1', '6c847974320c7cb184228d53eea19114', '22', NULL, 90, '酒精', '22', NULL, NULL, '22', '常规贮存', '222', '盒', '22', 22.00, NULL, NULL);
INSERT INTO `reagent_consumable_inventory` VALUES ('972B49CE93F21DB67AB34ABE42F4BEDB', '233ace392b1a111a5a4b91191cb24811', '大麻', '小米', '标准物质', '1.2', NULL, '固体', '2023-04-06 16:57:40.213000', '2023-04-06 16:57:40.213000', '1', '1', '70%', NULL, 80, '一般标准物质', '50', NULL, NULL, 'K粉', '冷藏存储', '白色粉末', '盒', 'HW', 4299.00, NULL, NULL);
INSERT INTO `reagent_consumable_inventory` VALUES ('BF9FE30FCF74CD8040BF7A7EAC53BBFC', 'E394DF6CB798A925D4C79F51544E1A73', '大麻2', 'dama', '标准物质', NULL, NULL, 'dada', '2023-04-18 10:26:32.422000', '2023-04-25 10:30:36.688000', '1', '1', '56%', NULL, 514, '一般标准物质', '564', NULL, NULL, 'dama', '常规贮存', NULL, '盒', 'dama', 45.00, NULL, NULL);
INSERT INTO `reagent_consumable_inventory` VALUES ('D115879CEE645E5FF1522B473CCDBAC8', 'EC9357ED2463BB14C6EFE231436C218D', NULL, '华为', '标准物质', '1.2', NULL, '固体', '2023-03-31 14:44:18.252000', '2023-04-18 15:19:44.664000', '1', '1', '70%', NULL, 60, '一般标准物质', '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `reagent_consumable_inventory` VALUES ('E26E35A8363EA106453A87AF223A211B', '942B1DF7A794395171D3175270A46464', NULL, '华为', '标准物质', '1.2', NULL, '固体', '2023-03-31 14:44:18.254000', '2023-04-18 15:19:44.839000', '1', '1', '70%', NULL, 249, '一般标准物质', '50', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for reagent_consumables
-- ----------------------------
DROP TABLE IF EXISTS `reagent_consumables`;
CREATE TABLE `reagent_consumables`  (
  `reagent_consumable_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reagent_consumable_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `brand` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '品牌',
  `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '类别',
  `deviation_or_uncertainty` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '偏差/不确定度',
  `species` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '种类',
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '规格型号',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `standard_value_or_purity` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准值/纯度)',
  `technical_parameter` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术参数)',
  `unit_price` double(10, 2) NULL DEFAULT NULL COMMENT '单价',
  `english_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `packaged_copies` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `storage_condition` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `minimum_unit` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `configuration_concentration` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`reagent_consumable_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材类)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of reagent_consumables
-- ----------------------------
INSERT INTO `reagent_consumables` VALUES ('214ed66de23e1f9cf495ea28f4b00b7f', '鸦片', '三星', '标准物质', '1.2', '一般标准物质', '固体', '2023-04-06 16:57:40.215000', '2023-04-06 16:57:40.215000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('233ace392b1a111a5a4b91191cb24811', '大麻', '小米', '标准物质', '1.2', '一般标准物质', '固体', '2023-04-06 16:57:40.213000', '2023-04-06 16:57:40.213000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('261E466DFFE2916093C5C3998365AE66', '海洛因2', '华为', '标准物质', NULL, '一般标准物质', '固体', '2023-04-13 14:52:00.802000', '2023-04-17 09:27:05.727000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('34ef0c4eb51bf9d925ea581e96fd2349', '摇头丸', '苹果', '标准物质', '1.2', '一般标准物质', '固体', '2023-04-06 16:57:40.216000', '2023-04-06 16:57:40.216000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('4DC0DFAD80856851F5484282EAFC54ED', '222', '22', '试剂', NULL, '酒精', '22', '2023-04-18 09:54:38.616000', '2023-04-18 11:30:05.617000', '1', '1', '22', NULL, 22.00, '22', '22', '22', '常规贮存', '222', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('56BC02CC3C58F537A8289D142297A381', '大麻1', 'dada', '标准物质', NULL, '一般标准物质', 'dada', '2023-04-18 10:25:36.994000', '2023-04-18 11:30:05.623000', '1', '1', '67%', NULL, 32.00, 'dada', '23', 'dada', '常规贮存', NULL, '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('5B6B773F606C7E20196298198CC97888', '海洛因3', '华为', '标准物质', NULL, '一般标准物质', '固体', '2023-04-13 14:52:00.803000', '2023-04-17 09:27:05.715000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('68D2DBC2AF35C0CEB4E67B6B2977AD61', '大麻3', 'da', '标准物质', NULL, '一般标准物质', 'ma', '2023-04-18 10:27:24.101000', '2023-04-18 11:30:05.619000', '1', '1', '76%', NULL, 45.00, 'ma', '54', 'ma', '常规贮存', NULL, '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('942B1DF7A794395171D3175270A46464', '海洛因3', '华为', '标准物质', '1.2', '一般标准物质', '固体', '2023-03-31 14:44:18.254000', '2023-03-31 14:54:04.668000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('A2EC1D872C1C5F1E42C8C32068E5E1D8', '海洛因1', '华为', '标准物质', NULL, '一般标准物质', '固体', '2023-04-13 14:52:00.802000', '2023-04-17 09:27:05.725000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('A3D7E4D4A19169E664FFF0698A4CF8AD', '大麻', 'da', '标准物质', NULL, '一般标准物质', 'da', '2023-04-18 10:40:34.056000', '2023-04-18 11:30:05.621000', '1', '1', '56%', NULL, 3443.00, 'da', '2343', 'da', '常规贮存', NULL, '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('E394DF6CB798A925D4C79F51544E1A73', '大麻2', 'dama', '标准物质', NULL, '一般标准物质', 'dada', '2023-04-18 10:26:32.422000', '2023-04-18 11:30:05.609000', '1', '1', '56%', NULL, 45.00, 'dama', '564', 'dama', '常规贮存', NULL, '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('EC9357ED2463BB14C6EFE231436C218D', '海洛因2', '华为', '标准物质', '1.2', '一般标准物质', '固体', '2023-03-31 14:44:18.252000', '2023-03-31 14:54:04.661000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);
INSERT INTO `reagent_consumables` VALUES ('FCD45169853216681393BA13B8056435', '海洛因1', '华为', '标准物质', '1.2', '一般标准物质', '固体', '2023-03-31 14:44:18.251000', '2023-03-31 14:54:04.665000', '1', '1', '70%', NULL, 4299.00, 'HW', '50', 'K粉', '冷藏存储', '白色粉末', '盒', NULL, NULL);

-- ----------------------------
-- Table structure for reagent_consumables_set
-- ----------------------------
DROP TABLE IF EXISTS `reagent_consumables_set`;
CREATE TABLE `reagent_consumables_set`  (
  `quantity` int(11) NULL DEFAULT NULL COMMENT '(数量)',
  `reagent_consumable_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `purpose` int(6) NULL DEFAULT NULL,
  `batch_details_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `return_or_not` tinyint(3) NULL DEFAULT NULL,
  `application_for_use_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材集合)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of reagent_consumables_set
-- ----------------------------
INSERT INTO `reagent_consumables_set` VALUES (10, '4DC0DFAD80856851F5484282EAFC54ED', '2023-04-25 11:50:15.469000', '2023-04-25 11:50:15.469000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '0397A52574652D6E84F9539E7324DCC5', '22', '1231', 0, '044BC72726B54F6E515C5913462DDB12', 0, '132E48107248D2F52AA9BA626821B64D', NULL);
INSERT INTO `reagent_consumables_set` VALUES (1, 'E394DF6CB798A925D4C79F51544E1A73', '2023-04-25 10:45:15.950000', '2023-04-25 10:45:15.950000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '2FDBEC310557FBC8D1F6FDD772DF47BD', 'dada', '1', 0, '35A44617B1CFB5722450DED4AE207056', 1, '7A2F7ADBCB14B2D8AB3F5CD3D2CA87C1', 'dama-2023-1-100');
INSERT INTO `reagent_consumables_set` VALUES (1, '4DC0DFAD80856851F5484282EAFC54ED', '2023-04-25 10:45:20.124000', '2023-04-25 10:45:20.124000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '3AD97F0A9077C5E2A49D549BC50743CC', '22', '1', 0, '044BC72726B54F6E515C5913462DDB12', 0, '0B48D3210DBDAF8FF53EF6C6D008EF00', NULL);
INSERT INTO `reagent_consumables_set` VALUES (10, '4DC0DFAD80856851F5484282EAFC54ED', '2023-04-25 11:48:33.784000', '2023-04-25 11:48:33.784000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '56B83A87598F74E80381C6129B9E12CB', '22', '12313', 0, '044BC72726B54F6E515C5913462DDB12', 0, 'BA532FB9709EC95F179FCC1C1F6BF67F', NULL);
INSERT INTO `reagent_consumables_set` VALUES (1, 'E394DF6CB798A925D4C79F51544E1A73', '2023-04-25 11:50:26.901000', '2023-04-25 11:50:26.901000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '6D93A7BF28A4BB4B98DAEC71E8ABC1A9', 'dada', '21312', 0, '35A44617B1CFB5722450DED4AE207056', 1, 'C366668EE5E76C3AAD5C43DC399A7A32', 'dama-2023-1-100');
INSERT INTO `reagent_consumables_set` VALUES (1, '4DC0DFAD80856851F5484282EAFC54ED', '2023-04-25 10:45:15.949000', '2023-04-25 10:45:15.949000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '6EAEE31C42E70C927D3B984A3185914F', '22', '1', 0, '044BC72726B54F6E515C5913462DDB12', 0, '7A2F7ADBCB14B2D8AB3F5CD3D2CA87C1', NULL);
INSERT INTO `reagent_consumables_set` VALUES (1, 'E394DF6CB798A925D4C79F51544E1A73', '2023-04-25 10:43:53.032000', '2023-04-25 10:43:53.032000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', '99D62B3D14ACC821DAB6608373CCC4B6', 'dada', '1', 0, '35A44617B1CFB5722450DED4AE207056', 1, '121700C7196E61EFD084CE94BA8A9045', 'dama-2023-1-100');
INSERT INTO `reagent_consumables_set` VALUES (1, '56BC02CC3C58F537A8289D142297A381', '2023-04-25 10:46:17.290000', '2023-04-25 10:46:17.290000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'AF7D2D5EC2872188545C052843DF0584', 'dada', '1', 0, '5B307CF2ED7EB5620C04C224CBAE2F9B', 1, 'A2098A185E57905E2A428FDC9BA13904', 'dada-2023-1-038');
INSERT INTO `reagent_consumables_set` VALUES (1, 'E394DF6CB798A925D4C79F51544E1A73', '2023-04-25 10:45:20.124000', '2023-04-25 10:45:20.124000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'CDF5177579EF720BE0F454073F263643', 'dada', '1', 0, '35A44617B1CFB5722450DED4AE207056', 1, '0B48D3210DBDAF8FF53EF6C6D008EF00', 'dama-2023-1-100');
INSERT INTO `reagent_consumables_set` VALUES (1, '4DC0DFAD80856851F5484282EAFC54ED', '2023-04-25 10:43:53.032000', '2023-04-25 10:43:53.032000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'DB93A5BD73CCD14D4EBFB16CDEEB5176', '22', '1', 0, '044BC72726B54F6E515C5913462DDB12', 0, '121700C7196E61EFD084CE94BA8A9045', NULL);
INSERT INTO `reagent_consumables_set` VALUES (1, '4DC0DFAD80856851F5484282EAFC54ED', '2023-04-25 10:46:17.290000', '2023-04-25 10:46:17.290000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', 'E80301953B5CEF5AECB10FF6FC954ED3', '22', '1', 0, '044BC72726B54F6E515C5913462DDB12', 0, 'A2098A185E57905E2A428FDC9BA13904', NULL);

-- ----------------------------
-- Table structure for reference_material
-- ----------------------------
DROP TABLE IF EXISTS `reference_material`;
CREATE TABLE `reference_material`  (
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `batch_details_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` int(6) UNSIGNED ZEROFILL NULL DEFAULT NULL,
  `reagent_consumable_inventory_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of reference_material
-- ----------------------------
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '006658CBA49ADCA33E9EC27F2A28ECD7', '2023-04-21 10:14:32.576000', '2023-04-21 10:14:32.576000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-038', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '007C4F9D413B84F5FED6B536D453E92D', '2023-04-21 15:12:16.360000', '2023-04-21 15:12:16.360000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-090', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '01A8913069F2F2A6DDF49EAFB93AF395', '2023-04-21 17:17:23.928000', '2023-04-21 17:17:23.928000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '01E73F176665009D8DBD1E053A6AB1F2', '2023-04-21 10:14:32.516000', '2023-04-21 10:14:32.516000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-48', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '027AAE9C89C6A095479BA70250941B9F', '2023-04-21 10:14:32.288000', '2023-04-21 10:14:32.288000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-44', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '037F8FDE682785E102119BC4EE7451DB', '2023-04-21 10:14:32.280000', '2023-04-21 10:14:32.280000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-78', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '05643C10DB5DF2D06033AC463193F305', '2023-04-21 10:14:32.354000', '2023-04-21 10:14:32.354000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '05ADE8307A8EBE0A238F576C04E42C35', '2023-04-21 10:14:32.706000', '2023-04-21 10:14:32.706000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '05B70A5CC0BA1A88197958D06981AD9B', '2023-04-21 10:14:32.414000', '2023-04-21 10:14:32.414000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-80', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '06252094910802EAE9EF22DEE30CFC94', '2023-04-21 10:14:32.358000', '2023-04-21 10:14:32.358000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '063E215C812832F5AA99718127277C9A', '2023-04-21 10:14:33.186000', '2023-04-21 10:14:33.186000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-18', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '065C2F632BEF1F427650F4D1450775EE', '2023-04-21 10:14:32.224000', '2023-04-21 10:14:32.224000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '07722EAD9746B0B171B75EC8E0B00247', '2023-04-21 10:14:32.502000', '2023-04-21 10:14:32.502000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '08391A7CECD5990169014B7B9A9F1933', '2023-04-21 10:14:32.555000', '2023-04-21 10:14:32.555000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0875593D08816BB9D64AC69BC7928266', '2023-04-21 10:14:33.063000', '2023-04-21 10:14:33.063000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '08E2470A63BBA50F3D315F289A60ADE8', '2023-04-21 10:14:33.333000', '2023-04-21 10:14:33.333000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-69', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '097F36506FA0460CB08C07E3C09B81BC', '2023-04-21 10:14:32.333000', '2023-04-21 10:14:32.333000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-086', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '0A5DA430963DE2CA3D363D7D651C1993', '2023-04-21 17:17:23.916000', '2023-04-21 17:17:23.916000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0AC30252242B435CFCE85690ECAD852C', '2023-04-21 10:14:32.652000', '2023-04-21 10:14:32.652000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0B639CF62CE6845918549A3FA13B7CC3', '2023-04-21 10:14:32.693000', '2023-04-21 10:14:32.693000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0B7EE769B6F31AAAC5560FE5175B2974', '2023-04-21 10:14:32.864000', '2023-04-21 10:14:32.864000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-64', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0D247E9B1E1E39A843F9AC0B6109451B', '2023-04-21 10:14:32.323000', '2023-04-21 10:14:32.323000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0D9B35346CBE8331BC6624AA1498393C', '2023-04-21 10:14:32.690000', '2023-04-21 10:14:32.690000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-73', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0DA42BB72981C8DE0983D3F69993578F', '2023-04-21 10:14:32.343000', '2023-04-21 10:14:32.343000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '0E29543D851190153D3B109444D7610D', '2023-04-21 10:14:32.561000', '2023-04-21 10:14:32.561000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-001', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '0EF48524D7301CF25135C53C5C61AEC5', '2023-04-21 15:12:16.296000', '2023-04-21 15:12:16.296000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-011', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '0EFD49F9361CC2D7CA6FAEC104459D00', '2023-04-21 15:12:16.314000', '2023-04-21 15:12:16.314000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-072', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '112475A54C83C0B5CA1DA73EBFE45526', '2023-04-21 17:17:23.869000', '2023-04-21 17:17:23.869000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '117675FAFE23FA0C1823B73B0FBA99C6', '2023-04-21 10:14:33.220000', '2023-04-21 10:14:33.220000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '11A6DAF3E3EE3ACF4B3B8032E99B4DD5', '2023-04-21 10:14:32.679000', '2023-04-21 10:14:32.679000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-53', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '1309CE324F0C0BD013F2DE8988B51922', '2023-04-21 10:14:32.298000', '2023-04-21 10:14:32.298000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-025', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '134AFA3C70452CE416C2484BBB18A73C', '2023-04-21 15:12:16.337000', '2023-04-21 15:12:16.337000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '141DAE74C2145EBA914F01A612D3A6B2', '2023-04-21 10:14:32.485000', '2023-04-21 10:14:32.485000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-15', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '15329EE423757345177B6535773302A4', '2023-04-21 10:14:32.217000', '2023-04-21 10:14:32.217000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-054', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '16535506A2F82B402DA653F2C041EE0F', '2023-04-21 17:17:23.807000', '2023-04-21 17:17:23.807000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '16D2D3E2765A024D1C862D5C07E1CAEB', '2023-04-21 10:14:32.609000', '2023-04-21 10:14:32.609000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '17BA602413E998E099D3450DB46F2899', '2023-04-21 10:14:33.253000', '2023-04-21 10:14:33.253000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-042', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '18513F1CD0E5922B3E75F69902CF9C8E', '2023-04-21 15:12:16.368000', '2023-04-21 15:12:16.368000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '18E49AFC9D0A9A9AE6E338FC4EA1257C', '2023-04-21 10:14:32.909000', '2023-04-21 10:14:32.909000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-018', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '19ED63CF3A987F6F24838A4544501ECA', '2023-04-21 15:12:16.326000', '2023-04-21 15:12:16.326000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-093', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '1A236387C1EBD1726C16F59A19621F10', '2023-04-21 17:17:23.936000', '2023-04-21 17:17:23.936000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-068', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '1A65F8B9B289CC68C406290E7827E086', '2023-04-21 17:17:23.855000', '2023-04-21 17:17:23.855000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-60', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '1A80ED6E0978E530F7DD18EB8EA98F29', '2023-04-21 10:14:32.315000', '2023-04-21 10:14:32.315000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '1AA6319CE4B56FEB601525665DA08BEB', '2023-04-21 10:14:33.175000', '2023-04-21 10:14:33.175000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-037', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '1C40CE4FAF93838C20689208D188C595', '2023-04-21 15:12:16.359000', '2023-04-21 15:12:16.359000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-088', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '1C483EBA8B33ADD7F63AD25AD28C79D8', '2023-04-21 17:17:23.922000', '2023-04-21 17:17:23.922000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-034', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '1C8D3E7437D992DF1C4A2522C6EA2313', '2023-04-21 15:12:16.353000', '2023-04-21 15:12:16.353000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '1CE4FEC9A145C194F7C77B96A41D0F30', '2023-04-21 10:14:32.744000', '2023-04-21 10:14:32.744000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-055', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '1ED73F05F3A1C6D84F51D3E01AB3D505', '2023-04-21 17:17:23.810000', '2023-04-21 17:17:23.810000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '1FB280968F1D256B41D03903C1828CC5', '2023-04-21 10:14:32.648000', '2023-04-21 10:14:32.648000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '1FFDA84DDEC9CECCCB72C655B0D1652B', '2023-04-21 10:14:32.541000', '2023-04-21 10:14:32.541000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-029', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '200598E53A9BF1748634D4BA41B4AB2B', '2023-04-21 15:12:16.344000', '2023-04-21 15:12:16.344000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-22', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '207AAA3C7A09713DF064241A1457E368', '2023-04-21 10:14:32.232000', '2023-04-21 10:14:32.232000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-061', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '20F30C173D02E6DEBF1FCD8672973586', '2023-04-21 17:17:23.832000', '2023-04-21 17:17:23.832000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '212F520DC0B3D787D770EC96A03736A7', '2023-04-21 10:14:32.820000', '2023-04-21 10:14:32.820000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-035', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '219FC6C8F318B352CB5F13BE20038003', '2023-04-21 15:12:16.355000', '2023-04-21 15:12:16.355000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-099', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '223364104B76A60B386C9BD435746CB8', '2023-04-21 17:17:23.954000', '2023-04-21 17:17:23.954000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-72', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2457DE77D659C45CE5BB73173FC82554', '2023-04-21 10:14:32.340000', '2023-04-21 10:14:32.340000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-051', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '2501D2A92E8F0EC8655D2B2F18D51263', '2023-04-21 17:17:23.796000', '2023-04-21 17:17:23.796000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-27', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '250EC9F3D41191A4D853A6D7BB04DCFE', '2023-04-21 10:14:32.243000', '2023-04-21 10:14:32.243000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2555B55F4B597DADD48C4BC2587A84E8', '2023-04-21 10:14:32.494000', '2023-04-21 10:14:32.494000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '25AA4DD2588DDCBB111E86E7065E0E3B', '2023-04-21 10:14:33.002000', '2023-04-21 10:14:33.002000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '261F78A8E1C74D2E1221A3DA86CA3E8E', '2023-04-21 10:14:33.142000', '2023-04-21 10:14:33.142000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-99', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '263726B0879F7D333EFD2D783A729D15', '2023-04-21 10:14:32.406000', '2023-04-21 10:14:32.406000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-065', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '274383EFB7254CFCCA11AE8283745B4A', '2023-04-21 17:17:23.846000', '2023-04-21 17:17:23.846000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '28404B3B7CCF44BCB9C8E07812A60334', '2023-04-21 10:14:32.432000', '2023-04-21 10:14:32.432000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-97', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '289F0EA5C4F39B6B2208513D787CE455', '2023-04-21 10:14:32.401000', '2023-04-21 10:14:32.401000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '290EC5805E0AFDAF31740A0648993229', '2023-04-21 10:14:32.416000', '2023-04-21 10:14:32.416000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '29E897B3F5CAE421E3158F6C00C01A39', '2023-04-21 10:14:32.941000', '2023-04-21 10:14:32.941000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-50', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2B504B62592019F70FA632458ABADF34', '2023-04-21 10:14:32.293000', '2023-04-21 10:14:32.293000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2B99B30388825142831FA13C41A40BF1', '2023-04-21 10:14:32.429000', '2023-04-21 10:14:32.429000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2D2FBF236BD777EBA2A5F736C624A254', '2023-04-21 10:14:32.603000', '2023-04-21 10:14:32.603000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2DE4CC818B3175C3C2864FDF1DB9C581', '2023-04-21 10:14:32.588000', '2023-04-21 10:14:32.588000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2E8F158B06D4DA4D7AF96C173A921D76', '2023-04-21 10:14:32.930000', '2023-04-21 10:14:32.930000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2ECA63ECACF026C11FD0313DA64AB70A', '2023-04-21 10:14:32.936000', '2023-04-21 10:14:32.936000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '2ECF48D6889830954B206C932A174543', '2023-04-21 10:14:32.606000', '2023-04-21 10:14:32.606000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '30B1D65DC304A57A0809B9C96F0FAF25', '2023-04-21 10:14:32.767000', '2023-04-21 10:14:32.767000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-083', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '3108E85ACE7867FECFEF6C7689E445BF', '2023-04-21 17:17:23.907000', '2023-04-21 17:17:23.907000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '313B13D7D6679E3ADA7CF5F0F71CB7E4', '2023-04-21 10:14:33.106000', '2023-04-21 10:14:33.106000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '317FBF3EBBFD4EBA26C2C6E2F5583104', '2023-04-21 10:14:32.634000', '2023-04-21 10:14:32.634000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3187D68B390E28F44305362EC4BB3428', '2023-04-21 10:14:32.529000', '2023-04-21 10:14:32.529000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '31F19B166109B1D2C6750FE554956CF6', '2023-04-21 10:14:32.683000', '2023-04-21 10:14:32.683000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '33464ABB75AED21494EB225C3E3475F2', '2023-04-21 10:14:32.491000', '2023-04-21 10:14:32.491000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-062', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '34714D6EBDCE838C8FEF35F2B241E815', '2023-04-21 17:17:23.836000', '2023-04-21 17:17:23.836000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3474D1B2CA5C99FEFFC75CC666613CB9', '2023-04-21 10:14:32.549000', '2023-04-21 10:14:32.549000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-043', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '348F90689E7BCB21B5E70A9EE2E037C3', '2023-04-21 15:12:16.370000', '2023-04-21 15:12:16.370000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-015', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '35090AF47674E0F11AE30FAB7A2B1249', '2023-04-21 15:12:16.320000', '2023-04-21 15:12:16.320000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '353B665642BA0E093987ED62C6FAFA51', '2023-04-21 10:14:32.991000', '2023-04-21 10:14:32.991000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3587F447C0DAD01CBEF8C727EADFE591', '2023-04-21 10:14:33.310000', '2023-04-21 10:14:33.310000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-20', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '35EE519FCA7EA54E4B65CF9D1A8F463C', '2023-04-21 10:14:32.228000', '2023-04-21 10:14:32.228000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '35F602EE8A17D96713336E4986BC5438', '2023-04-21 10:14:33.007000', '2023-04-21 10:14:33.007000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-006', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '363B798B2E03F4A3E0C341F9A568DC97', '2023-04-21 15:12:16.305000', '2023-04-21 15:12:16.305000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '36505A629FCD455CDFF7D6D54CBE2C42', '2023-04-21 10:14:32.919000', '2023-04-21 10:14:32.919000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '390837C568E48E1B24A0E84CA8618215', '2023-04-21 10:14:33.148000', '2023-04-21 10:14:33.148000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '397B60BE489B1FD971BC44058B8C9FD5', '2023-04-21 10:14:32.758000', '2023-04-21 10:14:32.758000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3980D5640FFAE9078C4CF04A9121D161', '2023-04-21 10:14:33.042000', '2023-04-21 10:14:33.042000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-098', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '3B320145487F267008ED34333FEBAC89', '2023-04-21 17:17:23.951000', '2023-04-21 17:17:23.951000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-49', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3B4BCA9A53FFF6D7C6E0C851F6C7EB25', '2023-04-21 10:14:32.291000', '2023-04-21 10:14:32.291000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3B9004A80A1DBACB89D2E3CBA49EC984', '2023-04-21 10:14:33.180000', '2023-04-21 10:14:33.180000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-63', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3BE507FD8DA0A9C08BE6258BF83B395D', '2023-04-21 10:14:32.321000', '2023-04-21 10:14:32.321000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3D2C11132ABDB805E8D64B0A885E2FA5', '2023-04-21 10:14:32.409000', '2023-04-21 10:14:32.409000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3D31B1266D9336A44CE0686E0F8617CD', '2023-04-21 10:14:32.462000', '2023-04-21 10:14:32.462000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-078', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '3DA78683E6676D812FFF64EA6480CA78', '2023-04-21 17:17:23.890000', '2023-04-21 17:17:23.890000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3EA7517E5B3F280A16D09B45FE862CC3', '2023-04-21 10:14:32.600000', '2023-04-21 10:14:32.600000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-008', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '3EAB51E5F08FAC8E0BDAA20CC639E3D3', '2023-04-21 15:12:16.309000', '2023-04-21 15:12:16.309000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-93', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3EECE5188B17C5B5EFE31AC047389AA8', '2023-04-21 10:14:32.391000', '2023-04-21 10:14:32.391000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-11', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3F0EBDD9DF23F03AE597D99228D6EA2D', '2023-04-21 10:14:32.208000', '2023-04-21 10:14:32.208000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-87', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3F22159AC928348970AF2B2D98146057', '2023-04-21 10:14:32.375000', '2023-04-21 10:14:32.375000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '3F305E23013D3F8A0D5072B79E1B3006', '2023-04-21 10:14:32.730000', '2023-04-21 10:14:32.730000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '404DBC6BED88CE6C75980D97AA3B1345', '2023-04-21 10:14:33.091000', '2023-04-21 10:14:33.091000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '41610CF6B8F57317314BFA3C70B65B10', '2023-04-21 10:14:32.840000', '2023-04-21 10:14:32.840000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '424289AA477E34C9A4A2FDE7D723692C', '2023-04-21 10:14:33.276000', '2023-04-21 10:14:33.276000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-063', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '43FCC0EAA17880B3D6BFB1EA62916BBD', '2023-04-21 17:17:23.839000', '2023-04-21 17:17:23.839000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-089', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '4462471D842E7DD688589806F19BACC4', '2023-04-21 17:17:23.925000', '2023-04-21 17:17:23.925000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-54', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '44D8FE168684448EAE231A2E49D2F684', '2023-04-21 10:14:32.301000', '2023-04-21 10:14:32.301000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '45390ECA2FE46141C72764C3E03EB212', '2023-04-21 10:14:32.763000', '2023-04-21 10:14:32.763000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-68', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4619FABB6D8515EAC27B70BAED6AB47A', '2023-04-21 10:14:32.331000', '2023-04-21 10:14:32.331000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4666A5FCB9176B9BE6DE0A38A59A16E9', '2023-04-21 10:14:32.424000', '2023-04-21 10:14:32.424000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '478C5D5A456E0AB3386215D3C49B1083', '2023-04-21 10:14:32.670000', '2023-04-21 10:14:32.670000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-04', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '48227B5896079A9627EF99E876EE98A5', '2023-04-21 10:14:32.191000', '2023-04-21 10:14:32.191000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4828D213888EEB08F23A1F2CDBC4E820', '2023-04-21 10:14:33.068000', '2023-04-21 10:14:33.068000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4848E14F804FEE2D499A3BBD84C177AA', '2023-04-21 10:14:32.488000', '2023-04-21 10:14:32.488000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-032', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '49DDA3FFC45B2F4CE64C7E494DF49AA6', '2023-04-21 15:12:16.350000', '2023-04-21 15:12:16.350000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-74', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4A69CD62226A421E1C7FBDAFEF5CCD7E', '2023-04-21 10:14:32.345000', '2023-04-21 10:14:32.345000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4C718B90C82DAE2010932065622E4272', '2023-04-21 10:14:33.304000', '2023-04-21 10:14:33.304000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4D075F83496481D035F0B7AD52A2FAF9', '2023-04-21 10:14:32.844000', '2023-04-21 10:14:32.844000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4D56D0B3E052F7B4F2965403F8FE8612', '2023-04-21 10:14:33.339000', '2023-04-21 10:14:33.339000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-57', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4D6EA17EF8EF9C88BA88D75407DB259B', '2023-04-21 10:14:32.308000', '2023-04-21 10:14:32.308000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4E1B2A2A286A89EE5FA0457BCC075C74', '2023-04-21 10:14:32.970000', '2023-04-21 10:14:32.970000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4EB896DFED4D088737F0DC43DF584848', '2023-04-21 10:14:32.904000', '2023-04-21 10:14:32.904000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-25', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '4ED13BE027D96934FB5092EE712877C9', '2023-04-21 10:14:32.238000', '2023-04-21 10:14:32.238000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '50957DFD692E6A1B70FDD1AD63AE1AC5', '2023-04-21 10:14:33.259000', '2023-04-21 10:14:33.259000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '51A74BD1098823B00534D8FFD9C031A3', '2023-04-21 10:14:32.787000', '2023-04-21 10:14:32.787000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '51F62395E537CA4576873ECC82FCC64A', '2023-04-21 10:14:33.236000', '2023-04-21 10:14:33.236000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-024', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '51FF92B56D2DA4E9522A87BB28C6D908', '2023-04-21 15:12:16.336000', '2023-04-21 15:12:16.336000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-020', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '526B66A961347F05BAC8F3D1FE8207B3', '2023-04-21 15:12:16.329000', '2023-04-21 15:12:16.329000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '5277EC9A69B11E513F6A26F71E554C42', '2023-04-21 10:14:32.914000', '2023-04-21 10:14:32.914000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-45', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '529584C6950D4BFAA6E66041AC608F17', '2023-04-21 10:14:32.282000', '2023-04-21 10:14:32.282000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '540F08A7AB47809F61065C355B57000A', '2023-04-21 10:14:32.538000', '2023-04-21 10:14:32.538000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '541512323D45D86C4EC88A78D4C6206B', '2023-04-21 10:14:32.570000', '2023-04-21 10:14:32.570000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '542142EF84312BCB973641E6A9C76CE8', '2023-04-21 10:14:32.483000', '2023-04-21 10:14:32.483000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-01', 'E394DF6CB798A925D4C79F51544E1A73', '17C258BFB79DDCED5A2F950BADA7004A', '55F3F49AC4103CBD536FD281D3FB4064', '2023-04-21 10:14:32.162000', '2023-04-21 10:14:32.162000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-007', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '5650270F2500F1BCF549D64008701F95', '2023-04-21 15:12:16.307000', '2023-04-21 15:12:16.307000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-03', 'E394DF6CB798A925D4C79F51544E1A73', '17C258BFB79DDCED5A2F950BADA7004A', '5898CF8E4A0484DCE1CC7A98DE04E145', '2023-04-21 10:14:32.168000', '2023-04-21 10:14:32.168000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-071', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '58C61DE37278BFBE2531347DEFDBD295', '2023-04-21 17:17:23.866000', '2023-04-21 17:17:23.866000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '5AF3D0046F5E966FE31712DFFA1B0587', '2023-04-21 10:14:33.101000', '2023-04-21 10:14:33.101000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '5B1ADAC4028430E55770BFD540C3DB66', '2023-04-21 10:14:32.496000', '2023-04-21 10:14:32.496000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '5C7DF43F7F7751894C0F38CA8808D572', '2023-04-21 10:14:33.191000', '2023-04-21 10:14:33.191000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '5CCBEC4CB8CBA1D767E4AB151134D739', '2023-04-21 10:14:32.411000', '2023-04-21 10:14:32.411000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-033', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '5D817D3497948DB401ABDED4FD07147C', '2023-04-21 15:12:16.352000', '2023-04-21 15:12:16.352000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '5E8892B2EB4813DCF79EE36A97530D38', '2023-04-21 10:14:33.170000', '2023-04-21 10:14:33.170000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-048', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '5F4431C75BA458A92CA5E95386A22A45', '2023-04-21 17:17:23.784000', '2023-04-21 17:17:23.784000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-057', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '6018B663C80109738FAAF5D9B9C6F6EF', '2023-04-21 17:17:23.817000', '2023-04-21 17:17:23.817000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-41', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '60C1AD2CBEFE95A2F12296108B64DB88', '2023-04-21 10:14:32.273000', '2023-04-21 10:14:32.273000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-67', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6175EF79927A806328E87ED686A7C92D', '2023-04-21 10:14:32.329000', '2023-04-21 10:14:32.329000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-52', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '619B6385D596512B70850BDF66CBA64A', '2023-04-21 10:14:32.297000', '2023-04-21 10:14:32.297000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '63B315B12C3B66299250E926AEB5910C', '2023-04-21 10:14:32.874000', '2023-04-21 10:14:32.874000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '63F7E8E54E194452AD23DC5422B316A3', '2023-04-21 10:14:32.532000', '2023-04-21 10:14:32.532000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '643F030C121C94F4B651071202B3BAE0', '2023-04-21 10:14:32.450000', '2023-04-21 10:14:32.450000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-70', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '64CD891353497BA97C014CA1345A5563', '2023-04-21 10:14:32.335000', '2023-04-21 10:14:32.335000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6614473D4D4328D43D7244B1BBC0EAB0', '2023-04-21 10:14:32.739000', '2023-04-21 10:14:32.739000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '663DD2F4750B737EF8CE5E6A44D33EB9', '2023-04-21 10:14:32.535000', '2023-04-21 10:14:32.535000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-40', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '68259CEE3F99962EBE6FF84B3489D0F1', '2023-04-21 10:14:32.271000', '2023-04-21 10:14:32.271000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '685C2C37132B34577395222394C1EDAF', '2023-04-21 10:14:32.815000', '2023-04-21 10:14:32.815000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6AA8AB9F934EBB6FCB988CD3578EBD32', '2023-04-21 10:14:32.637000', '2023-04-21 10:14:32.637000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6B32217F9B7F56DAD728C19473CF18A7', '2023-04-21 10:14:32.703000', '2023-04-21 10:14:32.703000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-097', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '6B81033177FE4FBE3297F720CD04FCF9', '2023-04-21 17:17:23.948000', '2023-04-21 17:17:23.948000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6B9E72571279B9F820BEE8F94C38CBAB', '2023-04-21 10:14:32.749000', '2023-04-21 10:14:32.749000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-71', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6BF9E801AFB2DD3F725FE2C32DB8F8E0', '2023-04-21 10:14:32.337000', '2023-04-21 10:14:32.337000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-42', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6C8F0AB35460F0B602B43C64EE0ECB2A', '2023-04-21 10:14:32.276000', '2023-04-21 10:14:32.276000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-85', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6D46CBF47BC31931290B6C3E38999663', '2023-04-21 10:14:32.370000', '2023-04-21 10:14:32.370000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6D84B03097AEC289390762374E971225', '2023-04-21 10:14:32.777000', '2023-04-21 10:14:32.777000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6E4054D22E5FBAE7C9DE5B0665BDF06A', '2023-04-21 10:14:32.573000', '2023-04-21 10:14:32.573000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6E5CAA319F14C34599753131C2FE2800', '2023-04-21 10:14:33.374000', '2023-04-21 10:14:33.374000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-077', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '6EE8206C5E870B56FE46CA9C94FF67F1', '2023-04-21 17:17:23.886000', '2023-04-21 17:17:23.886000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-07', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6F00FF07236001449CA5A334FDB64B8B', '2023-04-21 10:14:32.199000', '2023-04-21 10:14:32.199000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '6F98F238C5F1F16D8E0030120FF3BEA1', '2023-04-21 10:14:32.585000', '2023-04-21 10:14:32.585000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '704511095790E0B8CE4D6F8FD6620143', '2023-04-21 10:14:33.037000', '2023-04-21 10:14:33.037000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '705C4398C755B61E536E269446B29E51', '2023-04-21 10:14:32.925000', '2023-04-21 10:14:32.925000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7062D565E960BB16F6D201E9F2936161', '2023-04-21 10:14:32.510000', '2023-04-21 10:14:32.510000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '70D78B827869444A0F22D64F3A2AC3EC', '2023-04-21 10:14:33.053000', '2023-04-21 10:14:33.053000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-75', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '71810F6BDE6DED961DFBBAC3C2B5D745', '2023-04-21 10:14:32.347000', '2023-04-21 10:14:32.347000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '72FB4D53305C3E3126BD636D2C457FC8', '2023-04-21 10:14:32.895000', '2023-04-21 10:14:32.895000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7320F52E893041D1B02924A792B0DDA7', '2023-04-21 10:14:32.996000', '2023-04-21 10:14:32.996000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-046', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '75091BC299D32428E91C1335E896E433', '2023-04-21 17:17:23.774000', '2023-04-21 17:17:23.774000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-39', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '75125A0DAF4265184E552DAF9139BA6D', '2023-04-21 10:14:32.268000', '2023-04-21 10:14:32.268000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-35', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '75598477152259A86B514D0E570B6E74', '2023-04-21 10:14:32.261000', '2023-04-21 10:14:32.261000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-94', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '77EAF7E2786ABA64AD471991C9C5DD70', '2023-04-21 10:14:32.393000', '2023-04-21 10:14:32.393000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '788395750D50861A753590CCE9785C42', '2023-04-21 10:14:32.505000', '2023-04-21 10:14:32.505000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '78C3A536978FE410AF61766F7775A545', '2023-04-21 10:14:32.616000', '2023-04-21 10:14:32.616000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '79137FE0960C8549259A0F308510DA73', '2023-04-21 10:14:32.613000', '2023-04-21 10:14:32.613000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-81', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7A8D817D623AEAD6D1B9C34ADC85C5A2', '2023-04-21 10:14:32.360000', '2023-04-21 10:14:32.360000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-081', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '7AD7BA3CAAF876821215F46A0DA288C8', '2023-04-21 17:17:23.900000', '2023-04-21 17:17:23.900000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-37', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7C198A6CAC382C37E87F92EF8E763260', '2023-04-21 10:14:32.265000', '2023-04-21 10:14:32.265000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-091', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '7C4302839052E50D02646D74BE73311B', '2023-04-21 17:17:23.930000', '2023-04-21 17:17:23.930000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7CCF5425A61DE3C42E25A10EB12EA0FD', '2023-04-21 10:14:32.453000', '2023-04-21 10:14:32.453000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-96', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7D7A65608E5CFE12D24CD5511DC3ED7F', '2023-04-21 10:14:32.399000', '2023-04-21 10:14:32.399000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7F57338722C883CE3AE0EC24BA8FEDD6', '2023-04-21 10:14:32.421000', '2023-04-21 10:14:32.421000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-59', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7F73913EF4F5A1949367E603768E71C8', '2023-04-21 10:14:32.313000', '2023-04-21 10:14:32.313000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7FA9E36A2949F3B8C94D245503057817', '2023-04-21 10:14:32.597000', '2023-04-21 10:14:32.597000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '7FF53E4C0E978DF36381E2B6BAF26D34', '2023-04-21 10:14:32.480000', '2023-04-21 10:14:32.480000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '80DEAC458A23E70A4DA3FC444ED752DC', '2023-04-21 10:14:33.153000', '2023-04-21 10:14:33.153000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '81B30955A0E7DAC2F9E00DDB0B5BEBD8', '2023-04-21 10:14:32.591000', '2023-04-21 10:14:32.591000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '821B7AFC00820C876FFC330B90AEEE83', '2023-04-21 10:14:32.619000', '2023-04-21 10:14:32.619000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-28', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '826D9C6145BAA27B7470416B390698B3', '2023-04-21 10:14:32.245000', '2023-04-21 10:14:32.245000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '82D18DDF98FCB619ABF8779E818EB0BF', '2023-04-21 10:14:32.564000', '2023-04-21 10:14:32.564000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-079', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '82E89F3800D0C3FF717248EE91A859D0', '2023-04-21 17:17:23.893000', '2023-04-21 17:17:23.893000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8339FBE49EFE1787D89BCAE4D14E1CA8', '2023-04-21 10:14:33.225000', '2023-04-21 10:14:33.225000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8390E5CCF727F8C8A3C71D173640BE88', '2023-04-21 10:14:33.085000', '2023-04-21 10:14:33.085000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '83C06B9829DAFAC541E9EF98F046C0CD', '2023-04-21 10:14:32.543000', '2023-04-21 10:14:32.543000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-26', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '841C92BE4600C4BDE57D3C0ECE76AD70', '2023-04-21 10:14:32.240000', '2023-04-21 10:14:32.240000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-036', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '843E1FD502F3BC70C71288A00436AA86', '2023-04-21 15:12:16.357000', '2023-04-21 15:12:16.357000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-049', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '8468612C9A3F4C8936640ADC9C02639C', '2023-04-21 17:17:23.788000', '2023-04-21 17:17:23.788000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-095', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '8504475B8E4B9B29836859DFDD702E29', '2023-04-21 17:17:23.942000', '2023-04-21 17:17:23.942000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-12', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '853C9FDE9D741098AFD2C56E15385293', '2023-04-21 10:14:32.210000', '2023-04-21 10:14:32.210000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '85B1A87662D7A7CF6659B3EA402FAEBF', '2023-04-21 10:14:32.546000', '2023-04-21 10:14:32.546000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-003', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '86B4959AF8DFF58F3D80CFA03FC3875D', '2023-04-21 15:12:16.299000', '2023-04-21 15:12:16.299000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '86E1A173DAF9E63F82C6BA8FBF9E08EF', '2023-04-21 10:14:32.622000', '2023-04-21 10:14:32.622000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-082', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '86E979CA92A6C3010888E8017EAF7554', '2023-04-21 17:17:23.903000', '2023-04-21 17:17:23.903000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '87ACB773B5BABC85D5651BFB56F377EC', '2023-04-21 10:14:32.475000', '2023-04-21 10:14:32.475000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8972FB004DAFF0B57892E68D743EA96E', '2023-04-21 10:14:32.631000', '2023-04-21 10:14:32.631000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8986F455AE0CDF998E4D900C15385740', '2023-04-21 10:14:32.567000', '2023-04-21 10:14:32.567000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-027', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '8A0BB3723C38C617D87A4640305B9CAC', '2023-04-21 15:12:16.341000', '2023-04-21 15:12:16.341000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-009', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '8A2845A3ABA1E9DB5C71E8F9BB594731', '2023-04-21 15:12:16.311000', '2023-04-21 15:12:16.311000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-84', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8A4EA6F5C9AC0C6D53B75E941F250651', '2023-04-21 10:14:32.368000', '2023-04-21 10:14:32.368000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8AA7316BF1643C5EF5166BBCEB46A9CD', '2023-04-21 10:14:32.900000', '2023-04-21 10:14:32.900000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-16', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8B31CC45EA73898934CE975A3EE150D3', '2023-04-21 10:14:32.220000', '2023-04-21 10:14:32.220000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-019', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '8BBCD5C2655EE039E0210A1739399320', '2023-04-21 15:12:16.328000', '2023-04-21 15:12:16.328000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-066', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '8BCC27F1B1700388C4CDA916FBEEB9EE', '2023-04-21 17:17:23.849000', '2023-04-21 17:17:23.849000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8C2CA1188D3945F56AB73B132520D116', '2023-04-21 10:14:33.208000', '2023-04-21 10:14:33.208000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8D553E3EF3F58E6E09409972020DBDE2', '2023-04-21 10:14:32.713000', '2023-04-21 10:14:32.713000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8D6386BE328E24B5DB49C7E169E26795', '2023-04-21 10:14:33.012000', '2023-04-21 10:14:33.012000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8E0378A549C3BB296F58C8F0229E74CA', '2023-04-21 10:14:33.362000', '2023-04-21 10:14:33.362000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-092', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '8E2043783A5ABEADC70C408C361AD838', '2023-04-21 17:17:23.933000', '2023-04-21 17:17:23.933000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8EAB64D35B7958FB71C57234350C1C81', '2023-04-21 10:14:32.427000', '2023-04-21 10:14:32.427000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-039', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '8EC0CABD64C288D575C0DC58E0A06D36', '2023-04-21 15:12:16.362000', '2023-04-21 15:12:16.362000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-58', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8F96951E5346DC9DA68F64F50232750D', '2023-04-21 10:14:32.311000', '2023-04-21 10:14:32.311000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '8FB8A8432612937C2E0B7286B8190732', '2023-04-21 10:14:32.985000', '2023-04-21 10:14:32.985000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-053', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '906CC32337119982751DFF2187885DD3', '2023-04-21 17:17:23.803000', '2023-04-21 17:17:23.803000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-010', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '913215F33AA8B7F4FA06C9B76C3000A2', '2023-04-21 15:12:16.312000', '2023-04-21 15:12:16.312000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-022', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '91D7D0B8E067BFB61A067106A7E2F351', '2023-04-21 15:12:16.332000', '2023-04-21 15:12:16.332000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-073', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '92497CA72046CC9EC15F0257011A6392', '2023-04-21 17:17:23.873000', '2023-04-21 17:17:23.873000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-087', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '947F699743A4F6B972EFBF8C377BB205', '2023-04-21 17:17:23.919000', '2023-04-21 17:17:23.919000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-06', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '94B6B1B84A6A161E2C246C5C8E36EC30', '2023-04-21 10:14:32.196000', '2023-04-21 10:14:32.196000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-21', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9529478F45268FDC19DDEED3291A0B80', '2023-04-21 10:14:32.230000', '2023-04-21 10:14:32.230000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '95AB785741A1E309BEC74FCF946AB37D', '2023-04-21 10:14:32.710000', '2023-04-21 10:14:32.710000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '964A13C9F548A910B5910215C60D39B4', '2023-04-21 10:14:33.270000', '2023-04-21 10:14:33.270000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '969A7D4C8A9295CDEFFB4821E1C2F3D2', '2023-04-21 10:14:32.437000', '2023-04-21 10:14:32.437000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-016', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '9874E2FB7F887E3F47B1E746F1E77F4D', '2023-04-21 15:12:16.323000', '2023-04-21 15:12:16.323000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-017', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '9879B6B65AE20086C8318F646578F337', '2023-04-21 15:12:16.324000', '2023-04-21 15:12:16.324000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '987C7551293236A8DD6894896C42F70A', '2023-04-21 10:14:32.801000', '2023-04-21 10:14:32.801000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-10', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '98C9D75AEECDB7174CE20ACCFA3EA4C6', '2023-04-21 10:14:32.206000', '2023-04-21 10:14:32.206000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '98D520AFAFA7A95C80DF5F80514C575A', '2023-04-21 10:14:32.980000', '2023-04-21 10:14:32.980000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9A2C86300537EFAA93EAEEF8D22BB18A', '2023-04-21 10:14:32.753000', '2023-04-21 10:14:32.753000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-92', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9A95F842E615D0B91D335322B6D09780', '2023-04-21 10:14:32.388000', '2023-04-21 10:14:32.388000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9ABEE6B02E9497E3A313B670DC38F730', '2023-04-21 10:14:33.137000', '2023-04-21 10:14:33.137000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-62', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9AE72A30350BB967A51DAFD8FD0D986B', '2023-04-21 10:14:32.319000', '2023-04-21 10:14:32.319000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9B348630BC83C9DE04EA67E21C8E0F27', '2023-04-21 10:14:33.322000', '2023-04-21 10:14:33.322000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-51', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9B684A46D9AFD0781618CFBCA9329B47', '2023-04-21 10:14:32.295000', '2023-04-21 10:14:32.295000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-013', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '9BCB4B51BB81214565F55F53FFBC76E6', '2023-04-21 15:12:16.317000', '2023-04-21 15:12:16.317000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9BE770440CE3535F4A3DE257B2EEF829', '2023-04-21 10:14:32.946000', '2023-04-21 10:14:32.946000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', '9C6B9DF2027986960BEBC04103A26258', '2023-04-21 10:14:33.058000', '2023-04-21 10:14:33.058000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-064', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '9CCED9D7026E5D5A93500A645101E513', '2023-04-21 17:17:23.843000', '2023-04-21 17:17:23.843000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-040', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '9CD140C2313C2743876EBAD5E8A669A4', '2023-04-21 15:12:16.365000', '2023-04-21 15:12:16.365000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-021', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', '9D9EDFE72E8FA21F5F4D80DA80A7A723', '2023-04-21 15:12:16.331000', '2023-04-21 15:12:16.331000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-076', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', '9E7598E096A007385B9F56743474C835', '2023-04-21 17:17:23.883000', '2023-04-21 17:17:23.883000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A0D690939614C04D22F80C0F481088F8', '2023-04-21 10:14:32.791000', '2023-04-21 10:14:32.791000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A1EB7E4BD84E67C3DE996ACE1F019C69', '2023-04-21 10:14:32.717000', '2023-04-21 10:14:32.717000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-43', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A316E3246BBD2279394FBA8FF97A3933', '2023-04-21 10:14:32.278000', '2023-04-21 10:14:32.278000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A3403560C7AA5EA2062AEB59731A62E0', '2023-04-21 10:14:33.121000', '2023-04-21 10:14:33.121000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A34C2FE521FFC65FE1FE044CE34397D2', '2023-04-21 10:14:33.132000', '2023-04-21 10:14:33.132000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A43460CD3E0EA4EEFDD38EA956B643D4', '2023-04-21 10:14:33.079000', '2023-04-21 10:14:33.079000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-29', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A572D43402000FA05E547DF2E7E0AA02', '2023-04-21 10:14:32.247000', '2023-04-21 10:14:32.247000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A5A0DCB4C663D6B7AD9B69236F213BDF', '2023-04-21 10:14:32.696000', '2023-04-21 10:14:32.696000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A71A1032603FB28BCBF122BF66698EDB', '2023-04-21 10:14:33.197000', '2023-04-21 10:14:33.197000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A7D9E771F1D3BD4C6D956487A97FB891', '2023-04-21 10:14:33.287000', '2023-04-21 10:14:33.287000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-002', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'A8988BAF9BE7AE14EDEDA64A65E12CD8', '2023-04-21 15:12:16.297000', '2023-04-21 15:12:16.297000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-46', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A95FE30CA0550E8F8F6C7DDDC46E0CE7', '2023-04-21 10:14:32.284000', '2023-04-21 10:14:32.284000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'A9A3CE38F069F3012C6E06418707EFED', '2023-04-21 10:14:33.017000', '2023-04-21 10:14:33.017000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AA657BE7F197F0A9100436E7B421C878', '2023-04-21 10:14:33.327000', '2023-04-21 10:14:33.327000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AB0184FFBEDF2AF12622189D31EA4514', '2023-04-21 10:14:32.518000', '2023-04-21 10:14:32.518000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'ABE195434D67974755B7186B2871A71C', '2023-04-21 10:14:32.735000', '2023-04-21 10:14:32.735000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-041', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'AD910B46B05E5D83554C4A8F7F42964C', '2023-04-21 15:12:16.366000', '2023-04-21 15:12:16.366000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AE69BDA3B18EAD180D469AB97BBAC8FE', '2023-04-21 10:14:33.231000', '2023-04-21 10:14:33.231000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AE72E0D5C49F36B183CA315CEC5B9991', '2023-04-21 10:14:32.849000', '2023-04-21 10:14:32.849000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AF268E3ECFFA95C31CBE83B0D683D44C', '2023-04-21 10:14:32.582000', '2023-04-21 10:14:32.582000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AF37FDE91C9F5EEA4D6C8A4A41D9DB76', '2023-04-21 10:14:33.164000', '2023-04-21 10:14:33.164000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-89', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AF705E35064671CA2755F748C10EA3F9', '2023-04-21 10:14:32.380000', '2023-04-21 10:14:32.380000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AF77B4C2ABA26E4B99171137938F5483', '2023-04-21 10:14:33.242000', '2023-04-21 10:14:33.242000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'AFFDB3274A38EE18C96F0DE2200BFCDB', '2023-04-21 10:14:32.772000', '2023-04-21 10:14:32.772000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-91', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B0A9224B0C2E7802F4A6A98709A82F51', '2023-04-21 10:14:32.385000', '2023-04-21 10:14:32.385000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B0CD1BBEF0239A9CC8F2A2430489D9B0', '2023-04-21 10:14:32.444000', '2023-04-21 10:14:32.444000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-05', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B23672BF065B5B7DCCB23BEED6E32EFC', '2023-04-21 10:14:32.193000', '2023-04-21 10:14:32.193000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-004', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'B34AD764C8DAA2C43BCE7BF0953DE63B', '2023-04-21 15:12:16.301000', '2023-04-21 15:12:16.301000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-65', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B3DE338BBDD8E6BC58F7E3D2CB1A41C1', '2023-04-21 10:14:32.325000', '2023-04-21 10:14:32.325000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B3F31CFD73D69730E90C0FCFC50CFBF1', '2023-04-21 10:14:32.513000', '2023-04-21 10:14:32.513000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B451405EA0DA44F71B7CFCDA4150F00E', '2023-04-21 10:14:32.579000', '2023-04-21 10:14:32.579000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-33', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B50A470613B753B7433D12AE68F4D2DD', '2023-04-21 10:14:32.257000', '2023-04-21 10:14:32.257000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B546C0D505DFA70F042FDBD1FB79AF3C', '2023-04-21 10:14:33.345000', '2023-04-21 10:14:33.345000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B56BE141384D9FD6081AB4D12FFAED1F', '2023-04-21 10:14:33.356000', '2023-04-21 10:14:33.356000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-02', 'E394DF6CB798A925D4C79F51544E1A73', '17C258BFB79DDCED5A2F950BADA7004A', 'B6070DD660CAE8AB09A0708470E8A1AD', '2023-04-21 10:14:32.165000', '2023-04-21 10:14:32.165000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-023', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'B6667FA58544AB186ECFFEA322A77E59', '2023-04-21 15:12:16.334000', '2023-04-21 15:12:16.334000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-026', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'B755B63C5D101F62C704D8E31F1793CE', '2023-04-21 15:12:16.339000', '2023-04-21 15:12:16.339000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B7A5A9F2327FB8EB98408988D46D6D8B', '2023-04-21 10:14:32.593000', '2023-04-21 10:14:32.593000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-058', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'B7CA5735837021B2AEF681A57867DEE1', '2023-04-21 17:17:23.821000', '2023-04-21 17:17:23.821000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B94AD44AFE85AAADEBF2286641AAAB80', '2023-04-21 10:14:32.527000', '2023-04-21 10:14:32.527000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B9B8E0AB8A484A74258544FC0B02BDFD', '2023-04-21 10:14:32.835000', '2023-04-21 10:14:32.835000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'B9DF71A3C9722F587ECCCBB76F48B48B', '2023-04-21 10:14:33.265000', '2023-04-21 10:14:33.265000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-075', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'BA517EF4B7070BED437377FA92D238E4', '2023-04-21 17:17:23.880000', '2023-04-21 17:17:23.880000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'BA94C7F5F551C3672550D3D4313908C8', '2023-04-21 10:14:33.282000', '2023-04-21 10:14:33.282000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-14', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'BB53FBA1F4A980257C61937288C326D9', '2023-04-21 10:14:32.215000', '2023-04-21 10:14:32.215000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-060', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'BB70D774BC2159076E28F5167C17B4E8', '2023-04-21 17:17:23.828000', '2023-04-21 17:17:23.828000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'BC27CE06629B3E855A7E1AD80011524F', '2023-04-21 10:14:32.470000', '2023-04-21 10:14:32.470000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'BCE89BA31DB7DABD5B80B60C92AD2605', '2023-04-21 10:14:33.027000', '2023-04-21 10:14:33.027000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-084', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'BD4EC7EFD67C5B094A92D97E93D3A234', '2023-04-21 17:17:23.910000', '2023-04-21 17:17:23.910000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C080177D8D77B86297FBD1AA28DBF0B1', '2023-04-21 10:14:33.096000', '2023-04-21 10:14:33.096000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-86', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C1F4FC21752E6B6C93AD60767D1D54CA', '2023-04-21 10:14:32.372000', '2023-04-21 10:14:32.372000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C2B6B2F539EEBA72999A78CFA23E0567', '2023-04-21 10:14:33.248000', '2023-04-21 10:14:33.248000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-085', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'C365432B4035B68A3D336167CBDAC384', '2023-04-21 17:17:23.913000', '2023-04-21 17:17:23.913000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-030', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'C3A457F5B414ABC8DDA8B0619517410E', '2023-04-21 15:12:16.346000', '2023-04-21 15:12:16.346000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-90', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C4D4A1995A19811FCD06BD9710912AF4', '2023-04-21 10:14:32.383000', '2023-04-21 10:14:32.383000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-23', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C51CA4C7283A25BE7D58FEBC7DD23D1C', '2023-04-21 10:14:32.234000', '2023-04-21 10:14:32.234000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C5E4A52D486567208A7FCB9A3F90ECBB', '2023-04-21 10:14:33.022000', '2023-04-21 10:14:33.022000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-074', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'C6159E8FBE28174976F2B04D36070025', '2023-04-21 17:17:23.876000', '2023-04-21 17:17:23.876000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-83', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C6C7EA0044CCEB85E04A49BFDB841B15', '2023-04-21 10:14:32.365000', '2023-04-21 10:14:32.365000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-36', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C71B80EAB7827674A51719ADB0E31B59', '2023-04-21 10:14:32.263000', '2023-04-21 10:14:32.263000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C748B3DC46517037C3211F2C08D16B85', '2023-04-21 10:14:32.829000', '2023-04-21 10:14:32.829000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C74FAC8D266F0750475B9291AD47DEA0', '2023-04-21 10:14:32.477000', '2023-04-21 10:14:32.477000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-88', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C78F4C4F092568AE7B8979600690DB46', '2023-04-21 10:14:32.377000', '2023-04-21 10:14:32.377000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-014', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'C84C5DBE34954CA18A183A43840461F4', '2023-04-21 15:12:16.319000', '2023-04-21 15:12:16.319000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C8CD9EA27E8A8205D9B3C4FA3582269B', '2023-04-21 10:14:32.521000', '2023-04-21 10:14:32.521000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C8D8FD58DF5E88DC68C3BC6A485887FE', '2023-04-21 10:14:32.810000', '2023-04-21 10:14:32.810000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-09', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'C8F321DD662F20BD3C49AFB474F99FBA', '2023-04-21 10:14:32.204000', '2023-04-21 10:14:32.204000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CB228B034CDE1AC6CA1C58E30F5D620B', '2023-04-21 10:14:33.159000', '2023-04-21 10:14:33.159000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CB8694F3B2F9D45EF0633BDB5764AE1F', '2023-04-21 10:14:32.625000', '2023-04-21 10:14:32.625000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CBBE819FB3BB4B14D148E3DA03FC1B6D', '2023-04-21 10:14:32.459000', '2023-04-21 10:14:32.459000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CBEAE666C98E0C54BCA3EDF1F825B4D1', '2023-04-21 10:14:33.202000', '2023-04-21 10:14:33.202000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CCD0CCE0207BDEE50C26C3F81F94F9F6', '2023-04-21 10:14:33.111000', '2023-04-21 10:14:33.111000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-13', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CD544726A73292E2C0E944F6533486B5', '2023-04-21 10:14:32.213000', '2023-04-21 10:14:32.213000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CDA21AD8BD3E28C00872A3DFA915AA47', '2023-04-21 10:14:32.782000', '2023-04-21 10:14:32.782000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CDCC285B0817A045B46678F1A9126BE5', '2023-04-21 10:14:32.673000', '2023-04-21 10:14:32.673000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-059', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'CE0EB21B8A182FB8EAE18D12BFF9966D', '2023-04-21 17:17:23.824000', '2023-04-21 17:17:23.824000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CE6D1CBBD773BAA2EEE6487BA4CCBCAC', '2023-04-21 10:14:32.507000', '2023-04-21 10:14:32.507000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-56', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CEA2B86403B8492C7A80184FD8586339', '2023-04-21 10:14:32.305000', '2023-04-21 10:14:32.305000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CF3E660376EB23B9B13721C1CBA2A8F8', '2023-04-21 10:14:32.655000', '2023-04-21 10:14:32.655000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-34', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'CFB0EF2ECDCA6259BE3186D6605559D6', '2023-04-21 10:14:32.259000', '2023-04-21 10:14:32.259000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D0D239C2B71886F825F8F6D4D88B7F37', '2023-04-21 10:14:32.663000', '2023-04-21 10:14:32.663000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D13F02FCB6DC314B28973262708F47BA', '2023-04-21 10:14:32.659000', '2023-04-21 10:14:32.659000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-028', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'D16A3B51E5138D128C2EC1BEFAA81074', '2023-04-21 15:12:16.342000', '2023-04-21 15:12:16.342000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D2BB57CA0B8DB8DDDD9D7C4C83CE8475', '2023-04-21 10:14:32.558000', '2023-04-21 10:14:32.558000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D45A28A22A5859F6CF77271B69CF105A', '2023-04-21 10:14:32.859000', '2023-04-21 10:14:32.859000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-32', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D5148AFB1D53F48F3A234368E6A97212', '2023-04-21 10:14:32.255000', '2023-04-21 10:14:32.255000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D567EE535B9A1D8AFDCA33C1B59A3724', '2023-04-21 10:14:33.298000', '2023-04-21 10:14:33.298000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D595B33BB017152DE6A52FC57CEF632F', '2023-04-21 10:14:32.447000', '2023-04-21 10:14:32.447000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D5BF2A1C1BA219335212B579A2B73798', '2023-04-21 10:14:32.442000', '2023-04-21 10:14:32.442000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-95', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D73AB013E992113D50A4B0BAFEC6D82C', '2023-04-21 10:14:32.396000', '2023-04-21 10:14:32.396000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-79', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D7B70FA169D204E30EFCBBC098E21A4C', '2023-04-21 10:14:32.356000', '2023-04-21 10:14:32.356000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-98', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D7FE53838FADD83E11EB53C468C28376', '2023-04-21 10:14:32.404000', '2023-04-21 10:14:32.404000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'D85FF4D18236D5F3BA206F6E4635BC6F', '2023-04-21 10:14:32.499000', '2023-04-21 10:14:32.499000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-045', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'D88315007320B85744167D15F809DE4B', '2023-04-21 15:12:16.374000', '2023-04-21 15:12:16.374000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-012', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'DA0C446DC948674086F8529C6C41DA8E', '2023-04-21 15:12:16.315000', '2023-04-21 15:12:16.315000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'DAD014A655B08DCE370CD33F8D904681', '2023-04-21 10:14:33.214000', '2023-04-21 10:14:33.214000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-047', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'DBAC0D2AD67736F9044FCCE838CB7445', '2023-04-21 17:17:23.780000', '2023-04-21 17:17:23.780000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'DD1EB315BC963367B22088928AF3E67E', '2023-04-21 10:14:32.854000', '2023-04-21 10:14:32.854000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'DE6E8332E9D5A063064D4D89BF5100F7', '2023-04-21 10:14:33.316000', '2023-04-21 10:14:33.316000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-070', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'DF0103E7789E2A19B72034051BD29739', '2023-04-21 17:17:23.862000', '2023-04-21 17:17:23.862000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-044', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'DFB7E5AA967FD2582F68464CAC94F88E', '2023-04-21 15:12:16.372000', '2023-04-21 15:12:16.372000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-031', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'E0099969FE6DADFF338B970259A29103', '2023-04-21 15:12:16.348000', '2023-04-21 15:12:16.348000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E07DFFA6D34738C3CD9D6CE290602DC4', '2023-04-21 10:14:32.666000', '2023-04-21 10:14:32.666000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E0C1A6BD79F2395BBD226E7299372A35', '2023-04-21 10:14:32.456000', '2023-04-21 10:14:32.456000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E160B700FD7D0104B627AB865642907B', '2023-04-21 10:14:33.293000', '2023-04-21 10:14:33.293000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E174D19819A048FD6F28F87B76661A11', '2023-04-21 10:14:32.676000', '2023-04-21 10:14:32.676000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E1913C3ADA7B27E936FABC3EE35E7B9F', '2023-04-21 10:14:32.628000', '2023-04-21 10:14:32.628000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-056', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'E3D5B0B59336D6EF6B70597D9689ACA0', '2023-04-21 17:17:23.814000', '2023-04-21 17:17:23.814000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E482F288B2074F883BC9371F509DCC1B', '2023-04-21 10:14:32.700000', '2023-04-21 10:14:32.700000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E5073152DA2EABEFEC42EBE7BDDB86AF', '2023-04-21 10:14:32.419000', '2023-04-21 10:14:32.419000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E529DBCCC4A3AB4424EA090008278695', '2023-04-21 10:14:32.524000', '2023-04-21 10:14:32.524000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E5CFE891B906A9FF4C7CF07D03AF8616', '2023-04-21 10:14:32.552000', '2023-04-21 10:14:32.552000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-77', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E65B5B2BDD70E2F3A15D0217E088DEF1', '2023-04-21 10:14:32.352000', '2023-04-21 10:14:32.352000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E65E8E221D75FC4A3E29E02B5594BB3D', '2023-04-21 10:14:33.047000', '2023-04-21 10:14:33.047000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-31', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E6E223339F9E888B1A6C6E0D7D216421', '2023-04-21 10:14:32.252000', '2023-04-21 10:14:32.252000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E7E156AAD61826A68C337A46C059C9F9', '2023-04-21 10:14:32.645000', '2023-04-21 10:14:32.645000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-30', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E8D26CFAF6E49C5DB904124F9DA8F027', '2023-04-21 10:14:32.249000', '2023-04-21 10:14:32.249000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E8E0325B1972F34A6A36F50374B29C04', '2023-04-21 10:14:32.824000', '2023-04-21 10:14:32.824000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-24', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'E90B405683D1780DB6248E89C06BE8D6', '2023-04-21 10:14:32.236000', '2023-04-21 10:14:32.236000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EA673C72A11D8056BFA90FCE2E3F8DA5', '2023-04-21 10:14:32.869000', '2023-04-21 10:14:32.869000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-08', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EADB85F593701E3A8D601B93CEBD6AB6', '2023-04-21 10:14:32.201000', '2023-04-21 10:14:32.201000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EB7BA82BEF38F07CDCDF1D81D97C03BE', '2023-04-21 10:14:33.351000', '2023-04-21 10:14:33.351000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EB9E3E2EA354B8E0D8896577BFE8A924', '2023-04-21 10:14:32.806000', '2023-04-21 10:14:32.806000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EC53B6E33BF1DAF82E99C8F9D1EA71E3', '2023-04-21 10:14:32.439000', '2023-04-21 10:14:32.439000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'ED34C08A409CC43A774B34BDEDC58448', '2023-04-21 10:14:32.686000', '2023-04-21 10:14:32.686000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'ED96C276C641386E87E6447E89FB093B', '2023-04-21 10:14:32.889000', '2023-04-21 10:14:32.889000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EEC983A56ACD016B8B754C13EFE05551', '2023-04-21 10:14:32.434000', '2023-04-21 10:14:32.434000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-17', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EF488FB92F2663E2C15CDC2370AA2FE5', '2023-04-21 10:14:32.222000', '2023-04-21 10:14:32.222000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-067', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'EF4C41B8DFD99DA9659FB5475999D9D0', '2023-04-21 17:17:23.852000', '2023-04-21 17:17:23.852000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-55', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'EFFD4DCCC3B6D89E6916CC8FD150E660', '2023-04-21 10:14:32.303000', '2023-04-21 10:14:32.303000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F03DF6CDA0287D212F73FA118A4B095F', '2023-04-21 10:14:32.879000', '2023-04-21 10:14:32.879000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F06387DF70F540079B17138851130B7D', '2023-04-21 10:14:32.467000', '2023-04-21 10:14:32.467000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-005', '56BC02CC3C58F537A8289D142297A381', '5B307CF2ED7EB5620C04C224CBAE2F9B', 'F0D2CF2EA524311793921D7E563D8EFA', '2023-04-21 15:12:16.303000', '2023-04-21 15:12:16.303000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-19', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F10C477B6F926B19C6D81ED4A4F40639', '2023-04-21 10:14:32.226000', '2023-04-21 10:14:32.226000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-66', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F18B73A7EA64FF8941BA5BE15305932A', '2023-04-21 10:14:32.327000', '2023-04-21 10:14:32.327000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-82', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F230BBF94B27FCB570D7E799C4BC3C0F', '2023-04-21 10:14:32.363000', '2023-04-21 10:14:32.363000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-100', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'F2EEF1C21DF3CB45A27982C1003D0131', '2023-04-21 17:17:23.957000', '2023-04-21 17:17:23.957000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F38F620C3CC9E737E0F94DC1F7E1FF4C', '2023-04-21 10:14:33.074000', '2023-04-21 10:14:33.074000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-76', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F44E9886EBADF18D364AFEC687549993', '2023-04-21 10:14:32.349000', '2023-04-21 10:14:32.349000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F469C209493B7143E7577856C046C788', '2023-04-21 10:14:32.725000', '2023-04-21 10:14:32.725000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-094', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'F5305D671985858AADF0DD03EB564DD0', '2023-04-21 17:17:23.939000', '2023-04-21 17:17:23.939000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-052', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'F5BF41060B51480CF853D8C470944E43', '2023-04-21 17:17:23.799000', '2023-04-21 17:17:23.799000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dada-2023-1-096', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'F79900C3A9EBE3B2CC86315C6E3AC03D', '2023-04-21 17:17:23.945000', '2023-04-21 17:17:23.945000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F8C72567EAE2A176C5352950E8975C2D', '2023-04-21 10:14:33.126000', '2023-04-21 10:14:33.126000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-61', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F9688027E635BE32E1D427BE4D8AB76B', '2023-04-21 10:14:32.317000', '2023-04-21 10:14:32.317000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F9E238C89F3ABD9B0A43C3964C6D3410', '2023-04-21 10:14:32.885000', '2023-04-21 10:14:32.885000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'F9F2D3104CC22D484D26370477DE37A8', '2023-04-21 10:14:32.472000', '2023-04-21 10:14:32.472000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FAAEC5DDC261F5E87AFBA2E38E9FCA0A', '2023-04-21 10:14:33.368000', '2023-04-21 10:14:33.368000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FAB9AAD4A9AA07BEF105143D82F3EE0E', '2023-04-21 10:14:32.975000', '2023-04-21 10:14:32.975000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-080', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'FACAD7A0B1CFB76A875EF16B9DB03E6B', '2023-04-21 17:17:23.897000', '2023-04-21 17:17:23.897000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FC1721FDB4BCD55DA68918D00B13C814', '2023-04-21 10:14:32.641000', '2023-04-21 10:14:32.641000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-050', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'FD1D1EAD226E0BFA3AE3A25433FDA3AE', '2023-04-21 17:17:23.792000', '2023-04-21 17:17:23.792000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-47', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FD316AC1A5C8644526DF688E53ABF456', '2023-04-21 10:14:32.286000', '2023-04-21 10:14:32.286000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FE282C888D7FCC41979D4C4FBF3B8BB5', '2023-04-21 10:14:32.796000', '2023-04-21 10:14:32.796000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dama-2023-1-100', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FEA6E708135CC58F96F2CBB1321A31CA', '2023-04-21 10:14:32.464000', '2023-04-21 10:14:32.464000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');
INSERT INTO `reference_material` VALUES ('dada-2023-1-069', '56BC02CC3C58F537A8289D142297A381', 'A44E2FED4822B19246C3A1A94B65DE88', 'FF24726874EB347AAAD94869BDDB2329', '2023-04-21 17:17:23.859000', '2023-04-21 17:17:23.859000', '1', '1', 000000, '88FF175C8ACCF8B710C000C386765866');
INSERT INTO `reference_material` VALUES ('dama-2023-1-38', 'E394DF6CB798A925D4C79F51544E1A73', '35A44617B1CFB5722450DED4AE207056', 'FFF5EA412617843676EB0EF102BCE417', '2023-04-21 10:14:32.266000', '2023-04-21 10:14:32.266000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', 000000, 'BF9FE30FCF74CD8040BF7A7EAC53BBFC');

-- ----------------------------
-- Table structure for requisition_record
-- ----------------------------
DROP TABLE IF EXISTS `requisition_record`;
CREATE TABLE `requisition_record`  (
  `date_of_claim` datetime(6) NULL DEFAULT NULL COMMENT '(领用日期)',
  `recipient_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(领用人)',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `requisition_record_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `specification_and_model` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `drawing_amount` int(8) NULL DEFAULT NULL,
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`requisition_record_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材领用记录表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of requisition_record
-- ----------------------------

-- ----------------------------
-- Table structure for solution_use_form
-- ----------------------------
DROP TABLE IF EXISTS `solution_use_form`;
CREATE TABLE `solution_use_form`  (
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '溶液使用记录表\r\n',
  `solution_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `user_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `quantity_used` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `order_of_use` int(255) NULL DEFAULT NULL,
  `date_of_use` datetime(6) NULL DEFAULT NULL,
  `standard_material_application_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of solution_use_form
-- ----------------------------

-- ----------------------------
-- Table structure for standard_material_application
-- ----------------------------
DROP TABLE IF EXISTS `standard_material_application`;
CREATE TABLE `standard_material_application`  (
  `administrator_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质管理员ID)',
  `date_of_claim` datetime(6) NULL DEFAULT NULL COMMENT '(领用日期)',
  `date_of_return` datetime(6) NULL DEFAULT NULL COMMENT '(归还日期)',
  `purpose_and_quantity` varchar(6) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '使用数量',
  `recipient_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(领用人ID)',
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质编号)',
  `reference_substance_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质ID)',
  `requisitioned_quantity` int(11) NULL DEFAULT NULL COMMENT '(领用数量)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `serial_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(序号)',
  `specification` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(规格)',
  `standard_material_application_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `delivery_registration_form_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `requisition_record_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `storage_registration_form_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `claim_code` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `purpose` int(6) NULL DEFAULT NULL,
  `number` varchar(11) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `application_for_use_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` int(3) NULL DEFAULT NULL,
  `reference_material_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`standard_material_application_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准物质领用/归还登记表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of standard_material_application
-- ----------------------------
INSERT INTO `standard_material_application` VALUES (NULL, '2023-04-07 16:46:19.650000', '2023-04-07 17:14:55.216000', '0', '1', 'HW-2023-1-50', '942B1DF7A794395171D3175270A46464', 99, '2023-04-07 16:46:30.354000', '2023-04-07 17:14:55.224000', '1', '1', NULL, '固体', '1B730B57691272DD61C51D6EBF2F8A97', NULL, NULL, NULL, NULL, 0, NULL, 'CEFD859C6B7A997C4AE368794B5CD4DE', 1, NULL);
INSERT INTO `standard_material_application` VALUES (NULL, '2023-04-25 10:30:36.683000', NULL, NULL, 'BC1A096180973C5EA652C9787F5A155A', NULL, 'E394DF6CB798A925D4C79F51544E1A73', 99, '2023-04-25 10:30:36.702000', '2023-04-25 10:30:36.702000', '1', '1', NULL, 'dada', 'ADD4DFF410C841F4AC405FA37DFFB8EC', NULL, NULL, NULL, NULL, 0, NULL, 'D3B1A1A881E4F3CA1BB3CB1C7A8DF3F2', 0, '006658CBA49ADCA33E9EC27F2A28ECD7');
INSERT INTO `standard_material_application` VALUES (NULL, '2023-04-07 16:47:20.256000', NULL, NULL, '1', 'HW-2023-1-50', '942B1DF7A794395171D3175270A46464', 99, '2023-04-07 16:47:20.291000', '2023-04-07 16:47:20.291000', '1', '1', NULL, '固体', 'E6FE38073A150CCDFB2C2CA196273E04', NULL, NULL, NULL, NULL, 0, NULL, 'CEFD859C6B7A997C4AE368794B5CD4DE', 0, NULL);

-- ----------------------------
-- Table structure for standard_material_approval_form
-- ----------------------------
DROP TABLE IF EXISTS `standard_material_approval_form`;
CREATE TABLE `standard_material_approval_form`  (
  `agent_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(经办人)',
  `applicant_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(申请人)',
  `application_time` datetime(6) NULL DEFAULT NULL COMMENT '(申请时间)',
  `opinion_of_approval` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(主任审批意见)',
  `result_of_approval` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(主任审批结果)',
  `approval_of_time` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(主任审批时间)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `audit_opinion_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质管理员审核意见)',
  `audit_opinion_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术负责人审核意见)',
  `audit_result_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质管理员审核结果)',
  `audit_result_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术负责人审核结果)',
  `audit_time_of_primary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质管理员审核时间)',
  `audit_time_of_secondary` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术负责人审核时间)',
  `batch_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(批号)',
  `commit_status` int(11) NULL DEFAULT NULL COMMENT '(提交状态)',
  `approver_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(主任id)',
  `fixed_result` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(定值结果)',
  `manufacturer_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(制造商)',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(编号)',
  `processing_time` datetime(6) NULL DEFAULT NULL COMMENT '(处理时间)',
  `purchase_time` datetime(6) NULL DEFAULT NULL COMMENT '(购置时间)',
  `quantity` int(11) NULL DEFAULT NULL COMMENT '(数量)',
  `reason_for_application` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(申请原因)',
  `reference_material_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质id)',
  `primary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质管理员ID)',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `specification` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(规格)',
  `secondary_auditor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(技术负责人id)',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `applicant_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `reference_material_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准物质停用/报废销毁/恢复/降级使用审批表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of standard_material_approval_form
-- ----------------------------

-- ----------------------------
-- Table structure for standard_reserve_solution
-- ----------------------------
DROP TABLE IF EXISTS `standard_reserve_solution`;
CREATE TABLE `standard_reserve_solution`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `configuration_concentration` double(10, 2) NULL DEFAULT NULL COMMENT '(配置浓度(mg/mL))',
  `configuration_date` datetime(6) NULL DEFAULT NULL COMMENT '(配置日期)',
  `constant_volume` double(10, 2) NULL DEFAULT NULL COMMENT '(定容体积（mL）)',
  `dispenser_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(配制人ID)',
  `reference_material_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质ID)',
  `reference_material_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准物质编号)',
  `reference_material_scale` double(10, 2) NULL DEFAULT NULL COMMENT '(标准物质称取量)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `solution_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(溶液名称)',
  `solution_numbering` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(溶液编号)',
  `use_of_solvent` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(使用溶剂)',
  `user_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(使用人ID)',
  `validity_period` datetime(6) NULL DEFAULT NULL COMMENT '(有效期限)',
  `status` int(5) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准储备溶液配制及使用记录表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of standard_reserve_solution
-- ----------------------------

-- ----------------------------
-- Table structure for standard_solution_curve
-- ----------------------------
DROP TABLE IF EXISTS `standard_solution_curve`;
CREATE TABLE `standard_solution_curve`  (
  `dispenser_id` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(配制人ID)',
  `serialn_number` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(序号)',
  `solution_name_` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(溶液名称)',
  `solution_concentration` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准储备溶液浓度)',
  `concentration_numbering` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(标准储备溶液浓度编号)',
  `step_solution_concentration` varchar(0) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(逐级溶液浓度)',
  `create_time` datetime(0) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(0) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `configuration_date` datetime(0) NULL DEFAULT NULL COMMENT '(工作曲线溶液配置日期)',
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reference_material_id` int(11) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(标准工作曲线溶液配置记录表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of standard_solution_curve
-- ----------------------------

-- ----------------------------
-- Table structure for storage_registration_form
-- ----------------------------
DROP TABLE IF EXISTS `storage_registration_form`;
CREATE TABLE `storage_registration_form`  (
  `date_of_arrival` datetime(6) NULL DEFAULT NULL COMMENT '(入库日期)',
  `depositor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(入库人)',
  `quantity` int(11) NULL DEFAULT NULL COMMENT '(数量)',
  `reagent_consumable_id` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材ID)',
  `reagent_consumable_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材编号)',
  `reagent_consumable_type` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(试剂耗材类型)',
  `remarks` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(备注)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `storage_life` datetime(6) NULL DEFAULT NULL COMMENT '(存储期限)',
  `storage_registration_form_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `warehousing_batch_list_id` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lattice_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`storage_registration_form_id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(试剂耗材入库登记表)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of storage_registration_form
-- ----------------------------
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.697000', '2023-04-21 09:42:34.697000', '1', '1', NULL, '0528542639ACFE3ABDD28D2774360D1D', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 3, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, 'rtrdf', '2023-04-21 10:14:32.138000', '2023-04-21 10:14:32.138000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '0B98A1E3EB59C5A175DF5A2421283B56', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 5, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '2023-04-06 09:47:34.128000', '2023-04-06 09:47:34.128000', '1', '1', NULL, '0D97B3B61D225A6D13DBD2A57B1746DD', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.759000', '2023-04-21 09:42:34.759000', '1', '1', NULL, '0E7D50FAA7EF0F003322AA9CB1810657', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.612000', '2023-04-21 09:42:34.612000', '1', '1', NULL, '0F111609BD2BDEE96859E4A666CFFCF8', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.668000', '2023-04-21 09:42:34.668000', '1', '1', NULL, '10BD4B70252DB25EA04F5D55C7D47A1E', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.824000', '2023-04-21 09:42:34.824000', '1', '1', NULL, '122F72B0F5C63D8F580244E04577B78B', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.529000', '2023-04-21 09:42:34.529000', '1', '1', NULL, '154A443B91CCC31997995B2B72BE963B', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 45, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '45', '2023-04-21 14:59:56.870000', '2023-04-21 14:59:56.870000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '1608F2EB77F51D9BC81172FEE5565082', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 23, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '3', '2023-04-21 17:36:19.977000', '2023-04-21 17:36:19.977000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '1D2AB97F6697EF4127A5504E081E3B16', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.793000', '2023-04-21 09:42:34.793000', '1', '1', NULL, '2CACAA7352F1E2633F1B3B113E9487AF', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.351000', '2023-04-21 09:15:03.351000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '30D17194C580DB7D2EFFE82D8D6C2F84', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 320, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, 'ewd', '2023-04-21 10:14:32.186000', '2023-04-21 10:14:32.186000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '3136717DF73230C3A2ABE699A38AD6BF', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, '签收入库测试1', '2023-04-18 15:19:44.615000', '2023-04-18 15:19:44.615000', '1', '1', NULL, '346485D3F4D3A68D56F66B629AD5EAA0', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '2023-04-06 09:54:48.850000', '2023-04-06 09:54:48.850000', '1', '1', NULL, '3BC39DEBBAAC5E1DEEB71645E46E82FB', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '2023-04-06 14:43:42.180000', '2023-04-06 14:43:42.180000', '1', '1', NULL, '3D6C7DA89A143E36F11B14716DBEC916', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '1', '2023-04-21 15:13:24.022000', '2023-04-21 15:13:24.022000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, '445D7345B7EE62B432277D6E78E7DBCE', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:18:37.476000', '2023-04-20 17:18:37.476000', '1', '1', NULL, '47696FDC77B71F6962EBEACE5F23BE3B', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 5, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '5', '2023-04-21 17:36:19.998000', '2023-04-21 17:36:19.998000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '4922BD8547DC599797BD464E604D9375', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '2023-04-06 14:46:15.561000', '2023-04-06 14:46:15.561000', '1', '1', NULL, '4A8AFDC1F2F45D6338B99FFC08EC1593', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.416000', '2023-04-21 09:42:34.416000', '1', '1', NULL, '53E6BDB57FF4799A427338E420A6E6B5', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:03:02.261000', '2023-04-20 17:03:02.261000', '1', '1', NULL, '54E7C093C17BD81552293BBAFAE75FEC', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 45, '56BC02CC3C58F537A8289D142297A381', NULL, NULL, '54', '2023-04-21 15:12:16.285000', '2023-04-21 15:12:16.285000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '56B218A7ACDAF29CD9A61512A768DB64', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 50, '942B1DF7A794395171D3175270A46464', NULL, NULL, '签收入库测试2', '2023-04-18 15:19:44.672000', '2023-04-18 15:19:44.672000', '1', '1', NULL, '5B05E851D2D66C95C34B7204325D78BB', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:18:37.402000', '2023-04-20 17:18:37.402000', '1', '1', NULL, '6090741BA19E25E446AAF66AE1823FF8', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:26:52.061000', '2023-04-20 17:26:52.061000', '1', '1', NULL, '60F163ACECEF48F93437233BD6E4B446', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.390000', '2023-04-21 09:15:03.390000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '61C7B0652CFEBE807AD5AA8497892CC9', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.461000', '2023-04-21 09:15:03.461000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '6245CE1CE0A31A26B163CE79ED120269', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 5, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '554', '2023-04-21 17:36:20.006000', '2023-04-21 17:36:20.006000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '724D5C8A99D0FA8C145DFD63FFAC8B49', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '2023-04-06 14:45:40.353000', '2023-04-06 14:45:40.353000', '1', '1', NULL, '734B7F7F701E20E8F5F50458059A05B1', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.583000', '2023-04-21 09:42:34.583000', '1', '1', NULL, '7AE6C69A71CE09E7C5B365BA66AF3B0B', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '1', '2023-04-21 16:15:35.068000', '2023-04-21 16:15:35.068000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, '803577F81910AA7D140C5188F609D4C1', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:26:52.111000', '2023-04-20 17:26:52.111000', '1', '1', NULL, '818DB160D782544520AB4F9D5DC234B0', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.467000', '2023-04-21 09:42:34.467000', '1', '1', NULL, '83B57D1B304C79092B5EC90DBA40CA8D', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 6, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '23', '2023-04-21 17:36:19.954000', '2023-04-21 17:36:19.954000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '840773AFD07AF191A3BCBCD31A44E132', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 5, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '2023-04-06 09:59:58.109000', '2023-04-06 09:59:58.109000', '1', '1', NULL, '88C93586782BD982869ECF95A193B0E1', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 55, '56BC02CC3C58F537A8289D142297A381', NULL, NULL, '1', '2023-04-21 17:17:23.748000', '2023-04-21 17:17:23.748000', '1', '1', NULL, '9209E0DAA5B3CB2FCF168E30109CC803', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '2023-04-06 09:56:59.426000', '2023-04-06 09:56:59.426000', '1', '1', NULL, '966CED58C26020D982E70DFCFC3DD890', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '1', '2023-04-21 15:22:15.614000', '2023-04-21 15:22:15.614000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, '9C7C3E177C7A1B14CE9E3061C46E88E8', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.638000', '2023-04-21 09:42:34.638000', '1', '1', NULL, '9DE3DD0EC77E15B12A9898302D7BB956', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 4, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '34', '2023-04-21 17:36:19.985000', '2023-04-21 17:36:19.985000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, '9FC66A893475C0441D9CB852F1F48EF9', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.498000', '2023-04-21 09:42:34.498000', '1', '1', NULL, 'AA86E137B575D19E108251C731AAA039', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '2023-04-06 10:24:38.678000', '2023-04-06 10:24:38.678000', '1', '1', NULL, 'B6358461B20F27E81524422D0A9D024B', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.312000', '2023-04-21 09:15:03.312000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'B6A5DCBEBE5EF28518F36D4547CEB5A7', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.496000', '2023-04-21 09:15:03.496000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'B8736AC7E41C7BCFC06EC7D3E24962AA', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '2023-04-06 09:58:15.716000', '2023-04-06 09:58:15.716000', '1', '1', NULL, 'B93A3DF7C6DD1B29A946FD682C5390A9', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 3, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '87', '2023-04-21 17:36:19.920000', '2023-04-21 17:36:19.920000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'B9CB105D9B794ED764FAB3EB34B47593', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.557000', '2023-04-21 09:42:34.557000', '1', '1', NULL, 'C160B5CE18D10179353CFD429E063D37', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:26:52.083000', '2023-04-20 17:26:52.083000', '1', '1', NULL, 'C173C6A2118F0599E89315AF44E4C8FB', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '942B1DF7A794395171D3175270A46464', NULL, NULL, NULL, '2023-04-06 09:57:37.714000', '2023-04-06 09:57:37.714000', '1', '1', NULL, 'C3C3F8D0B3AB960735CA4BD233F0FB46', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '1', '2023-04-21 15:20:30.074000', '2023-04-21 15:20:30.074000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, 'C75274A77E733B0E4992F7691D1B6000', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.238000', '2023-04-21 09:15:03.238000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'CBF4C838D136D43FE54511700AFACEAB', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:15:03.425000', '2023-04-21 09:15:03.425000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'CFF8F77E8467C92DD7FA5D3D5412657C', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'EC9357ED2463BB14C6EFE231436C218D', NULL, NULL, NULL, '2023-04-06 14:23:58.941000', '2023-04-06 14:23:58.941000', '1', '1', NULL, 'DB303AD7C1CBD80031EF6FEF1A9F523A', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 40, '233ace392b1a111a5a4b91191cb24811', NULL, NULL, '签收入库测试3', '2023-04-18 15:19:44.843000', '2023-04-18 15:19:44.843000', '1', '1', NULL, 'E5E286CBCCED35CED0ED516157DD16DC', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '23', '2023-04-21 17:36:19.968000', '2023-04-21 17:36:19.968000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'EF9F997C8988E7CE444EB69EEE644E64', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-20 17:26:52.020000', '2023-04-20 17:26:52.020000', '1', '1', NULL, 'F0AB3552B37F9F1C1A6526D52B9D5E51', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 10, 'E394DF6CB798A925D4C79F51544E1A73', NULL, NULL, '1', '2023-04-21 09:42:34.726000', '2023-04-21 09:42:34.726000', '1', '1', NULL, 'F16CD5F28B72079369BE7110D2F9F0BA', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 55, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '无', '2023-04-21 15:10:58.737000', '2023-04-21 15:10:58.737000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'F289098D9B0F59B8C74C01FC9353A706', NULL, NULL);
INSERT INTO `storage_registration_form` VALUES (NULL, NULL, 4, '4DC0DFAD80856851F5484282EAFC54ED', NULL, NULL, '4', '2023-04-21 17:36:19.945000', '2023-04-21 17:36:19.945000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 'FD0CF9F9C5882B9996753682F5F98172', NULL, NULL);

-- ----------------------------
-- Table structure for storage_room_form
-- ----------------------------
DROP TABLE IF EXISTS `storage_room_form`;
CREATE TABLE `storage_room_form`  (
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `picture` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `floor` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `room_location` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of storage_room_form
-- ----------------------------
INSERT INTO `storage_room_form` VALUES ('1', NULL, NULL, '1', NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for supplier_information
-- ----------------------------
DROP TABLE IF EXISTS `supplier_information`;
CREATE TABLE `supplier_information`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `acceptable_condition` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(合格状态)',
  `contact_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(联系人电话)',
  `contact_person_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(联系人名称)',
  `name_of_supplier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应人姓名)',
  `photograph_of_supplier` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应人照片)路径',
  `qualification_document` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(资质文件)路径',
  `scope_of_supply` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应范围)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `supplier_coding` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商编码)',
  `supplier_id_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应人身份证号)',
  `supplier_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商名称)',
  `supplier_telephone` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应人电话)',
  `supplier_business_license` tinyint(1) NULL DEFAULT NULL COMMENT '(供应商营业执照)',
  `supplier_passes_quality_assurance_system` tinyint(1) NULL DEFAULT NULL COMMENT '(供应商通过质量保证体系)',
  `supplier_product_certification` tinyint(1) NULL DEFAULT NULL COMMENT '(供应商产品认证)',
  `check_and_calibrate_efficiency_of_supplies` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(对供应品检验校准效率)',
  `overall_supplier_service_satisfaction` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(对供应商总体服务是否满意)',
  `supplier_attitude` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商态度)',
  `supplier_equipment_and_facilities` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商设备与设施)',
  `supplier_technology_and_management_capability` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商技术与管理能力)',
  `whether_the_supplier_delivers_on_time` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商交货是否及时)',
  `number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '(服务商/供应商信息)' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of supplier_information
-- ----------------------------
INSERT INTO `supplier_information` VALUES ('1', '合格', '19983828405', '王五', '张麻子', '111', '222', '标准物质-试剂耗材', '2023-03-20 14:22:54.922000', '2023-03-20 14:24:21.355000', '1', '1', '1155222', '522128111111111111', 'xxx供应商2', '13355556666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('12F7D1F5F83481503F5EAC204BFE9FB7', '不合格', '1231', '123123', '231', NULL, NULL, '3123', '2023-04-17 14:54:38.370000', '2023-04-17 14:54:38.370000', '1', '1', '2312312', '1231', '231231', '23123123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('2DA79E5EA9BD6AC13D6BED4258B976EA', '2', '电话', NULL, '姓名', NULL, NULL, '范围', '2023-04-17 14:09:39.445000', '2023-04-17 14:09:39.445000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '编码', '供应人身份证', '供应商名称1', '供应人电', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('4DE1482F1E1C25E76EEAA306E3161C9D', '合格', '联系人电话2', '联系人姓名2', '供应人姓名2', NULL, NULL, '供应范围2', '2023-04-17 16:44:38.852000', '2023-04-17 16:44:38.852000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '供应商编码2', '供应人身份证2', '供应商名称2', '供应人电话2', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('72E82118AA58CFE3EB4D400C253F512E', '合格', '19983828405', '张三', '李四', '111', '222', '标准物质-试剂耗材', '2023-03-20 14:21:51.987000', '2023-03-20 14:21:51.987000', '1', '1', '1155222', '522128111111111111', 'xxx供应商', '13355556666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('80FA0C44E3A2846331CAD918A2D90F2D', '合格', '联系人电话', '联系人姓名', '供应人姓名', NULL, NULL, '供应范围', '2023-04-17 15:26:24.437000', '2023-04-17 15:26:24.437000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '供应商编码', '供应人身份证', '供应商名称', '供应人电话', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('92E358EC60031EF81C131A93355592E1', '1', '312', NULL, NULL, NULL, NULL, '12312', '2023-04-17 14:04:56.957000', '2023-04-17 14:04:56.957000', '1', '1', '123', '1231', '213', '23123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `supplier_information` VALUES ('EA088AA61983C2C8C60954D2D8E4B153', '合格', '23123', '23123', '12312', NULL, NULL, '1231', '2023-04-17 14:21:31.333000', '2023-04-17 14:21:31.333000', 'BC1A096180973C5EA652C9787F5A155A', 'BC1A096180973C5EA652C9787F5A155A', '123', '23123', '123', '31231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

-- ----------------------------
-- Table structure for warehousing_batch_list
-- ----------------------------
DROP TABLE IF EXISTS `warehousing_batch_list`;
CREATE TABLE `warehousing_batch_list`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `batch` int(6) NULL DEFAULT NULL COMMENT '(批次)',
  `batch_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(批号)',
  `date_of_production` datetime(6) NULL DEFAULT NULL COMMENT '(生产日期)',
  `date_of_receipt` datetime(6) NULL DEFAULT NULL COMMENT '签收日期',
  `expiration_date` datetime(6) NULL DEFAULT NULL COMMENT '(有效日期)',
  `quantity` int(11) NULL DEFAULT NULL COMMENT '(数量)',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `supplier_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '(供应商ID)',
  `warning_value` int(11) NULL DEFAULT NULL COMMENT '(预警值)',
  `depositor_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '签收人\r\n',
  `warehousing_content_id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `lattice_Id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `limit_date` varbinary(255) NULL DEFAULT NULL,
  `remark` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '签收批次明细' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of warehousing_batch_list
-- ----------------------------
INSERT INTO `warehousing_batch_list` VALUES ('027459AA39DD44653EEFA84859B6E840', 1, NULL, '2023-04-17 00:00:00.000000', '2023-04-21 10:14:32.115000', '2023-04-26 00:00:00.000000', 3, '2023-04-21 10:14:32.135000', '2023-04-21 10:14:32.135000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 65, '6c847974320c7cb184228d53eea19114', '3CD861402007799BB4245532C69AA62C', '1', 0x32E5B9B4, 'rtrdf');
INSERT INTO `warehousing_batch_list` VALUES ('192E0984CEECE2EF71C2DCF394934B49', 6, NULL, '2023-04-24 00:00:00.000000', '2023-04-21 17:36:19.940000', '2023-04-25 00:00:00.000000', 4, '2023-04-21 17:36:19.944000', '2023-04-21 17:36:19.944000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 4, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x34, '4');
INSERT INTO `warehousing_batch_list` VALUES ('1AB0720E10222631460DC242368113C4', 2, NULL, '2023-04-25 00:00:00.000000', '2023-04-21 15:20:29.958000', '2023-04-18 00:00:00.000000', 10, '2023-04-21 15:20:30.070000', '2023-04-21 15:20:30.070000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, 1, 'C27B8F582693B93596C21C1586A0845A', 'A37037DD44C963298026E64AF680FC33', '1', 0x32E5B9B4, '1');
INSERT INTO `warehousing_batch_list` VALUES ('1E6DA9AD2391D6F0A8D3F3F99DD57608', 11, NULL, '2023-04-24 00:00:00.000000', '2023-04-21 17:36:19.994000', '2023-04-19 00:00:00.000000', 5, '2023-04-21 17:36:19.997000', '2023-04-21 17:36:19.997000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 54, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x3534, '5');
INSERT INTO `warehousing_batch_list` VALUES ('2E5EAFFD2B29E90B7F7DB7B9F4A0DA5E', 2, NULL, '2023-04-18 00:00:00.000000', '2023-04-21 17:17:23.729000', '2023-04-19 00:00:00.000000', 55, '2023-04-21 17:17:23.745000', '2023-04-21 17:17:23.745000', '1', '1', NULL, 1, '1', 'F3F5C573564D3BC27FB0377834C6FA30', '1', 0x31, '1');
INSERT INTO `warehousing_batch_list` VALUES ('2ED84B5EABF76FD340E114101124E653', 12, NULL, '2023-04-24 00:00:00.000000', '2023-04-21 17:36:20.002000', '2023-04-26 00:00:00.000000', 5, '2023-04-21 17:36:20.005000', '2023-04-21 17:36:20.005000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 55, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x3435, '554');
INSERT INTO `warehousing_batch_list` VALUES ('3B7EE7DC744019E7A93AF5155BBD9765', 7, NULL, '2023-05-16 00:00:00.000000', '2023-04-21 17:36:19.949000', '2023-06-10 00:00:00.000000', 6, '2023-04-21 17:36:19.953000', '2023-04-21 17:36:19.953000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 23, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x3332, '23');
INSERT INTO `warehousing_batch_list` VALUES ('3FBFA93B8765983CC12BF18422B0DC72', 1, NULL, '2023-03-28 00:00:00.000000', '2023-04-21 15:13:24.018000', '2023-04-12 00:00:00.000000', 10, '2023-04-21 15:13:24.022000', '2023-04-21 15:13:24.022000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, 1, 'C27B8F582693B93596C21C1586A0845A', 'A37037DD44C963298026E64AF680FC33', '1', 0x32, '1');
INSERT INTO `warehousing_batch_list` VALUES ('566D77F006841DEBC90005F471060619', 4, NULL, '2023-04-18 00:00:00.000000', '2023-04-21 16:15:35.043000', '2023-04-19 00:00:00.000000', 10, '2023-04-21 16:15:35.065000', '2023-04-21 16:15:35.065000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, 1, 'C27B8F582693B93596C21C1586A0845A', 'A37037DD44C963298026E64AF680FC33', '1', 0x32, '1');
INSERT INTO `warehousing_batch_list` VALUES ('5F5685B75A55F911A2E576458A8A54C8', 10, NULL, '2023-04-26 00:00:00.000000', '2023-04-21 17:36:19.980000', '2023-04-25 00:00:00.000000', 4, '2023-04-21 17:36:19.984000', '2023-04-21 17:36:19.984000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 34, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x3334, '34');
INSERT INTO `warehousing_batch_list` VALUES ('723642452898F03468071CD2C943D1D1', 1, NULL, '2023-04-17 00:00:00.000000', '2023-04-21 15:12:16.281000', '2023-04-25 00:00:00.000000', 45, '2023-04-21 15:12:16.284000', '2023-04-21 15:12:16.284000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 45, '6c847974320c7cb184228d53eea19114', 'F3F5C573564D3BC27FB0377834C6FA30', '1', 0x3435, '54');
INSERT INTO `warehousing_batch_list` VALUES ('7337971B94FB3EB7814675D47E404BCB', 9, NULL, '2023-04-24 00:00:00.000000', '2023-04-21 17:36:19.972000', '2023-04-24 00:00:00.000000', 23, '2023-04-21 17:36:19.976000', '2023-04-21 17:36:19.976000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 3, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x33, '3');
INSERT INTO `warehousing_batch_list` VALUES ('79C63B2402C73D978DACE6A1AA02517C', 1, NULL, '2023-04-10 00:00:00.000000', '2023-04-21 14:59:56.855000', '2023-04-27 00:00:00.000000', 45, '2023-04-21 14:59:56.867000', '2023-04-21 14:59:56.867000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 54, '6c847974320c7cb184228d53eea19114', 'B9980A6497AD4DFEF4A021E39DF24A58', '54', 0x36E5B9B4, '45');
INSERT INTO `warehousing_batch_list` VALUES ('945BE1C7AFC8B41C8DC01ED394B9190B', 5, NULL, '2023-04-24 00:00:00.000000', '2023-04-21 17:36:19.900000', '2023-04-26 00:00:00.000000', 3, '2023-04-21 17:36:19.917000', '2023-04-21 17:36:19.917000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 8, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x3837, '87');
INSERT INTO `warehousing_batch_list` VALUES ('BC0D9C8F69D6DE25E75D3F4DB4A222E7', 2, NULL, '2023-04-17 00:00:00.000000', '2023-04-21 10:14:32.182000', '2023-04-25 00:00:00.000000', 320, '2023-04-21 10:14:32.186000', '2023-04-21 10:14:32.186000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 323, '6c847974320c7cb184228d53eea19114', '3CD861402007799BB4245532C69AA62C', '1', 0x32E5B9B4, 'ewd');
INSERT INTO `warehousing_batch_list` VALUES ('CCE4442C2636050D22FE77E12C99BB99', 8, NULL, '2023-04-25 00:00:00.000000', '2023-04-21 17:36:19.963000', '2023-04-24 00:00:00.000000', 10, '2023-04-21 17:36:19.967000', '2023-04-21 17:36:19.967000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 23, '6c847974320c7cb184228d53eea19114', 'A37037DD44C963298026E64AF680FC33', '1', 0x3233, '23');
INSERT INTO `warehousing_batch_list` VALUES ('E0F934ED9DC12A17A7678C2E8B0B430B', 2, NULL, '2023-04-16 00:00:00.000000', '2023-04-21 15:10:58.733000', '2023-04-18 00:00:00.000000', 55, '2023-04-21 15:10:58.737000', '2023-04-21 15:10:58.737000', '6c847974320c7cb184228d53eea19114', '6c847974320c7cb184228d53eea19114', NULL, 78, '6c847974320c7cb184228d53eea19114', 'B9980A6497AD4DFEF4A021E39DF24A58', '1', 0x37E5B9B4, '无');
INSERT INTO `warehousing_batch_list` VALUES ('E96F537EA167A880A3EFA6C168636802', 3, NULL, '2023-04-25 00:00:00.000000', '2023-04-21 15:22:15.527000', '2023-04-18 00:00:00.000000', 10, '2023-04-21 15:22:15.610000', '2023-04-21 15:22:15.610000', 'C27B8F582693B93596C21C1586A0845A', 'C27B8F582693B93596C21C1586A0845A', NULL, 1, 'C27B8F582693B93596C21C1586A0845A', 'A37037DD44C963298026E64AF680FC33', '1', 0x32E5B9B4, '1');

-- ----------------------------
-- Table structure for warehousing_content
-- ----------------------------
DROP TABLE IF EXISTS `warehousing_content`;
CREATE TABLE `warehousing_content`  (
  `id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `reagent_consumable_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `total_quantity` int(6) NULL DEFAULT NULL,
  `warehousing_quantity` int(6) NULL DEFAULT NULL,
  `catalogue_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `create_time` datetime(6) NULL DEFAULT NULL,
  `update_time` datetime(6) NULL DEFAULT NULL,
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `warehousing_record_form_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `acceptance_record_form_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `supplier_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of warehousing_content
-- ----------------------------
INSERT INTO `warehousing_content` VALUES ('3CD861402007799BB4245532C69AA62C', 'E394DF6CB798A925D4C79F51544E1A73', 323, 323, NULL, '2023-04-19 16:36:41.594000', '2023-04-21 10:14:32.185000', '1', '6c847974320c7cb184228d53eea19114', '682A4EEF4BCDD120368789591D7F4799', NULL, '4DE1482F1E1C25E76EEAA306E3161C9D');
INSERT INTO `warehousing_content` VALUES ('A37037DD44C963298026E64AF680FC33', '4DC0DFAD80856851F5484282EAFC54ED', 100, 100, NULL, '2023-04-21 15:00:05.644000', '2023-04-21 17:36:20.024000', '1', '6c847974320c7cb184228d53eea19114', '84350AE350BBDC3089F9298BA5777357', 'E1081B769B37A22B9EF17854042F62C5', '80FA0C44E3A2846331CAD918A2D90F2D');
INSERT INTO `warehousing_content` VALUES ('B9980A6497AD4DFEF4A021E39DF24A58', '4DC0DFAD80856851F5484282EAFC54ED', 100, 100, NULL, '2023-04-19 16:36:41.596000', '2023-04-21 15:10:58.752000', '1', '6c847974320c7cb184228d53eea19114', '682A4EEF4BCDD120368789591D7F4799', '3CA16BCA35AAFA3799A82425A66B3F7B', '2DA79E5EA9BD6AC13D6BED4258B976EA');
INSERT INTO `warehousing_content` VALUES ('F3F5C573564D3BC27FB0377834C6FA30', '56BC02CC3C58F537A8289D142297A381', 100, 100, NULL, '2023-04-19 16:36:41.595000', '2023-04-21 17:17:23.972000', '1', '1', '682A4EEF4BCDD120368789591D7F4799', '90A7E86DE961D322D620DD0096E37461', '80FA0C44E3A2846331CAD918A2D90F2D');

-- ----------------------------
-- Table structure for warehousing_record_form
-- ----------------------------
DROP TABLE IF EXISTS `warehousing_record_form`;
CREATE TABLE `warehousing_record_form`  (
  `id` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `purchase_list_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '采购清单ID',
  `status` int(6) NULL DEFAULT NULL COMMENT '状态',
  `create_time` datetime(6) NULL DEFAULT NULL COMMENT '--创建时间',
  `update_time` datetime(6) NULL DEFAULT NULL COMMENT '--修改时间',
  `create_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--创建人',
  `update_by` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '--修改人',
  `purchase_number` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '采购编号',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '签收记录表' ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of warehousing_record_form
-- ----------------------------
INSERT INTO `warehousing_record_form` VALUES ('682A4EEF4BCDD120368789591D7F4799', '66724A3976617987C9B78167EABBC515', 1, '2023-04-19 16:36:41.589000', '2023-04-21 17:17:23.973000', '1', '1', '2023-04-19入库任务');
INSERT INTO `warehousing_record_form` VALUES ('84350AE350BBDC3089F9298BA5777357', 'BAEC3FB4FA2294BF4C4BFD1A8DCCE01A', 2, '2023-04-21 15:00:05.643000', '2023-04-21 17:36:20.025000', '1', '6c847974320c7cb184228d53eea19114', '2023-04-21入库任务');

-- ----------------------------
-- Procedure structure for pro_code_generator
-- ----------------------------
DROP PROCEDURE IF EXISTS `pro_code_generator`;
delimiter ;;
CREATE PROCEDURE `pro_code_generator`()
begin
	SELECT COUNT(*) INTO @menucount FROM sys_menu WHERE menu="reagent";
	-- SELECT @menucount;
	set @parentId = replace(UUID(),"-","");
	SELECT MAX(sort) into @maxsort FROM sys_menu WHERE parent_id = "root";
	if ((SELECT @menucount)>0) then
		SELECT menu_id INTO @parentId FROM sys_menu WHERE menu="reagent";
	else
		INSERT into `sys_menu` ( `parent_id`, menu_id, `path`, menu,  `permission_id`, `type`, `icon`, `sort`, `name`)
    		values ( 'root', @parentId, '/reagent', 'reagent', '', '0', 'icon-bangzhushouji', @maxsort+10,'reagent管理');
	end if;
end
;;
delimiter ;

SET FOREIGN_KEY_CHECKS = 1;
